unit Commun;

interface

{$WARN SYMBOL_PLATFORM OFF}
uses Windows, SysUtils, ShellAPI, Classes, ShlObj;

const PARAM_SERVICE_TEST='/t';
      PARAM_SERVICE_INSTALL='/i';
      PARAM_SERVICE_UNINSTALL='/u';
      PARAM_SERVICE_CONTEXT='/c';
      PARAM_PROGRAMMATION='/s';
      PARAM_SERVICE_FOLDER='/folder';
      PARAM_SERVICE_SCRIPT='/script';
      PARAM_SERVICE_USER='/user';
      PARAM_SERVICE_PASSWORD='/password';
      NOMAPPLI='UpdateSoft';
      EXECUTABLE=NOMAPPLI+'.exe';
      APP_PUBLISHER='SOFT-MICRO';
      SERVICE_CONFIGURATION_KEY='\SYSTEM\CurrentControlSet\Services\'+NOMAPPLI;
      SERVICE_APPLICATION_KEY='\Software\'+NOMAPPLI;

type TVersion= record
       Chaine: string;
       P: array[1..4] of integer;
     end;
    TEXEVersionData = record
       CompanyName,
       FileDescription,
       FileVersion,
       InternalName,
       LegalCopyright,
       LegalTrademarks,
       OriginalFileName,
       ProductName,
       ProductVersion,
       Comments,
       PrivateBuild,
       SpecialBuild: string;
   end;

function CopierFichier(const srcFile, destFile : string) : boolean;
function RenommerFichier(const srcFile, destFile : string) : boolean;
function EffacerFichier(FileName: TFileName): bool;
function RenvoiDossierTemp(NewSubFolder: bool=false): string;
function TailleFichier(Fichier: TFileName): cardinal;
procedure EffacerExecutable(const AutresFichiers: array of string ; const FermerApplication: bool=true);
function GetVersion(sFileName: string='' ; ProductVersion: bool=false): string;
function CompareVersion(LaVersion: TVersion; const BonneVersion: string=''): shortint; overload;
function CompareVersion(LaVersion, BonneVersion: string): shortint; overload;
procedure EcrireLog(Fichier: TFileName ; Valeur: string ; RAZ: bool=false);
function LanceAppli(Commande, Repertoire:string):cardinal;
function GetEXEVersionData(const FileName: string ; out VersionData: TEXEVersionData): bool;
procedure EffacerDossier(Source: String);

implementation

procedure EffacerDossier(Source: String);
var
  lpFileOp:TSHFILEOPSTRUCTA;
  TabFrom:array of Char;
  j: integer;
begin
     Setlength(TabFrom,length(Source)+2);
     for j:=1 to length(Source) do TabFrom[j-1]:=Source[j];
     TabFrom[length(TabFrom)-2]:=#0;
     TabFrom[length(TabFrom)-1]:=#0;
     lpFileOp.Wnd:=GetActiveWindow;
     lpFileOp.wFunc:=FO_DELETE;
     lpFileOp.pFrom:=PAnsiChar(TabFrom);
     lpFileOp.pTo:='';
     lpFileOp.fFlags:=FOF_NOCONFIRMATION or FOF_SILENT or FOF_NOERRORUI;
     SHFileOperation(lpFileOp);
end;

function GetEXEVersionData(const FileName: string ; out VersionData: TEXEVersionData): bool;
type PLandCodepage = ^TLandCodepage;
     TLandCodepage = record
       wLanguage,
       wCodePage: word;
     end;
function MakeLangId(LangId, SubLangId: Byte): Word; begin Result := (SubLangId shl 10) or LangId; end;     
var dummy, len, lentranslation: cardinal;
    buf, pntr: pointer;
    LandCodePage: pointer;
    lang: string;
    Mode : word;
begin
     result:=false;
     len := GetFileVersionInfoSize(PChar(FileName), dummy);
     if len > 0 then
     begin
          GetMem(buf, len);
          try
             if GetFileVersionInfo(PChar(FileName), dummy, len, buf) and VerQueryValue(buf, '\VarFileInfo\Translation\', LandCodePage, lentranslation) then
             begin
                  Mode:=0;
                  repeat
                        Inc(Mode);
                        lang:='';
                        case Mode of
                        1: if VerQueryValue(buf, '\VarFileInfo\Translation\', LandCodePage, lentranslation) then lang := Format('%.4x%.4x', [PLandCodepage(LandCodePage)^.wLanguage, PLandCodepage(LandCodePage)^.wCodePage]);
                        2: lang:=Format('%.4x04B0', [MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT)]);
                        3: lang:=Format('%.4x04B0', [MAKELANGID(LANG_ENGLISH, SUBLANG_NEUTRAL)]);
                        4: lang:=Format('%.4x04B0', [MAKELANGID(LANG_ENGLISH, SUBLANG_DEFAULT)]);
                        5: lang:=Format('%.4x04B0', [MAKELANGID(LANG_NEUTRAL, SUBLANG_NEUTRAL)]);
                        end;
                        if lang<>'' then
                        begin
                             if VerQueryValue(buf, PChar('\StringFileInfo\' + lang + '\CompanyName'), pntr, len) then begin VersionData.CompanyName := PChar(pntr); result:=true; end;
                             if VerQueryValue(buf, PChar('\StringFileInfo\' + lang + '\FileDescription'), pntr, len) then begin VersionData.FileDescription := PChar(pntr); result:=true; end;
                             if VerQueryValue(buf, PChar('\StringFileInfo\' + lang + '\FileVersion'), pntr, len) then begin VersionData.FileVersion := PChar(pntr); result:=true; end;
                             if VerQueryValue(buf, PChar('\StringFileInfo\' + lang + '\InternalName'), pntr, len) then begin VersionData.InternalName := PChar(pntr); result:=true; end;
                             if VerQueryValue(buf, PChar('\StringFileInfo\' + lang + '\LegalCopyright'), pntr, len) then begin VersionData.LegalCopyright := PChar(pntr); result:=true; end;
                             if VerQueryValue(buf, PChar('\StringFileInfo\' + lang + '\LegalTrademarks'), pntr, len) then begin VersionData.LegalTrademarks := PChar(pntr); result:=true; end;
                             if VerQueryValue(buf, PChar('\StringFileInfo\' + lang + '\OriginalFileName'), pntr, len) then begin VersionData.OriginalFileName := PChar(pntr); result:=true; end;
                             if VerQueryValue(buf, PChar('\StringFileInfo\' + lang + '\ProductName'), pntr, len) then begin VersionData.ProductName := PChar(pntr); result:=true; end;
                             if VerQueryValue(buf, PChar('\StringFileInfo\' + lang + '\ProductVersion'), pntr, len) then begin VersionData.ProductVersion := PChar(pntr); result:=true; end;
                             if VerQueryValue(buf, PChar('\StringFileInfo\' + lang + '\Comments'), pntr, len) then begin VersionData.Comments := PChar(pntr); result:=true; end;
                             if VerQueryValue(buf, PChar('\StringFileInfo\' + lang + '\PrivateBuild'), pntr, len) then begin VersionData.PrivateBuild := PChar(pntr); result:=true; end;
                             if VerQueryValue(buf, PChar('\StringFileInfo\' + lang + '\SpecialBuild'), pntr, len) then begin VersionData.SpecialBuild := PChar(pntr); result:=true; end;
                        end;
                  until result or (Mode=5);
             end;
         finally
            FreeMem(buf);
         end;
    end;
end;

// Renvoie la version de l'excutable
function GetVersion(sFileName: string='' ; ProductVersion: bool=false): string;
var
  VerInfoSize: DWORD;
  VerInfo: Pointer;
  VerValueSize: DWORD;
  VerValue: PVSFixedFileInfo;
  Data: Pointer;
  Dummy: DWORD;
  Langue: string;
begin
     if sFileName='' then sFileName:=ParamStr(0);
     VerInfoSize := GetFileVersionInfoSize(PChar(sFileName), Dummy);
     Result:='';
     if VerInfoSize>0 then
     try
        GetMem(VerInfo, VerInfoSize);
        GetFileVersionInfo(PChar(sFileName), 0, VerInfoSize, VerInfo);
        if not ProductVersion then
        begin
             VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
             with VerValue^ do Result := IntToStr(dwFileVersionMS shr 16)+ '.' + IntToStr(dwFileVersionMS and $FFFF)+ '.' + IntToStr(dwFileVersionLS shr 16)+ '.' + IntToStr(dwFileVersionLS and $FFFF)
        end
        else
        begin
             VerQueryValue(VerInfo, '\VarFileInfo\Translation', Data, VerValueSize);
             if Data <> NIL then
             begin
                  Langue := IntToHex(MakeLong(HiWord(Longint(Data^)), LoWord(Longint(Data^))), 8);
                  VerQueryValue(VerInfo, PChar('\StringFileInfo\'+Langue+'\ProductVersion'), Data, VerValueSize);
                  if Data<>nil then result:=string(PChar(Data));
             end;
        end;
        if Assigned(VerInfo) then FreeMem(VerInfo, VerInfoSize);
     except
     end;
end;

// Renvoie la taille du fichier dont le nom est donn en argument
function TailleFichier(Fichier: TFileName): cardinal;
var SearchRec:TSearchRec;
    Resultat:integer;
begin
     Result:=0;
     if FileExists(Fichier) then
     try
        resultat:=FindFirst(fichier, FaAnyFile, SearchRec);
        if Resultat=0 then result:=Cardinal(UInt64(SearchRec.FindData.nFileSizeLow)+(UInt64(SearchRec.FindData.nFileSizeHigh)*UInt64(1 shl 32)));
        FindClose(SearchRec);
     except
     end;
end;

function EffacerFichier(FileName: TFileName): bool;
var
  lpFileOp:TSHFILEOPSTRUCTA;
  TabFrom:array of Char;
  j, k: integer;
begin
     if FileExists(FileName) then
     begin
          DeleteFile(FileName);
          if FileExists(FileName) then
          begin
               Setlength(TabFrom,0);
               k:=length(TabFrom);
               Setlength(TabFrom,length(TabFrom)+length(FileName)+1);
               for j:=1 to length(FileName) do TabFrom[k+j-1]:=FileName[j];
               TabFrom[length(TabFrom)-1]:=#0;
               Setlength(TabFrom,length(TabFrom)+1);
               TabFrom[length(TabFrom)-1]:=#0;
               lpFileOp.Wnd:=GetActiveWindow;
               lpFileOp.wFunc:=FO_DELETE;
               lpFileOp.pFrom:=PAnsiChar(TabFrom);
               lpFileOp.pTo:='';
               lpFileOp.fFlags:=FOF_SILENT or FOF_NOCONFIRMATION or FOF_NOERRORUI or FOF_NOCONFIRMMKDIR;
               SHFileOperation(lpFileOp);
               result:=not FileExists(FileName);
          end else result:=true;
     end else result:=true;
end;

function CopierFichier(const srcFile, destFile : string) : boolean;
var shFOS : TShFileOpStruct;
begin
     ZeroMemory(@shFOS, SizeOf(TShFileOpStruct));
     shFOS.Wnd := GetActiveWindow;
     shFOS.wFunc := FO_COPY;
     shFOS.pFrom := PChar(srcFile + #0);
     shFOS.pTo := PChar(destFile + #0);
     shFOS.fFlags := FOF_SILENT or FOF_NOCONFIRMATION or FOF_NOERRORUI or FOF_NOCONFIRMMKDIR;;
     result := SHFileOperation(shFOS) = 0;
end;

function RenommerFichier(const srcFile, destFile : string) : boolean;
var shFOS : TShFileOpStruct;
begin
     ZeroMemory(@shFOS, SizeOf(TShFileOpStruct));
     shFOS.Wnd := GetActiveWindow;
     shFOS.wFunc := FO_RENAME;
     shFOS.pFrom := PChar(srcFile + #0);
     shFOS.pTo := PChar(destFile + #0);
     shFOS.fFlags := FOF_SILENT or FOF_NOCONFIRMATION or FOF_NOERRORUI or FOF_NOCONFIRMMKDIR;;
     result := SHFileOperation(shFOS) = 0;
end;

procedure EffacerExecutable(const AutresFichiers: array of string ; const FermerApplication: bool=true);
function OEM(AsciiString: string): string;
begin
    result:=AsciiString;
    CharToOEM(PChar(AsciiString), PChar(result));
end;
var batchfile: TStringList;
    i: integer;
    batchname: string;
begin
     i:=0;
     repeat
           if i=0 then batchname:=RenvoiDossierTemp+ChangeFileExt(ExtractFileName(ParamStr(0)),'.bat')
           else batchname:=RenvoiDossierTemp+ChangeFileExt(ExtractFileName(ParamStr(0)),' ('+inttostr(i)+').bat');
           Inc(i);
     until not FileExists(batchname);
     FileSetAttr(ParamStr(0), 0);
     batchfile := TStringList.Create;
     with batchfile do
     try
        Add(':Label0');
        Add('del "' + Oem(ParamStr(0)) + '"');
        Add('if exist "' + Oem(ParamStr(0)) + '" goto Label0');
        for i:=0 to length(AutresFichiers)-1 do
         if (AutresFichiers[i]<>'') then
         begin
              EffacerFichier(AutresFichiers[i]);
              if FileExists(AutresFichiers[i]) then
              begin
                   Add(':Label'+inttostr(i+1));
                   Add('del "' + Oem(AutresFichiers[i]) + '"');
                   Add('if exist "' + Oem(AutresFichiers[i]) + '" goto Label'+inttostr(i+1));
              end;
         end;
        Add('rmdir "' + Oem(ExtractFilePath(ParamStr(0))) + '"');
        Add('del "' + Oem(batchname)+'"');
        SaveToFile(batchname);
     finally
        batchfile.Free;
     end;
     ShellExecute(0, 'open', PChar(batchname), nil, PChar(ExtractFilePath(batchname)), SW_HIDE);
     if FermerApplication then Halt;
end;

// Rcupre le nom du dossier temporaire ou,  dfaut, le dossier d'excution
function RenvoiDossierTemp(NewSubFolder: bool=false): string;
var Dossier:array[0..MAX_PATH] of Char;
    NomBase: string;
    i: integer;
begin
     GetTempPath(SizeOf(Dossier), Dossier);
     result:=StrPas(Dossier);
     if result='' then result:=ExtractFilePath(ParamStr(0)) else result:=IncludeTrailingPathDelimiter(StrPas(Dossier));
     if not DirectoryExists(result) then result:=('C:\Windows\Temp\'); // Patch GPO

     if NewSubFolder then
     begin
          NomBase:=result+NOMAPPLI;
          i:=1;
          while DirectoryExists(NomBase) do
          begin
               Inc(i);
               NomBase:=result+NOMAPPLI+inttostr(i);
          end;
          result:=IncludeTrailingPathDelimiter(NomBase);
     end;
end;

// Teste si la validit du format de la donne Version donne en paramtre
function CheckFormatVersion(var Version: TVersion): bool;
var i: integer;
    Chaine: string;
begin
     result:=false;
     Chaine:=Version.Chaine+'.';
     for i:=1 to 4 do Version.P[i]:=0;
     i:=1;
     while (i<=4) and (Chaine<>'') do
     begin
          Version.P[i]:=Strtointdef(Copy(Chaine,1, Pos('.', Chaine)-1), -1);
          if Version.P[i]<0 then exit else Chaine:=Copy(Chaine, Pos('.', Chaine)+1, length(Chaine));
          Inc(i);
     end;
     result:=Chaine='';
end;

procedure EcrireLog(Fichier: TFileName ; Valeur: string ; RAZ: bool=false);
var F: TextFile;
begin
     AssignFile(F, Fichier);
     if RAZ then Rewrite(F) else Append(F);
     Writeln(F, inttostr(Gettickcount)+' '+ Valeur);
     CloseFile(F);
end;

// Compare deux versions et indique (1 : LaVersion est plus ancienne, -1 : LaVersion est plus rcente ; 0 : versions idendiques)
function CompareVersion(LaVersion: TVersion; const BonneVersion: string=''): shortint; overload;
var Actuelle: TVersion;
begin
     Actuelle.Chaine:=BonneVersion;
     CheckFormatVersion(Actuelle);
     if LaVersion.P[1]>Actuelle.P[1] then result:=1
     else
     if (LaVersion.P[1]=Actuelle.P[1]) and (LaVersion.P[2]>Actuelle.P[2]) then result:=1
     else
     if (LaVersion.P[1]=Actuelle.P[1]) and (LaVersion.P[2]=Actuelle.P[2]) and (LaVersion.P[3]>Actuelle.P[3]) then result:=1
     else
     if (LaVersion.P[1]=Actuelle.P[1]) and (LaVersion.P[2]=Actuelle.P[2]) and (LaVersion.P[3]=Actuelle.P[3]) and (LaVersion.P[4]>Actuelle.P[4]) then result:=1
     else
     if (LaVersion.P[1]=Actuelle.P[1]) and (LaVersion.P[2]=Actuelle.P[2]) and (LaVersion.P[3]=Actuelle.P[3]) and (LaVersion.P[4]=Actuelle.P[4]) then result:=0
     else result:=-1;
end;

// Compare deux versions au format chane x.y.z.t
function CompareVersion(LaVersion, BonneVersion: string): shortint; overload;
var VersionProposee: TVersion;
begin
     VersionProposee.Chaine:=LaVersion;
     CheckFormatVersion(VersionProposee);
     result:=CompareVersion(VersionProposee, BonneVersion);
end;

// Lance l'appli et renvoie le hProcess
function LanceAppli(Commande, Repertoire:string):cardinal;
var
   StartInfo : TStartupInfo;
   ProcessInformation : TProcessInformation;
begin
     ZeroMemory(@StartInfo, sizeof(StartInfo));
     with StartInfo do
     begin
          cb:=sizeof(StartInfo);
          dwFlags := STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
     end;
     if CreateProcess(nil,PChar(Commande),nil,nil,true,0,nil,PChar(Repertoire),StartInfo,ProcessInformation) then result:=ProcessInformation.hProcess else result:=0;
end;


end.
