unit Fonctions;

interface

uses Windows, SysUtils, WInInet, Variants, tlhelp32, StrUtils, Math, Classes, WinSvc, Registry, Commun, TaskScheduler, LsaApi, RegExpr, uLkJSON;

type
     TTokenList = array of THandle;
     TMode=(Mode_Normal, Mode_Installation, Mode_Test, Mode_Desinstallation, Mode_Programmation);
     TActionsProcessus= set of (apKill, apToken);
     TDownloadError = record
       Code: integer;
       Message: string;
     end;
     TMode3264 = (Mode_None, Mode32bits, Mode64bits);

const PREFIXE_HTTP='http://';
      PREFIXE_HTTPS='https://';
      STRING_ESR='esr';
      PREFIXE_LOCALMACHINE='.\';
      NOMAPPLI='UpdateSoft';
      ADRESSE_EMAIL='contact@soft-micro.fr';
      URL_SITE=PREFIXE_HTTPS+'updatesoft.soft-micro.fr';
      URLVersion=URL_SITE+'/index.php?getinfos&exe';
      LOG_MAX_LINES=2000;
      DEFAULT_CONNECT_TIMEOUT=3000;
      USER_AGENT='Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:106.0) Gecko/20100101 Firefox/106.0';
      MOZILLA_FIREFOX_HTTP=PREFIXE_HTTPS+'download.mozilla.org/?product=firefox-latest&os=win&lang=fr';
      MOZILLA_FIREFOX_ESR_HTTP=PREFIXE_HTTPS+'download.mozilla.org/?product=firefox-esr-latest&os=win&lang=fr';
      MOZILLA_FIREFOX64_HTTP=PREFIXE_HTTPS+'download.mozilla.org/?product=firefox-latest&os=win64&lang=fr';
      MOZILLA_FIREFOX64_ESR_HTTP=PREFIXE_HTTPS+'download.mozilla.org/?product=firefox-esr-latest&os=win64&lang=fr';
      MOZILLA_THUNDERBIRD_HTTP=PREFIXE_HTTPS+'download.mozilla.org/?product=thunderbird-latest&os=win&lang=fr';
      MOZILLA_THUNDERBIRD64_HTTP=PREFIXE_HTTPS+'download.mozilla.org/?product=thunderbird-latest&os=win64&lang=fr';
      //ADOBE_FLASH_IE=PREFIXE_HTTP+'fpdownload.macromedia.com/pub/flashplayer/latest/help/install_flash_player_ax.exe';
      //ADOBE_FLASH_PLUGIN=PREFIXE_HTTP+'fpdownload.macromedia.com/pub/flashplayer/latest/help/install_flash_player.exe';
      //ADOBE_AIR=PREFIXE_HTTP+'airdownload.adobe.com/air/win/download/latest/AdobeAIRInstaller.exe';
      INDEX_EDUCATION_HTTP=PREFIXE_HTTPS+'www.index-education.com/redirect-json.php?';
      MOZILLA_FIREFOX_FILTER='Firefox Setup *.exe';
      MOZILLA_THUNDERBIRD_FILTER='Thunderbird Setup *.exe';
      VIDEOLAN_HTTP='download.videolan.org';
      VIDEOLAN_VLC_FILTER='vlc-*.exe';
      VIDEOLAN_VLC_HTTPDIR32bits='/pub/videolan/vlc/last/win32/';
      VIDEOLAN_VLC_HTTPDIR64bits='/pub/videolan/vlc/last/win64/';
      NOMFICHIERSERVICECLIENT=NOMAPPLI+'_svc.exe';

function DejaLance(Name: string=''): bool;
procedure EcrireFichierDebug(Message: string='' ; ReplaceLastLineInMemo: bool=false);
procedure RenommerAnciensInstallateurs(Filtre: string);
function RenvoiDossierWindows: string;
function GetParentProcessName: string;
function Filtre(Mot, Masque: string): bool;
function IAmIn64Bits: Boolean;
function NomOrdinateur: string;
procedure GetFichier(Nom: string ; var Version: string ; var Fichier: TFileName ; FichierArchiveVersion: string='' ; ESR: bool=false ; OldMode: bool=false ; Mode: TMode3264=Mode_None);
function DownloadFile(const URL: string; DestFile: string ; Proxy: bool=false ; Proxy_Adresse:string='' ; MaxSize: cardinal=0 ; ConnectTimeOut: cardinal=DEFAULT_CONNECT_TIMEOUT ; ShowProgress: bool=false ; ChaineLOG: string='' ; Headers: TStringStream = nil ; IndyAlternative: bool=false): cardinal;
function DownloadStream(URL: string; Stream: TStream ; Proxy: bool=false ; Proxy_Adresse:string='' ; MaxSize: cardinal=0 ; ConnectTimeOut: cardinal=DEFAULT_CONNECT_TIMEOUT ; ShowProgress: bool=false ; ChaineLOG: string='' ; Headers: TStringStream = nil ; IndyAlternative: bool=false): TDownloadError;
function DownloadFileIfNewest(URL: string ; Filter: string ; GetBiggestFileFromHTML: bool ; LastDownloadedSize: cardinal ; TestVersionIntegrity: bool=true ; SuffixeName: string=''): TDownloadError;
function LanceAppliAttenteFin(Commande, Repertoire:string ; Visible: bool=false ; MaxExecutionTime: cardinal = INFINITE):boolean;
procedure TransfertInstallateursVersSetup;
function DisableWowRedirection: Boolean;
procedure KillProcessesForFile(ExeFileName: TFileName);
function RevertWowRedirection: Boolean;
function TailleRessource(TypeRes: PAnsiChar ; NomRes: string): cardinal;
procedure ExtraireRessource(TypeRes: PAnsiChar ; NomRes, Destination: string);
function RenvoiDossierCommonAppData: string;
function RenvoiDossierCommonFiles: string;
function RenvoiDossierProgramFiles: string;
procedure DestructionThread(var LeThread ; Wait: bool=true ; Forcer: bool=false);
procedure MettreAJourExecutable;
procedure ActionProcessus(ExeFileName: TFileName; Actions: TActionsProcessus; var TokenList: TTokenList);
function NetBios(Name: string): string;
function GetRemoteFileSize(Url : string; Proxy: bool=false ; Proxy_Adresse:string=''): cardinal;
function IsRemoteDrive(Drive: String): bool;
function GetUNCName(const LocalPath: string): string;
function IsServiceInstalled(CheckExecutable: bool=false): bool; overload;
function IsServiceInstalled(CheckExecutable: bool ; var User: string): bool; overload;
procedure InstallerService(Mode: TMode ; Partage: string='' ; Script: string='' ; Utilisateur: string='' ; Passe: string='' ; Compte_Utilisateur: string=''; Compte_Passe: string='');
procedure CreerTachePlanifiee(Time: TDateTime);
procedure SupprimerTachePlanifiee;
function GetFullPath(FileName: TFileName): string;
function GetCurrentSessionID: Integer;
function AddLogonAsAService(AccountName: string): bool;
function Match(Value, Filter: string ; Matches: TStrings): bool;
function Suffixe(Mode: TMode3264): string;
function ModifyJSON(FileName: TFileName ; Data: array of string ; ValueType: TlkJSONtypes ; Value: variant): bool;

var DossierInstallateurs: string='';
    TEMP_FILE: string='';
    isAdmin: bool=false;
    MODETEST: bool=false;

implementation

uses Principale, Journal, SevenZIP, URLMon, ShlObj, HTTPApp, ShellAPI, idHTTP, IdSSLOpenSSL, IdURI;

type WinIsWow64 = function( Handle: THandle; var Iret: BOOL ): Windows.BOOL; stdcall;

function OpenThread(dwDesiredAccess: DWORD; bInheritHandle: BOOL; dwThreadId: DWORD): THandle; stdcall; external 'kernel32.dll';

function NetBios(Name: string): string;
const Exclude = [' ', '\', '*', '+', '=', '|', ':', ';', '"', '?', '<', '>', ','];
var i: integer;
begin
     result:='';
     for i:=1 to length(Name) do
     if not (Name[i] in Exclude) then result:=result+UpperCase(Name[i]);
end;

procedure DestructionThread(var LeThread ; Wait: bool=true ; Forcer: bool=false);
const THREAD_TERMINATE = $0001;
var Thread: TThread;
    OT:cardinal;
    EC:BOOL;
begin
     if Pointer(LeThread)<>nil then
     try
        Thread:=TThread(LeThread);
        Thread.Terminate;
        if Wait then WaitForSingleObject(Thread.Handle,1000);
        if Forcer then
        try
           OT:=OpenThread(THREAD_TERMINATE, true, Thread.ThreadID);
           EC:=GetExitCodeThread(Thread.ThreadID,OT);
           TerminateThread(OT,Cardinal(EC));
        except
        end;
        Thread.Free;
        Pointer(LeThread):=nil;
     except end;
end;

function RenvoiDossierCommonAppData: string;
const CSIDL_COMMON_APPDATA=$0023;
var IdList:PITEMIDLIST;
    Dossier:array[0..MAX_PATH] of Char;
begin
     result:='';
     if SHGetSpecialFolderLocation(0, CSIDL_COMMON_APPDATA,IdList)=NOERROR then
     begin
          SHGetPathFromIDList(IdList, Dossier);
          result:=String(Dossier);
     end;
     result:=IncludeTrailingPathDelimiter(result);
end;

function RenvoiDossierCommonFiles: string;
const CSIDL_PROGRAM_FILES_COMMON=$002B;
var IdList:PITEMIDLIST;
    Dossier:array[0..MAX_PATH] of Char;
begin
     result:='';
     if SHGetSpecialFolderLocation(0, CSIDL_PROGRAM_FILES_COMMON,IdList)=NOERROR then
     begin
          SHGetPathFromIDList(IdList, Dossier);
          result:=String(Dossier);
     end;
     result:=IncludeTrailingPathDelimiter(result);
end;

function RenvoiDossierProgramFiles: string;
const CSIDL_PROGRAM_FILES=$0026;
var IdList:PITEMIDLIST;
    Dossier:array[0..MAX_PATH] of Char;
begin
     result:='';
     if SHGetSpecialFolderLocation(0, CSIDL_PROGRAM_FILES,IdList)=NOERROR then
     begin
          SHGetPathFromIDList(IdList, Dossier);
          result:=String(Dossier);
     end;
     result:=IncludeTrailingPathDelimiter(result);
end;

function TailleRessource(TypeRes: PAnsiChar ; NomRes: string): cardinal;
var ResourceStream:TResourceStream;
begin
     ResourceStream:=TResourceStream.Create(hInstance, NomRes, TypeRes);
     try
        result:=ResourceStream.Size;
     finally
        ResourceStream.Free;
     end;
end;

// Extrait le fichier en ressource vers la destination
procedure ExtraireRessource(TypeRes: PAnsiChar ; NomRes, Destination: string);
var ResourceStream:TResourceStream;
    FichierStream :TFileStream;
begin
  ResourceStream:=TResourceStream.Create(hInstance, NomRes, TypeRes);
  try
     if not FileExists(Destination) then
     try
        FichierStream:=TFileStream.Create(Destination, fmCreate);
        try
          FichierStream.CopyFrom(ResourceStream, 0);
        finally
          FichierStream.Free;
        end;
     except
     end;
  finally
    ResourceStream.Free;
  end;
end;

procedure TerminateChildrenRecursively(ParentProcessID: DWORD);
var hSnapshot: THandle;
    ProcessEntry: TProcessEntry32;
    ProcessHandle: THandle;
begin
  hSnapshot := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  if hSnapshot = INVALID_HANDLE_VALUE then Exit;

  ProcessEntry.dwSize := SizeOf(ProcessEntry);
  if Process32First(hSnapshot, ProcessEntry) then
  begin
    repeat
      if ProcessEntry.th32ParentProcessID = ParentProcessID then
      begin
        TerminateChildrenRecursively(ProcessEntry.th32ProcessID);
        ProcessHandle := OpenProcess(PROCESS_TERMINATE, False, ProcessEntry.th32ProcessID);
        if ProcessHandle <> 0 then
        begin
          TerminateProcess(ProcessHandle, 0);
          CloseHandle(ProcessHandle);
        end;
      end;
    until not Process32Next(hSnapshot, ProcessEntry);
  end;

  CloseHandle(hSnapshot);
end;


// Lance l'application et attend la fin de son excution
function LanceAppliAttenteFin(Commande, Repertoire: string ; Visible: bool=false ; MaxExecutionTime: cardinal = INFINITE):boolean;
var StartInfo : TStartupInfo;
    ProcessInformation : TProcessInformation;
begin
     result:=true;
     ZeroMemory(@StartInfo, sizeof(StartInfo)); // remplit de 0 StartInfo
     with StartInfo do
     begin
          cb:=sizeof(StartInfo);
          if not Visible then dwFlags := STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
     end;
     if CreateProcess(nil,PChar(Commande),nil,nil,true,0,nil,PChar(Repertoire),StartInfo,ProcessInformation) then
     begin
          WaitForSingleObject(ProcessInformation.hProcess, MaxExecutionTime);
          if MaxExecutionTime<>INFINITE then
          begin
               TerminateChildrenRecursively(ProcessInformation.dwProcessId);
               TerminateProcess(OpenProcess(PROCESS_TERMINATE, False, ProcessInformation.dwProcessId), 0);
//               TerminateProcess(ProcessInformation.hProcess, 0);
          end;
     end
     else result:=false;
end;

// Extrait le fichier de l'archive pour connatre la version du module SFX
function GetSFXVersion(FichierArchive: string ; FichierVersion: string): string;
var i: integer;
    FS: TFileStream;
begin
     result:='0.0.0.0';
     try
        with CreateInArchive(CLSID_CFormat7z) do
        begin
             OpenFile(FichierArchive);
             for i := 0 to NumberOfItems - 1 do
                  if not ItemIsFolder[i] and SameText(ItemPath[i], FichierVersion) then
                  try
                     FS:=TFileStream.Create(IncludeTrailingPathDelimiter(RenvoiDossierTemp)+FichierVersion, fmCreate);
                     try
                        ExtractItem(i, FS, false);
                     finally
                        FS.Free;
                     end;
                     result:=GetVersion(IncludeTrailingPathDelimiter(RenvoiDossierTemp)+FichierVersion, true);
                     EffacerFichier(IncludeTrailingPathDelimiter(RenvoiDossierTemp)+FichierVersion);
                  except
                  end;
        end;
     except
     end;
end;

function Suffixe(Mode: TMode3264): string;
begin
     case Mode of
     Mode32bits: result:=' (32 bits)';
     Mode64bits: result:=' (64 bits)';
     else
     result:='';
     end;
end;

procedure RenommerAnciensInstallateurs(Filtre: string);
var Mode_ESR: integer;
    Nom, NomTemp: string;
    Sr: TSearchRec;
begin
     for Mode_ESR:=1 to 2 do
     begin
          Nom:=Filtre;
          if Mode_ESR=2 then Nom:=ChangeFileExt(Nom, '')+STRING_ESR+ExtractFileExt(Nom);
          if FindFirst(DossierInstallateurs+Nom,faAnyFile,sr)=0 then
          begin
               repeat
                     NomTemp:=ChangeFileExt(Sr.FindData.cFileName, '');
                     if not (Pos(Suffixe(Mode32bits), NomTemp)=length(NomTemp)+1-length(Suffixe(Mode32bits))) and not (Pos(Suffixe(Mode64bits), NomTemp)=length(NomTemp)+1-length(Suffixe(Mode64bits))) then
                          if FileExists(DossierInstallateurs+NomTemp+Suffixe(Mode32bits)+ExtractFileExt(Sr.FindData.cFileName)) then
                             DeleteFile(DossierInstallateurs+Sr.FindData.cFileName)
                          else
                             RenommerFichier(DossierInstallateurs+Sr.FindData.cFileName, DossierInstallateurs+NomTemp+Suffixe(Mode32bits)+ExtractFileExt(Sr.FindData.cFileName));
               until FindNext(sr)<>0;
               FindClose(sr);
          end;
     end;
end;

// Recherche dans le dossier courant la version la plus rcente et le nom de l'excutable associ correspondant au Nom gnrique d'excutable attendu
procedure GetFichier(Nom: string ; var Version: string ; var Fichier: TFileName ; FichierArchiveVersion: string='' ; ESR: bool=false ; OldMode: bool=false ; Mode: TMode3264=Mode_None);
var Sr: TSearchRec;
    VersionTemp, Folder: string;
begin
     if OldMode then Folder:=ExtractFilePath(ParamStr(0)) else Folder:=DossierInstallateurs;
     Version:=''; Fichier:='';
     if ESR then Nom:=ChangeFileExt(Nom, '')+STRING_ESR+ExtractFileExt(Nom);
     if Mode<>Mode_None then Nom:=ChangeFileExt(Nom, '')+Suffixe(Mode)+ExtractFileExt(Nom);
     if FindFirst(Folder+Nom,faAnyFile,sr)=0 then
     begin
          repeat
                if FichierArchiveVersion<>'' then
                begin
                     if ESR or (not ESR and not SameText(RightStr(ChangeFileExt(Sr.FindData.cFileName, ''), length(STRING_ESR+Suffixe(Mode))), STRING_ESR+Suffixe(Mode))) then
                     begin
                          VersionTemp:=GetSFXVersion(Folder+Sr.FindData.cFileName, FichierArchiveVersion);
                          if CompareVersion(VersionTemp, Version)>0 then
                          begin
                               if Fichier<>'' then EffacerFichier(Folder+Fichier);
                               Version:=VersionTemp;
                               Fichier:=Sr.FindData.cFileName;
                          end else EffacerFichier(Folder+Sr.FindData.cFileName);
                     end;
                end
                else
                if CompareVersion(GetVersion(Folder+Sr.FindData.cFileName), Version)>=0 then
                begin
                     if Fichier<>'' then EffacerFichier(Folder+Fichier);
                     Fichier:=Sr.FindData.cFileName;
                     Version:=GetVersion(Folder+Fichier);
                end else EffacerFichier(Folder+Sr.FindData.cFileName);
          until FindNext(sr)<>0;
          FindClose(sr);
     end;
end;

// Teste si le systme d'exploitation est en 64 bits
function IAmIn64Bits: Boolean;
var HandleTo64BitsProcess: WinIsWow64;
    Iret : BOOL;
begin
     Result := False;
     HandleTo64BitsProcess := GetProcAddress(GetModuleHandle('kernel32.dll'), 'IsWow64Process');
     if Assigned(HandleTo64BitsProcess) then
     begin
          HandleTo64BitsProcess(GetCurrentProcess, Iret);
          Result := Iret;
     end;
end;
// Sous routine de filtrage pour expressions rgulires
function Comparer(Mot, Masque: string ; R: array of integer): bool;
var j, n, i: integer;
    Temp: string;
begin
    j:=1; n:=0; Temp:=''; i:=1; result:=true;
    while (i<=length(Masque)) and result do
    begin
          if Masque[ i]='?' then
            begin Temp:=Temp+Mot[j]; j:=j+1; end
          else
          if Masque[ i]='*' then
            begin n:=n+1; Temp:=Temp+Copy(Mot, j, R[n]); j:=j+R[n]; end
          else
          begin
              Temp:=Temp+Masque[ i];
              j:=j+1;
          end;

          if Temp<>'' then result:=Copy(Mot, 1, length(Temp))=Temp;
          i:=i+1;
    end;
    result:=Mot=Temp;
end;

// Routine de filtrage pour expressions rgulires (teste si "abcdef" correspond au masque "a*d?f*" ou pas)
function Filtre(Mot, Masque: string): bool;
  function Somme(R: array of integer; k: integer): integer;
  var i: integer; begin result:=0; for i:=1 to k do result:=result+R[ i]; end;
var R: array of integer;
    Total, Etoiles, k, i: integer;
begin
    result:=false;

    Etoiles:=0; Total:=length(Mot);
    for i:=1 to length(Masque) do if Masque[ i]='*' then Inc(Etoiles) else Dec(Total); 

    if Etoiles=0 then result:=Comparer(Mot, Masque, []) else 
    if Total>-1 then 
    begin 
          Setlength(R, Etoiles+1); 
          k:=0; R[k]:=0; 
          while (R[0]=0) and not result do 
          begin 
              k:=k+1;
              if k=Etoiles then
              begin
                    R[k]:=Total-Somme(R, k-1);
                    if not Comparer(Mot, Masque, R) then
                    begin
                        while (k>0) and (Somme(R, k)>=Total) do k:=k-1;
                        R[k]:=R[k]+1;
                    end else result:=true;
              end
              else R[k]:=0;
          end;
          Setlength(R, 0);
    end;
end;

// Rcupre le nom du dossier Windows
function RenvoiDossierWindows: string;
var Dossier:array[0..MAX_PATH] of Char;
begin
     GetWindowsDirectory(Dossier, SizeOf(Dossier));
     result:=StrPas(Dossier);
     if result='' then result:=ExtractFilePath(ParamStr(0)) else result:=IncludeTrailingPathDelimiter(StrPas(Dossier));
end;

// Renvoie le nom de l'ordinateur
function NomOrdinateur: string;
var Buffer : array[0..255] of char;
    BufferSize : DWORD;
begin
     BufferSize := SizeOf(Buffer); GetComputerName(@buffer, BufferSize); result := buffer;
end;

// Ecrire fichier de journalisation
procedure EcrireFichierDebug(Message: string='' ; ReplaceLastLineInMemo: bool=false);
var Fichier: string;
    L: TStringList;
begin
     if not MODETEST then
     begin
          if Message<>'' then Message:=FormatDateTime('dd/mm/YYYY @ hh:nn:ss', Now)+' - '+Message;
          if Configuration.General.Log then
          try
             Fichier:=ExtractFilePath(ParamStr(0))+'Log\'+NomOrdinateur+'.log';
             try ForceDirectories(ExtractFilePath(Fichier)); except end;
             L:=TStringList.Create;
             with L do
             begin
                  if FileExists(Fichier) then LoadFromFile(Fichier);
                  while Count>LOG_MAX_LINES do Delete(0);
                  if ReplaceLastLineInMemo and (Count>0) then L[Count-1]:=Message else Add(Message);
                  SaveToFile(Fichier);
                  Free;
             end;
          except
          end;
          if Configuration.General.Fenetre and Assigned(UpdateThread) then
               UpdateThread.Afficher(Message, ReplaceLastLineInMemo);
     end;
end;


// Teste si l'utilitaire est dj lanc
function DejaLance(Name: string=''): bool;
begin
     if Name='' then Name:=ChangeFileExt(ExtractFileName(ParamStr(0)), '');
     SetLastError(NO_ERROR);
     CreateMutex (nil, False, PChar(Name));
     result:=GetLastError=ERROR_ALREADY_EXISTS;
end;


var
   Wow64Redirection: LongBool;

function DisableWowRedirection: Boolean;
 type TWow64DisableWow64FsRedirection = function(var Wow64FsEnableRedirection: LongBool): LongBool; StdCall;
var
   hHandle: THandle;
   Wow64DisableWow64FsRedirection: TWow64DisableWow64FsRedirection;
begin
   Result := true;
   if not IAmIn64Bits then exit;
  try
     hHandle := GetModuleHandle('kernel32.dll');
     @Wow64DisableWow64FsRedirection := GetProcAddress(hHandle, 'Wow64DisableWow64FsRedirection');
    if ((hHandle <> 0) and (@Wow64DisableWow64FsRedirection <> nil))
       then Wow64DisableWow64FsRedirection(Wow64Redirection);
   except
     result := false;
   end;
 end;

function RevertWowRedirection: Boolean;
 type
   TWow64RevertWow64FsRedirection  = function(var Wow64RevertWow64FsRedirection: LongBool): LongBool; StdCall;
var
   hHandle: THandle;
   Wow64RevertWow64FsRedirection: TWow64RevertWow64FsRedirection;
 begin
   Result := true;
   if not IAmIn64Bits then exit;
  try
     hHandle := GetModuleHandle('kernel32.dll');
     @Wow64RevertWow64FsRedirection  := GetProcAddress(hHandle, 'Wow64RevertWow64FsRedirection');
    if ((hHandle <> 0) and (@Wow64RevertWow64FsRedirection <> nil))
       then Wow64RevertWow64FsRedirection(Wow64Redirection);
   except
     result := false;
   end;
 end;


procedure MettreAJourExecutable;
   function OEM(AsciiString: string): string;
   begin
       result:=AsciiString;
       CharToOEM(PChar(AsciiString), PChar(result));
   end;
  function GetTmpFileName(ext: string): string;
  var
    pc: PChar;
  begin
    pc := StrAlloc(MAX_PATH + 1);
    GetTempFileName(PChar(RenvoiDossierTemp), 'uis', 0, pc);
    Result := string(pc);
    Result := ChangeFileExt(Result, ext);
    StrDispose(pc);
  end;

  function ParamString: string;
  var i: integer;
  begin
       result:='';
       for i:=1 to ParamCount do result:=result+'"'+ParamStr(i)+'"';
  end;

var
  batchfile: TStringList;
  batchname: string;
begin
  batchname := GetTmpFileName('.bat');
  FileSetAttr(ParamStr(0), 0);
  batchfile := TStringList.Create;
  with batchfile do
  begin
    try
      Add(':Label1');
      Add('del "' + Oem(ParamStr(0)) + '"');
      Add('if Exist "' + Oem(ParamStr(0)) + '" goto Label1');
      Add(':Label2');
      Add('ren "' + Oem(ParamStr(0)) + '.temp" "' + Oem(ExtractFileName(ParamStr(0))) + '"');
      Add('if not Exist "' + Oem(ParamStr(0)) + '" goto Label2');
      Add('chdir "'+Oem(GetCurrentDir)+'"');
      Add('start "" '+Oem('"'+ParamStr(0)+'" '+ParamString));
      Add('del ' + batchname);
      SaveToFile(batchname);
      ChDir(RenvoiDossierTemp);
      WinExec(PChar(batchname), SW_HIDE);
    finally
      batchfile.Free;
    end;
  end;
end;

// Stoppe ou cre un doublon de Token du processus portant le nom indiqu (chez tous les utilisateurs)
procedure ActionProcessus(ExeFileName: TFileName; Actions: TActionsProcessus; var TokenList: TTokenList);
     function SetPrivilege(aPrivilegeName: string; aEnabled: boolean): boolean;
     var TP : TTokenPrivileges;
         TPPrev : TTokenPrivileges;
         Token : THandle;
         dwRetLen : DWord;
     begin
          Result := False;
          if OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, Token) then
          begin
               TP.PrivilegeCount := 1;
               if (LookupPrivilegeValue(nil, PChar(aPrivilegeName), TP.Privileges[0].LUID)) then
               begin
                   if (aEnabled) then TP.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED
                   else TP.Privileges[0].Attributes := 0;
                   dwRetLen := 0;
                   Result := AdjustTokenPrivileges(Token, False, TP, SizeOf(TPPrev), TPPrev, dwRetLen);
               end;
               CloseHandle(Token);
          end;
     end;
var ContinueLoop: BOOL;
    ph, FSnapshotHandle: THandle;
    FProcessEntry32: TProcessEntry32;
    htoken, newToken: cardinal;
begin
     SetPrivilege('SeDebugPrivilege', True);
     Setlength(TokenList, 0);
     try
        FSnapshotHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
        try
           FProcessEntry32.dwSize := Sizeof(FProcessEntry32);
           ContinueLoop := Process32First(FSnapshotHandle, FProcessEntry32);
           while integer(ContinueLoop) <> 0 do
           begin
                if (FProcessEntry32.th32ProcessID<>GetCurrentProcessID) and ((StrIComp(PChar(ExtractFileName(FProcessEntry32.szExeFile)), PChar(ExeFileName)) = 0)
                or (StrIComp(FProcessEntry32.szExeFile, PChar(ExeFileName)) = 0))  then
                begin
                     ph:=OpenProcess(PROCESS_TERMINATE or PROCESS_QUERY_INFORMATION, BOOL(0), FProcessEntry32.th32ProcessID);
                     if (ph <> 0) and (apToken in Actions) then
                     try
                        if OpenProcessToken(ph, TOKEN_ASSIGN_PRIMARY or TOKEN_DUPLICATE or TOKEN_QUERY, hToken) then
                        begin
                             DuplicateTokenEx(hToken, MAXIMUM_ALLOWED, nil, SecurityImpersonation, TokenPrimary, newToken);
                             CloseHandle(hToken);
                             Setlength(TokenList, length(TokenList)+1);
                             TokenList[length(TokenList)-1]:=newToken;
                        end;
                     except
                     end;
                     if apKill in Actions then TerminateProcess(ph, 0);
                     CloseHandle(ph);
                end;
                ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
           end;
        finally
           CloseHandle(FSnapshotHandle);
        end;
     except
     end;
     SetPrivilege('SeDebugPrivilege', False);
end;

function DownloadFile(const URL: string; DestFile: string ; Proxy: bool=false ; Proxy_Adresse:string='' ; MaxSize: cardinal=0 ; ConnectTimeOut: cardinal=DEFAULT_CONNECT_TIMEOUT ; ShowProgress: bool=false ; ChaineLOG: string='' ; Headers: TStringStream = nil ; IndyAlternative: bool=false): cardinal;
var Stream: TFileStream;
begin
     EffacerFichier(DestFile);
     result:=0;
     try
        Stream:=TFileStream.Create(DestFile, fmCreate);
        try
           DownloadStream(URL, Stream, Proxy, Proxy_Adresse, MaxSize, ConnectTimeOut, ShowProgress, ChaineLOG, Headers, IndyAlternative);
           result:=Stream.Size;
        finally
           if Assigned(Stream) then Stream.Free;
        end;
     except
     end;
     if result=0 then EffacerFichier(DestFile);
end;

function FormatDownloadError(Code: integer=0 ; Message: string=''): TDownloadError;
begin
     result.Code:=Code;
     result.Message:=Message;
end;

function DownloadStream(URL: string; Stream: TStream ; Proxy: bool=false ; Proxy_Adresse:string='' ; MaxSize: cardinal=0 ; ConnectTimeOut: cardinal=DEFAULT_CONNECT_TIMEOUT ; ShowProgress: bool=false ; ChaineLOG: string='' ; Headers: TStringStream = nil ; IndyAlternative: bool=false): TDownloadError;
const BUFSIZE=16384;
var
  iNetworkHandle, iConnectionHandle, iRequestHandle: HINTERNET;
  arBuf: array[0..BUFSIZE-1] of Char;
  SecurityFlags, FlagsLen, dwAccessType, iBytesRead, iFlags: DWord;
  pURIC: URL_COMPONENTS;
  iRetry : Integer;
  MaxSizeToDownload: cardinal;
  IDHttp: TIDHttp;
  SSL: TIdSSLIOHandlerSocketOpenSSL;
  ProxyURI: TIdURI;
begin
     result:=FormatDownloadError;
     SecurityFlags:=0;
     FillChar(pURIC, SizeOf(URL_COMPONENTS), 0);
     iFlags := INTERNET_FLAG_NO_UI or INTERNET_FLAG_RELOAD or INTERNET_FLAG_RAW_DATA;
     with pURIC do
     begin
          dwStructSize:= SizeOf(pURIC);
          lpszScheme:= nil;
          dwSchemeLength:= INTERNET_MAX_SCHEME_LENGTH;
          lpszHostName:= nil;
          dwHostNameLength:= INTERNET_MAX_HOST_NAME_LENGTH;
          lpszUserName:= nil;
          dwUserNameLength:= INTERNET_MAX_USER_NAME_LENGTH;
          lpszPassword:= nil;
          dwPasswordLength:= INTERNET_MAX_PASSWORD_LENGTH;
          lpszUrlPath:= nil;
          dwUrlPathLength:= INTERNET_MAX_PATH_LENGTH;
          lpszExtraInfo:= nil;
          dwExtraInfoLength:= INTERNET_MAX_PATH_LENGTH;
     end;
     if InternetCrackUrl(PChar(URL), Length(URL), 0, pURIC) then
     begin
          if not Proxy or (Trim(Proxy_Adresse)='') then begin Proxy_Adresse:=''; dwAccessType:=INTERNET_OPEN_TYPE_PRECONFIG; end else dwAccessType:=INTERNET_OPEN_TYPE_PROXY;
          iNetworkHandle := InternetOpen(USER_AGENT, dwAccessType, PChar(Proxy_Adresse), nil, 0);
          try
             if Assigned(iNetworkHandle) then
             begin
                  iConnectionHandle := InternetConnect(iNetworkHandle, PChar(Copy(pURIC.lpszHostName, 1, pURIC.dwHostNameLength)), pURIC.nPort, nil, nil, INTERNET_SERVICE_HTTP, 0, 0);
                  try
                     if Assigned(iConnectionHandle) then
                     begin
                          if pURIC.nScheme=INTERNET_SCHEME_HTTPS then
                          begin
                               iFlags:=iFlags or INTERNET_FLAG_SECURE;
                               SecurityFlags:=SecurityFlags or INTERNET_FLAG_IGNORE_CERT_DATE_INVALID;
                               SecurityFlags:=SecurityFlags or INTERNET_FLAG_IGNORE_CERT_CN_INVALID;
                               SecurityFlags:=SecurityFlags or SECURITY_FLAG_IGNORE_UNKNOWN_CA ;
                               SecurityFlags:=SecurityFlags or SECURITY_FLAG_IGNORE_REVOCATION;
                               iFlags:=iFlags or SecurityFlags;
                          end;
                          iRequestHandle := HTTPOpenRequest(iConnectionHandle, 'GET', PChar(pURIC.lpszUrlPath), PChar('HTTP/1.1'), nil, nil, iFlags, 0);
                          try
                             if Assigned(iRequestHandle) then
                             begin
                                  if Assigned(Headers) then HttpAddRequestHeaders(iRequestHandle, PChar(Headers.DataString), Length(Headers.DataString), HTTP_ADDREQ_FLAG_ADD or HTTP_ADDREQ_FLAG_REPLACE);
                                  InternetSetOption(iRequestHandle, INTERNET_OPTION_CONNECT_TIMEOUT, @ConnectTimeout, SizeOf(ConnectTimeout));
                                  InternetSetOption(iRequestHandle, INTERNET_OPTION_SECURITY_FLAGS, Pointer(@SecurityFlags), SizeOf(SecurityFlags));
                                  iRetry:=0;
                                  repeat
                                        if HTTPSendRequest(iRequestHandle, nil, 0, nil, 0) then
                                        begin
                                             if Assigned(Stream) then
                                             begin
                                                  repeat
                                                        MaxSizeToDownload:=length(arBuf);
                                                        if MaxSize>0 then MaxSizeToDownload:=Min(MaxSizeToDownload, MaxSize-Stream.Size);
                                                        InternetReadFile(iRequestHandle, @arBuf, MaxSizeToDownload, iBytesRead);
                                                        if iBytesRead>0 then Stream.Write(arBuf, iBytesRead);
                                                        if ShowProgress and (MaxSize>0) and Configuration.General.Fenetre and Assigned(UpdateThread) then UpdateThread.Afficher(ChaineLOG+Format('%.2f',[Stream.Size/MaxSize*100])+' %', true);
                                                  until (iBytesRead=0) or ((MaxSize>0) and (Stream.Size>=MaxSize));
                                             end
                                             else result:=FormatDownloadError(15, 'Stream not assigned');
                                             iRetry:=0;
                                       end
                                       else
                                       begin
                                            if (iRetry=0) and (GetLastError=ERROR_INTERNET_INVALID_CA) then
                                            begin
                                                 Inc(iRetry);
                                                 FlagsLen := SizeOf(iFlags);
                                                 InternetQueryOption(iRequestHandle, INTERNET_OPTION_SECURITY_FLAGS, Pointer(@iFlags), FlagsLen);
                                                 iFlags := iFlags or SecurityFlags;
                                                 InternetSetOption(iRequestHandle, INTERNET_OPTION_SECURITY_FLAGS, Pointer(@iFlags), FlagsLen);
                                            end
                                            else
                                            begin
                                                 if IndyAlternative then
                                                 begin
                                                      IDHttp:=TIDHttp.Create(nil);
                                                      if Proxy_Adresse<>'' then
                                                      begin
                                                           ProxyURI := TIdURI.Create(PREFIXE_HTTP+Proxy_Adresse);
                                                           IDHttp.ProxyParams.ProxyServer := ProxyURI.Host;
                                                           IDHttp.ProxyParams.ProxyPort := StrToIntDef(ProxyURI.Port, 3128);
                                                           IDHttp.ProxyParams.BasicAuthentication := False;
                                                           IDHttp.ProxyParams.ProxyUsername := '';
                                                           IDHttp.ProxyParams.ProxyPassword := '';
                                                           ProxyURI.Free;
                                                      end;
                                                      SSL:=TIdSSLIOHandlerSocketOpenSSL.Create(IDHttp);
                                                      SSL.SSLOptions.Mode := sslmClient;
                                                      SSL.SSLOptions.SSLVersions := [sslvTLSv1, sslvTLSv1_1, sslvTLSv1_2];
                                                      IDHttp.IOHandler := SSL;
                                                      IDHttp.ConnectTimeOut:=ConnectTimeOut;
                                                      if MaxSize>0 then IDHttp.Request.CustomHeaders.Add('Range: bytes=0-' + IntToStr(MaxSize));
                                                      if Headers<>nil then IDHttp.Request.CustomHeaders.Add(Headers.DataString);
                                                      try
                                                         IDHttp.Get(URL, Stream);
                                                      except
                                                           result:=FormatDownloadError(14, 'Unable to download '+URL);
                                                      end;
                                                      IDHttp.Free;
                                                      iRetry:=0;
                                                 end
                                                 else
                                                 begin
                                                      result:=FormatDownloadError(14, 'Unable to download '+URL);
                                                      iRetry:=0;
                                                 end;
                                            end;
                                       end;
                                  until iRetry=0;
                             end
                             else result:=FormatDownloadError(13, 'Unable to get '+pURIC.lpszUrlPath);
                          finally
                             InternetCloseHandle(iRequestHandle);
                          end;
                     end
                     else result:=FormatDownloadError(12, 'Unable to connect to '+Copy(pURIC.lpszHostName, 1, pURIC.dwHostNameLength));
                  finally
                     InternetCloseHandle(iConnectionHandle);
                  end;
             end
             else result:=FormatDownloadError(11, 'Unable to get access to WinInet.Dll');
          finally
            InternetCloseHandle(iNetworkHandle);
          end;
     end
     else result:=FormatDownloadError(10, 'Invalid URL ('+URL+')');
     FillChar(pURIC, SizeOf(URL_COMPONENTS), 0);
end;

type URIInfo=(Scheme, HostName, UserName, Password, URLPath, ExtraInfo);

function GetURIInfo(const lpszUrl: string; Info: URIInfo): string;
var
  lpszScheme      : array[0..INTERNET_MAX_SCHEME_LENGTH - 1] of Char;
  lpszHostName    : array[0..INTERNET_MAX_HOST_NAME_LENGTH - 1] of Char;
  lpszUserName    : array[0..INTERNET_MAX_USER_NAME_LENGTH - 1] of Char;
  lpszPassword    : array[0..INTERNET_MAX_PASSWORD_LENGTH - 1] of Char;
  lpszUrlPath     : array[0..INTERNET_MAX_PATH_LENGTH - 1] of Char;
  lpszExtraInfo   : array[0..1024 - 1] of Char;
  lpUrlComponents : TURLComponents;
begin
     ZeroMemory(@lpszScheme, SizeOf(lpszScheme));
     ZeroMemory(@lpszHostName, SizeOf(lpszHostName));
     ZeroMemory(@lpszUserName, SizeOf(lpszUserName));
     ZeroMemory(@lpszPassword, SizeOf(lpszPassword));
     ZeroMemory(@lpszUrlPath, SizeOf(lpszUrlPath));
     ZeroMemory(@lpszExtraInfo, SizeOf(lpszExtraInfo));
     ZeroMemory(@lpUrlComponents, SizeOf(TURLComponents));
     lpUrlComponents.dwStructSize      := SizeOf(TURLComponents);
     lpUrlComponents.lpszScheme        := lpszScheme;
     lpUrlComponents.dwSchemeLength    := SizeOf(lpszScheme);
     lpUrlComponents.lpszHostName      := lpszHostName;
     lpUrlComponents.dwHostNameLength  := SizeOf(lpszHostName);
     lpUrlComponents.lpszUserName      := lpszUserName;
     lpUrlComponents.dwUserNameLength  := SizeOf(lpszUserName);
     lpUrlComponents.lpszPassword      := lpszPassword;
     lpUrlComponents.dwPasswordLength  := SizeOf(lpszPassword);
     lpUrlComponents.lpszUrlPath       := lpszUrlPath;
     lpUrlComponents.dwUrlPathLength   := SizeOf(lpszUrlPath);
     lpUrlComponents.lpszExtraInfo     := lpszExtraInfo;
     lpUrlComponents.dwExtraInfoLength := SizeOf(lpszExtraInfo);
     InternetCrackUrl(PChar(lpszUrl), Length(lpszUrl), ICU_DECODE or ICU_ESCAPE, lpUrlComponents);
     case Info of
     Scheme: result:=lpszScheme;
     HostName: result:=lpszHostName;
     UserName: result:=lpszUserName;
     Password: result:=lpszPassword;
     ExtraInfo: result:=lpszExtraInfo;
     else
     result:=lpszURLPath;
     end;
end;

procedure GetRemoteFileInfo(Url : string; Proxy: bool ; Proxy_Adresse:string; out Size: cardinal ; out FileName: string);
var
  hInet    : HINTERNET;
  hConnect : HINTERNET;
  lpdwBufferLength: DWORD;
  dummy: DWORD;
  bufLen: DWORD;
  dwAccessType: DWORD;
  NewURL: string;
  infoBuffer: array [0..512] of char;
begin
     Size:=0; FileName:='';
     if not Proxy or (Trim(Proxy_Adresse)='') then begin Proxy_Adresse:=''; dwAccessType:=INTERNET_OPEN_TYPE_PRECONFIG; end else dwAccessType:=INTERNET_OPEN_TYPE_PROXY;
     try
        hInet := InternetOpen(USER_AGENT, dwAccessType, PChar(Proxy_Adresse), nil, 0);
        if hInet<>nil then
        try
           NewURL:=URL;
           repeat
                 URL:=NewURL;
                 SetLastError(0);
                 hConnect := InternetOpenURL(hInet, PChar(URL), nil, 0, INTERNET_FLAG_NO_UI or INTERNET_FLAG_RELOAD or INTERNET_FLAG_NO_AUTO_REDIRECT, 0);
                 if (hConnect=nil) and SameText(Copy(URL, 1, length(PREFIXE_HTTPS)), PREFIXE_HTTPS) then
                 begin
                      URL:=PREFIXE_HTTP+Copy(URL, length(PREFIXE_HTTPS)+1, MAXINT);
                      hConnect := InternetOpenURL(hInet, PChar(URL), nil, 0, INTERNET_FLAG_NO_UI or INTERNET_FLAG_RELOAD or INTERNET_FLAG_NO_AUTO_REDIRECT, 0);
                 end;
                 if hConnect<>nil then
                 try
                    dummy := 0;
                    Buflen := sizeof(infoBuffer);
                    if not HttpQueryInfo(hConnect, HTTP_QUERY_LOCATION, @infoBuffer[0], bufLen, dummy) then InfoBuffer:='';
                    NewURL:=Infobuffer;
                    if NewURL='' then
                    begin
                         lpdwBufferLength:=SizeOf(Size);
                         if InfoBuffer='' then FileName:=ExtractFileName(UnixPathToDosPath(URL)) else FileName:=ExtractFileName(InfoBuffer);
                         if not HttpQueryInfo(hConnect, HTTP_QUERY_CONTENT_LENGTH or HTTP_QUERY_FLAG_NUMBER, @Size, lpdwBufferLength, dummy) then Size:=0;
                    end;
                 finally
                    InternetCloseHandle(hConnect);
                 end;
           until (NewURL='') or (hConnect=nil);
        finally
           InternetCloseHandle(hInet);
        end;
     except
     end;
     FileName:=HTTPDecode(FileName);
     while Pos('/', FileName)>0 do FileName:=Copy(FileName, Pos('/', FileName)+1, MAXINT);
end;

function GetRemoteFileSize(Url : string; Proxy: bool=false ; Proxy_Adresse:string=''): cardinal;
var FileName: string;
begin
     GetRemoteFileInfo(URL, Proxy, Proxy_Adresse, result, FileName);
end;

function DownloadFileIfNewest(URL: string ; Filter: string ; GetBiggestFileFromHTML: bool ; LastDownloadedSize: cardinal ; TestVersionIntegrity: bool=true ; SuffixeName: string=''): TDownloadError;
const TAG=' href="';
var FileSize, FileSizeTemp: cardinal;
    FS: TFileStream;
    Lien, FileName, Chaine, ChaineLOG, NewFileName: string;
    i, Index: integer;
    StringStream: TStringStream;
    Liste: TStringList;
begin
     if Configuration.General.Fenetre and Assigned(FicheJournal) and (FicheJournal.Journal.Lines.Count>0) then ChaineLOG:=FicheJournal.Journal.Lines[FicheJournal.Journal.Lines.Count-1] else ChaineLOG:='';
     if Configuration.General.Fenetre and Assigned(UpdateThread) then UpdateThread.Afficher(ChaineLOG+'Prparation...', true);
     Liste:=TStringList.Create;
     if GetBiggestFileFromHTML then
     begin
           // 1. Tlchargement de la page HTML
           StringStream:=TStringStream.Create('');
           DownloadStream(URL, StringStream, Configuration.General.Proxy, Configuration.General.Proxy_Adresse, 200000);
           Chaine:=StringStream.DataString;
           StringStream.Free;

           // 2. Extraction des liens valides
           while Pos(TAG, Chaine)>0 do
           begin
                Chaine:=Copy(Chaine, Pos(TAG, Chaine)+length(TAG), MAXINT);
                Lien:=HTTPDecode(Copy(Chaine, 1, Pos('"', Chaine)-1));
                while Pos('/', Lien)>0 do Lien:=Copy(Lien, Pos('/', Lien)+1, MAXINT);
                if Filtre(Lien, Filter) then Liste.Add(Lien);
           end;

           // 3. Tlchargement des en-ttes
           FileSize:=High(Cardinal); Index:=-1;
           for i:=0 to Liste.Count-1 do
           begin
                FileSizeTemp:=GetRemoteFileSize(URL+Liste[i], Configuration.General.Proxy, Configuration.General.Proxy_Adresse);
                if (FileSizeTemp>FileSize) or (FileSize=High(Cardinal)) then
                begin
                     FileSize:=FileSizeTemp;
                     Index:=i;
                end;
           end;
           if Index>=0 then
           begin
                FileName:=Liste[Index];
                URL:=URL+FileName;
           end
           else URL:='';
     end
     else
     begin
          GetRemoteFileInfo(URL, Configuration.General.Proxy, Configuration.General.Proxy_Adresse, FileSize, FileName);
          if Pos('*', Filter)=0 then FileName:=Filter;
     end;

     if FileSize=High(Cardinal) then result:=FormatDownloadError(4, 'File not found')
     else
     if Filtre(FileName, Filter) then
          if FileSize<>LastDownloadedSize then
          begin
               EffacerFichier(TEMP_FILE);
               try
                  FS:=TFileStream.Create(TEMP_FILE, fmCreate);
                  try
                     result:=DownloadStream(URL, FS, Configuration.General.Proxy, Configuration.General.Proxy_Adresse, FileSize, DEFAULT_CONNECT_TIMEOUT, true, ChaineLOG);
                  finally
                     FS.Free;
                  end;
               except
                  result:=FormatDownloadError(1, 'Error while creating '+TEMP_FILE+'.');
               end;
               if result.Code=0 then
               begin
                    if not TestVersionIntegrity or (GetVersion(TEMP_FILE)<>'') then
                    begin
                         NewFileName:=FileName;
                         if SuffixeName<>'' then NewFileName:=ChangeFileExt(NewFileName, '')+SuffixeName+ExtractFileExt(NewFileName);
                         EffacerFichier(DossierInstallateurs+NewFileName);
                         if not RenommerFichier(TEMP_FILE, DossierInstallateurs+NewFileName) then result:=FormatDownloadError(3, 'Can''t rename '+ExtractFileName(TEMP_FILE)+' into '+NewFileName);
                    end
                    else result:=FormatDownloadError(2, 'File seems to be corrupted');
               end;
               EffacerFichier(TEMP_FILE);
          end
          else result:=FormatDownloadError(-1, 'Already downloaded')
     else result:=FormatDownloadError(4, Format('Cannot find file %s.',[URL]));
     Liste.Free;
end;

procedure TransfertInstallateursVersSetup;
    procedure DeplacerFichier(FileName: string);
    var Version: string;
        Fichier: TFileName;
    begin
         GetFichier(FileName, Version, Fichier, '', false, true);
         if Fichier<>'' then
         begin
              ForceDirectories(DossierInstallateurs);
              CopierFichier(ExtractFilePath(ParamStr(0))+Fichier, DossierInstallateurs+Fichier);
              EffacerFichier(ExtractFilePath(ParamStr(0))+Fichier);
         end;
    end;
begin
     if not DirectoryExists(DossierInstallateurs) then
     begin
          DeplacerFichier('install_flash_player_*active_x.exe');
          DeplacerFichier('install_flash_player_*plugin.exe');
          DeplacerFichier('jre-7u*-windows-i586.exe');
          DeplacerFichier('jre-7u*-windows-x64.exe');
          DeplacerFichier('jre-8u*-windows-i586.exe');
          DeplacerFichier('jre-8u*-windows-x64.exe');
          DeplacerFichier(MOZILLA_FIREFOX_FILTER);
          DeplacerFichier(MOZILLA_THUNDERBIRD_FILTER);
          DeplacerFichier(VIDEOLAN_VLC_FILTER);
          DeplacerFichier('AdobeAIRInstaller.exe');
     end;
end;

// Stoppe tous les processus portant le nom indiqu (chez tous les utilisateurs)
procedure KillProcessesForFile(ExeFileName: TFileName);
var TokenList: TTokenList;
begin
     ActionProcessus(ExeFileName, [apKill], TokenList);
     Setlength(TokenList, 0);
end;

// Renvoie un nom de dossier au format UNC
function GetUNCName(const LocalPath: string): string;
var BufferSize: DWord;
    DummyBuffer: Byte;
    Buffer: Pointer;
begin
     BufferSize := 1;
     WNetGetUniversalName(PChar(LocalPath), UNIVERSAL_NAME_INFO_LEVEL, @DummyBuffer, BufferSize);
     Buffer := AllocMem(BufferSize);
     result:='';
     try
        if WNetGetUniversalName(PChar(LocalPath), UNIVERSAL_NAME_INFO_LEVEL, Buffer, BufferSize)=NO_ERROR then Result := PUniversalNameInfo(Buffer)^.lpUniversalName
     finally
        FreeMem(Buffer);
     end;
end;

function GetFullPath(FileName: TFileName): string;
begin if not IsRemoteDrive(ExtractFileDrive(FileName)) then result:=FileName else result:=GetUNCName(FileName); end;

function IsRemoteDrive(Drive: String): bool;
begin result:=GetDriveType(Pchar(Drive))=DRIVE_REMOTE; end;

function IsServiceInstalled(CheckExecutable: bool ; var User: string): bool;
const LocalSystem='LocalSystem';
var ServiceControlManager: SC_Handle;
    ServiceHandle: SC_Handle;
    lpServiceConfig: PQueryServiceConfigA;
    nSize, nBytesNeeded: DWord;    
begin
     result:=not CheckExecutable or FileExists(IncludeTrailingPathDelimiter(RenvoiDossierProgramFiles+NOMAPPLI)+NOMFICHIERSERVICECLIENT);
     if result then
     begin
          ServiceControlManager:=OpenSCManager('', nil, STANDARD_RIGHTS_REQUIRED);
          ServiceHandle:=OpenService(ServiceControlManager, NOMAPPLI, SERVICE_QUERY_CONFIG);
          result:=ServiceHandle<>0;
          if result then
          begin
               QueryServiceConfig(ServiceHandle, nil, 0, nSize);
               if nSize>0 then
               begin
                    lpServiceConfig := AllocMem(nSize);
                    if QueryServiceConfig(ServiceHandle, lpServiceConfig, nSize, nBytesNeeded) then
                    begin
                         User:=string(lpServiceConfig^.lpServiceStartName);
                         if Copy(User, 1, length(PREFIXE_LOCALMACHINE))=PREFIXE_LOCALMACHINE then User:=Copy(User, length(PREFIXE_LOCALMACHINE)+1, MAXINT);
                         if SameText(LocalSystem, User) then User:='';
                    end;
                    Dispose(lpServiceConfig);
               end;
               CloseServiceHandle(ServiceHandle);
          end;
          CloseServiceHandle(ServiceControlManager);
     end;
end;

function IsServiceInstalled(CheckExecutable: bool=false): bool;
var UserName: string;
begin result:=IsServiceInstalled(CheckExecutable, UserName); end;

// Rinstallation du service (suppression du prcdent + cration du nouveau)
procedure InstallerService(Mode: TMode ; Partage: string='' ; Script: string='' ; Utilisateur: string='' ; Passe: string='' ; Compte_Utilisateur: string=''; Compte_Passe: string='');
var DossierService: string;
    User, Password: PChar;
    Erreur: integer;
    ServiceControlManager: SC_Handle;
    Status: _SERVICE_STATUS;
    ServiceHandle: SC_Handle;
    Args: array of PAnsiChar;
    lpServiceConfig: PQueryServiceConfigA;
    nSize, nBytesNeeded: DWord;
    Service_Status: _Service_Status;
    procedure WaitForServiceStop(Duration: cardinal=0);
    var TickCount: cardinal;
    begin
         TickCount:=GetTickCount;
         repeat
              ControlService(ServiceHandle, SERVICE_CONTROL_STOP, Status);
         until (Status.dwCurrentState=SERVICE_STOPPED) or ((Duration<>0) and (GetTickCount-TickCount>Duration));
    end;
begin
     if isAdmin then
     begin
          DossierService:=IncludeTrailingPathDelimiter(RenvoiDossierProgramFiles+NOMAPPLI);
          if Mode=Mode_Desinstallation then
          begin
               LanceAppliAttenteFin(DossierService+NOMFICHIERSERVICECLIENT+' '+PARAM_SERVICE_UNINSTALL, DossierService);
               if IsServiceInstalled then
               begin
                    ServiceControlManager:=OpenSCManager('', nil, STANDARD_RIGHTS_REQUIRED or SC_MANAGER_CREATE_SERVICE);
                    ServiceHandle:=OpenService(ServiceControlManager, NOMAPPLI, SERVICE_ALL_ACCESS);
                    if ServiceHandle<>0 then
                    begin
                         repeat
                               ControlService(ServiceHandle, SERVICE_CONTROL_STOP, Service_Status);
                               sleep(100);
                         until Service_Status.dwCurrentState=SERVICE_STOPPED;
                         DeleteService(ServiceHandle);
                         CloseServiceHandle(ServiceHandle);
                    end;
                    CloseServiceHandle(ServiceControlManager);
               end;
          end
          else
          begin
               ServiceControlManager:=OpenSCManager('', nil, STANDARD_RIGHTS_REQUIRED or SC_MANAGER_CREATE_SERVICE);
               ServiceHandle:=OpenService(ServiceControlManager, NOMAPPLI, SERVICE_ALL_ACCESS);
               // Suppression de l'ancien service
               if ServiceHandle<>0 then
               begin
                    WaitForServiceStop(5000);
                    // Arrt du service
                    KillProcessesForFile(NOMFICHIERSERVICECLIENT);
                    QueryServiceConfig(ServiceHandle, nil, 0, nSize);
                    lpServiceConfig := AllocMem(nSize);
                    try
                       if QueryServiceConfig(ServiceHandle, lpServiceConfig, nSize, nBytesNeeded) and FileExists(lpServiceConfig^.lpBinaryPathName) then EffacerFichier(lpServiceConfig^.lpBinaryPathName);
                    finally
                       Dispose(lpServiceConfig);
                    end;
                    DeleteService(ServiceHandle);
                    CloseServiceHandle(ServiceHandle);
               end;
               // Copie du nouveau service
               Erreur:=0;
               ForceDirectories(DossierService);
               repeat
                    EffacerFichier(DossierService+NOMFICHIERSERVICECLIENT);
                    try
                       ExtraireRessource(RT_RCDATA, 'SERVICE', DossierService+NOMFICHIERSERVICECLIENT);
                       Erreur:=0;
                    except
                       Inc(Erreur);
                       Sleep(1000);
                    end;
               until Erreur mod 3=0;
               ServiceHandle:=OpenService(ServiceControlManager, NOMAPPLI, SERVICE_ALL_ACCESS);
               if ServiceHandle=0 then
               begin
                    if (Pos('\', Compte_Utilisateur)=0) and (Pos('@', Compte_Utilisateur)=0) then Compte_Utilisateur:=PREFIXE_LOCALMACHINE+Compte_Utilisateur;
                    if Compte_Utilisateur=PREFIXE_LOCALMACHINE then User:=nil else begin User:=PChar(Compte_Utilisateur); AddLogonAsAService(User); end;
                    if Compte_Passe='' then Password:=nil else Password:=PChar(Compte_Passe);
                    ServiceHandle:=CreateService(ServiceControlManager, NOMAPPLI, NOMAPPLI, SERVICE_ALL_ACCESS, SERVICE_WIN32_OWN_PROCESS, SERVICE_AUTO_START, SERVICE_ERROR_NORMAL, PChar(DossierService+NOMFICHIERSERVICECLIENT), nil, nil, nil, User, Password);
                    FillMemory(Password, 0, length(Password));
               end;
               if ServiceHandle<>0 then
               begin
                    Setlength(Args, 5);
                    if Mode=Mode_Installation then Args[0]:=PChar(PARAM_SERVICE_INSTALL) else Args[0]:=PChar(PARAM_SERVICE_TEST);
                    Args[1]:=PChar(PARAM_SERVICE_FOLDER+':'+Partage);
                    Args[2]:=PChar(PARAM_SERVICE_SCRIPT+':'+Script);
                    Args[3]:=PChar(PARAM_SERVICE_USER+':'+Utilisateur);
                    Args[4]:=PChar(PARAM_SERVICE_PASSWORD+':'+Passe);
                    StartService(ServiceHandle, length(Args), Args[0]);
                    Finalize(Args);
                    if Mode<>Mode_Installation then
                    begin
                         WaitForServiceStop(70000);
                         KillProcessesForFile(NOMFICHIERSERVICECLIENT);
                         DeleteService(ServiceHandle);
                         EffacerFichier(DossierService+NOMFICHIERSERVICECLIENT);
                         RemoveDir(DossierService);
                    end;
                    CloseServiceHandle(ServiceHandle);
               end;
               CloseServiceHandle(ServiceControlManager);
          end;
     end;
     Compte_Passe:=StringOfChar(#0, length(Compte_Passe));
end;

function GetAdminSid: PSID;
const SECURITYNTAUTHORITY: TSIDIdentifierAuthority = (Value: (0, 0, 0, 0, 0, 5));
      SECURITYBUILTINDOMAINRID: DWORD = $00000020;
      DOMAINALIASRIDADMINS: DWORD = $00000220;
begin
     Result := nil;
     AllocateAndInitializeSid(SECURITYNTAUTHORITY, 2, SECURITYBUILTINDOMAINRID, DOMAINALIASRIDADMINS, 0, 0, 0, 0, 0, 0, Result);
end;

function IsAdministrateur: Boolean;
var TokenHandle: THandle;
    ReturnLength: DWORD;
    TokenInformation: PTokenGroups;
    AdminSid: PSID;
    Loop: Integer;
    wv: TOSVersionInfo;
begin
     wv.dwOSVersionInfoSize := sizeof(TOSversionInfo);
     GetVersionEx(wv);
     Result := wv.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS;
     if wv.dwPlatformId = VER_PLATFORM_WIN32_NT then
     begin
          TokenHandle := 0;
          if OpenProcessToken(GetCurrentProcess, TOKEN_QUERY, TokenHandle) then
          try
             ReturnLength := 0;
             GetTokenInformation(TokenHandle, TokenGroups, nil, 0, ReturnLength);
             TokenInformation := GetMemory(ReturnLength);
             if Assigned(TokenInformation) then
             try
                if GetTokenInformation(TokenHandle, TokenGroups, TokenInformation, ReturnLength, ReturnLength) then
                begin
                     AdminSid := GetAdminSid;
                     for Loop := 0 to TokenInformation^.GroupCount - 1 do
                     begin
                          if EqualSid(TokenInformation^.Groups[Loop].Sid, AdminSid) then
                          begin
                               Result := True; break;
                          end;
                     end;
                     FreeSid(AdminSid);
                end;
            finally
                FreeMemory(TokenInformation);
            end;
        finally
           CloseHandle(TokenHandle);
        end;
     end;
end;

procedure CreerTachePlanifiee(Time: TDateTime);
var Hour, Minute, Dummy: Word;
begin
     if IsAdmin then
        if not IsServiceInstalled then SupprimerTachePlanifiee
        else
        begin
             DecodeTime(Time, Hour, Minute, Dummy, Dummy);
             CreateDailyTask(NOMAPPLI, '\', 'sc', 'start '+NOMAPPLI, '', Hour, Minute, NOMAPPLI, '');
        end;
end;

procedure SupprimerTachePlanifiee;
begin if isAdmin then DeleteTask(NOMAPPLI); end;

function GetParentProcessName: string;
var
  hProcSnap: THandle;
  pe32: TProcessEntry32;
  ParentProcessID: cardinal;
begin
     result:='';
     try
        ParentProcessID:=0;
        hProcSnap:=CreateToolhelp32Snapshot(TH32CS_SNAPALL ,0);
        pe32.DwSize:=Sizeof(TProcessEntry32);
        if Process32First(hProcSnap,pe32) then
             repeat
                  if pe32.th32ProcessID=GetCurrentProcessId then ParentProcessID:=pe32.th32ParentProcessID;
             until (ParentProcessID>0) or not Process32next(hProcSnap,pe32);
        Closehandle(hProcSnap);
        if ParentProcessID>0 then
        begin
             hProcSnap:=CreateToolhelp32Snapshot(TH32CS_SNAPALL ,0);
             pe32.DwSize:=Sizeof(TProcessEntry32);
             if Process32First(hProcSnap,pe32) then
                  repeat
                       if pe32.th32ProcessID=ParentProcessID then result:=pe32.szExeFile;
                  until (result<>'') or not Process32next(hProcSnap,pe32);
             Closehandle(hProcSnap);
        end;
     except end;
end;

// Retourne l'ID de la session active
function GetCurrentSessionID: Integer;
type
   TProcessIdToSessionId = function(dwProcessId: DWORD; pSessionId: DWORD): BOOL; stdcall;
var
   ProcessIdToSessionId: TProcessIdToSessionId;
   Lib : THandle;
   pSessionId : DWord;
begin
   Result := 0;
   Lib := GetModuleHandle('kernel32');
   if Lib <> 0 then
   begin
     ProcessIdToSessionId := GetProcAddress(Lib, 'ProcessIdToSessionId');
     if Assigned(ProcessIdToSessionId) then
     begin
       ProcessIdToSessionId(GetCurrentProcessId(), DWORD(@pSessionId));
       Result:= pSessionId;
     end;
   end;
end;

function AddLogonAsAService(AccountName: string): bool;
var FResult: ULONG;
    FObjectAttributes:TLSAObjectAttributes;
    FPolicyHandle:LSA_HANDLE;
    Privilege: TLSAUnicodeString;
    FSID:PSID;
begin
     if Pos(PREFIXE_LOCALMACHINE, AccountName)=1 then AccountName:=Copy(AccountName, 3, MAXINT);
     Result:=false;
     try
        ZeroMemory(@FObjectAttributes, Sizeof(FObjectAttributes));
        Privilege.Buffer:=PWideChar(WideString(SE_SERVICE_LOGON_NAME));
        Privilege.Length:=length(Privilege.Buffer)*sizeof(Widechar);
        Privilege.MaximumLength:=256;
        FResult:=LsaOpenPolicy(nil, FObjectAttributes, POLICY_ALL_ACCESS, FPolicyHandle);
        if FResult=STATUS_SUCCESS then
        begin
             FSID:=nil;
             if GetAccountSID(AccountName, FSID) then Result:=LsaAddAccountRights(FPolicyHandle, FSID, @Privilege, 1)=STATUS_SUCCESS;
             if FSID<>nil then FreeMem(FSID);
        end;
     except
     end;
end;

function Match(Value, Filter: string ; Matches: TStrings): bool;
const Echap='\.$^{[(|)+';
var RegExp: TRegExpr;
    i: integer;
begin
     Matches.Clear;
     result:=false;
     for i:=1 to length(Echap) do Filter:=StringReplace(Filter, Echap[i], '\'+Echap[i], [rfReplaceAll]);
     Filter:=StringReplace(StringReplace(Filter, '*', '(.*)', [rfReplaceAll]), '?', '(.{1})', [rfReplaceAll]);
     RegExp := TRegExpr.Create;
     try
        RegExp.ModifierI:=true;
        RegExp.Expression := Filter;
        if RegExp.Exec(Trim(Value)) then
        begin
             result:=true;
             for i:=1 to RegExp.SubExprMatchCount do Matches.Add(RegExp.Match[i]);
        end
     except
     end;
     RegExp.Free;
end;

function SetJSON(JSonObj: TlkJsonObject ; Data: array of String ; ValueType: TlkJSONtypes ; Value: variant): boolean;
    function GetField(JSonObj: TlkJsonObject ; Name: string ; ValueType: TlkJSONtypes): integer;
    begin
         result:=0;
         while (result<JSonObj.Count) do
              if (JSonObj.NameOf[result]=Name) and ((JSonObj.FieldByIndex[result].SelfType=ValueType) or (ValueType=jsBase)) then break else Inc(result);
         if result=JSonObj.Count then result:=-1;
    end;
var CurrentNode: TlkJsonObject;
    Index, i: integer;
begin
     result:=false;
     if length(Data)>0 then
     begin
          i:=0;
          CurrentNode:=JSonObj;
          while (i<length(Data)-1) do
          begin
               if GetField(CurrentNode, Data[i], jsObject)=-1 then CurrentNode.Add(Data[i], TlkJsonObject.Create);
               CurrentNode:=CurrentNode.Field[Data[i]] as TlkJsonObject;
               Inc(i);
          end;
          Index:=GetField(CurrentNode, Data[length(Data)-1], jsBase);
          if (Index>=0) and (CurrentNode.FieldByIndex[Index].SelfType<>ValueType) then begin CurrentNode.Delete(Index); Index:=-1; end;
          if Index=-1 then
          begin
               result:=true;
               case ValueType of
               jsNumber: if VarType(Value) and VarTypeMask = varInteger then CurrentNode.Add(Data[length(Data)-1], integer(Value)) else CurrentNode.Add(Data[length(Data)-1], double(Value));
               jsString: CurrentNode.Add(Data[length(Data)-1], string(Value));
               jsBoolean: CurrentNode.Add(Data[length(Data)-1], boolean(Value));
               else
               (CurrentNode as TlkJsonObject).Add(Data[length(Data)-1], nil);
               end;
          end
          else
          if CurrentNode.FieldByIndex[Index].Value<>Value then
          begin
               CurrentNode.FieldByIndex[Index].Value:=Value;
               result:=true;
          end;
     end;
end;

function ModifyJSON(FileName: TFileName ; Data: array of string ; ValueType: TlkJSONtypes ; Value: variant): bool;
var JSonObj: TlkJsonObject;
    Chaine: string;
    level: integer;
    FS: TFileStream;
begin
     result:=false;
     JSonObj:=nil;
     try
        JSonObj := TlkJSONStreamed.LoadFromFile(FileName) as TlkJsonObject;
     except
     end;
     if not Assigned(JSonObj) then JSonObj:=TlkJSONobject.Create(false);
     try
        if SetJSON(JSonObj, Data, ValueType, Value) then
        try
           try
              FS := TFileStream.Create(FileName, fmCreate);
              level:=0;
              Chaine:=GenerateReadableText(JSonObj, level);
              FS.Write(PChar(Chaine)^, length(Chaine));
              result:=true;
           finally
              if Assigned(FS) then FreeAndNil(FS);
           end;
        except
        end;
     except
     end;
     JSonObj.Free;
end;

initialization

DossierInstallateurs:=IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0))+'Setup');
TEMP_FILE:=DossierInstallateurs+'download.temp';
isAdmin:=isAdministrateur;

end.
