unit Fonctions_AIR;

interface

uses Windows, SysUtils, Fonctions, Commun;

function TelechargerAIR: bool;
function InstallerAIR: bool;
procedure AIRAInstaller(var Version: string ; var Fichier: TFileName);

implementation

uses Principale, Journal, HTTPApp, Classes, Registry;

// Activer / Dsactiver mise  jour automatique AIR
procedure AIRUpdate(Enabled: bool);
var Info: TRegKeyInfo;
begin
     with TRegistry.Create do
     begin
          RootKey:=HKEY_LOCAL_MACHINE;
          if Enabled then
          begin
               if OpenKey('\Software\Policies\Adobe\AIR', false) then
               begin
                    DeleteValue('UpdateDisabled');
                    if GetKeyInfo(Info) then
                    begin
                         if Info.NumSubKeys+Info.NumValues=0 then DeleteKey('\Software\Policies\Adobe\AIR');
                    end;
                    CloseKey;
               end;
               if OpenKey('\Software\Policies\Adobe', false) and GetKeyInfo(Info) then
               begin
                    if Info.NumSubKeys+Info.NumValues=0 then DeleteKey('\Software\Policies\Adobe');
                    CloseKey;
               end;
          end
          else
            if OpenKey('\Software\Policies\Adobe\AIR', true) then WriteBool('UpdateDisabled', true);
          Free;
     end;
end;

// Renvoie la version de AIR installe
function VersionAIRInstalle: string;
var DLLAIR: string;
begin
     result:='0.0.0.0';
     DLLAIR:=RenvoiDossierCommonFiles+'Adobe AIR\Versions\1.0\Adobe AIR.dll';
     if not FileExists(DLLAIR) then DLLAIR:='';
     if DLLAIR<>'' then result:=GetVersion(DLLAIR);
end;

// Lit la version la plus rcente de AIR et le nom d'excutable associ parmi les excutables du dossier en cours
procedure AIRAInstaller(var Version: string ; var Fichier: TFileName);
begin GetFichier('AdobeAIRInstaller.exe', Version, Fichier); end;

// Tlchargement de Adobe AIR
function TelechargerAIR: bool;
//var FichierTemp: string;
begin
     result:=true;
     try
        EcrireFichierDebug('Adobe AIR : Tlchargement non pris en charge');
        {
        EcrireFichierDebug('Adobe AIR : Initialisation du tlchargement');
        EcrireFichierDebug('Adobe AIR : ');
        FichierTemp:=ExtractFileName(UnixPathToDosPath(ADOBE_AIR));
        with DownloadFileIfNewest(ADOBE_AIR, FichierTemp, false, TailleFichier(DossierInstallateurs+FichierTemp)) do
        begin
             if Code<=0 then
             begin
                  if Code<0 then EcrireFichierDebug('Adobe AIR : Installateur dj  jour', true)
                            else EcrireFichierDebug('Adobe AIR : Installateur mis  jour', true);
             end
             else
             begin
                  EcrireFichierDebug('Adobe AIR : Erreur '+inttostr(Code)+' ('+Message+')');
                  result:=false;
             end;
        end;
        EcrireFichierDebug('Adobe AIR : Termin');
        }
     except
        EcrireFichierDebug('Adobe AIR : Erreur');
        result:=false;
     end;
end;

function InstallerAIR: bool;
var Version, VersionInstallee: string;
    Fichier: TFileName;
    resultat: bool;
begin
     resultat:=false;
     result:=true;
     try
        // Recherche dans le dossier de l'excutable de la version la plus rcente de Adobe AIR + nom de fichier associ...'
        EcrireFichierDebug('Adobe AIR : Initialisation de l''installation');
        AIRAInstaller(Version, Fichier);
        if Version='' then EcrireFichierDebug('Adobe AIR : Installateur non trouv') else EcrireFichierDebug('Adobe AIR : Version '+Version +' trouve dans '+Fichier);
        // Si la version install d'Adobe AIR mrite une mise  jour alors on la lance...'
        VersionInstallee:=VersionAIRInstalle;
        if (CompareVersion(VersionInstallee, '0.0.0.0')=0) and Configuration.AIR.Installe then EcrireFichierDebug('Adobe AIR : Non install')
        else
        if CompareVersion(Version, VersionInstallee)>0 then
        begin
             if MODETEST then resultat:=true
             else
             begin
                  EcrireFichierDebug('Adobe AIR : Mise  jour');
                  LanceAppliAttenteFin('"'+DossierInstallateurs+Fichier+'" -silent', DossierInstallateurs);
             end;
        end else if Version<>'' then EcrireFichierDebug('Adobe AIR : Dj  jour');
        EcrireFichierDebug('Adobe AIR : Termin');
     except
        EcrireFichierDebug('Adobe AIR : Erreur');
        result:=false;
     end;

     if MODETEST then result:=resultat
     else
     // Mises  jour par Adobe AIR
     case Configuration.AIR.Update of
     1: AIRUpdate(false);
     2: AIRUpdate(true);
     end;       
end;

end.
