unit Fonctions_Firefox;

interface

uses Windows, SysUtils, WinInet, CRC32, Fonctions, Commun, uLkJSON;

function TelechargerFirefox: bool;
function InstallerFirefox: bool;

implementation

uses Principale, Journal, Classes, Registry, Math;

type TSizeObject = class(TObject)
       Valeur: cardinal;
     end;

(*$HINTS OFF*)
function HasANumber(S: string): bool;
var iCode, iValue: Integer;
begin
     val(s, iValue, iCode);
     result:=iCode = 0;
end;
(*$HINTS ON*)

function Firefox_GetExePath(Mode: TMode3264): string;
const DefaultRootPath='\SOFTWARE\Mozilla\Mozilla Firefox';
var RootPath, Cle: string;
    AAccess: integer;
begin
     result:='';
     if Mode=Mode32Bits then AAccess:=KEY_READ else AAccess:=KEY_READ or $0100;
     with TRegistry.Create(AAccess) do
     begin
          RootKey:=HKEY_LOCAL_MACHINE;
          RootPath:=DefaultRootPath;
          Cle:='';
          if Configuration.Firefox.ESR then RootPath:=RootPath+' ESR';
          if OpenKey(RootPath, false) then
          begin
               Cle:=ReadString('CurrentVersion');
               CloseKey;
          end;
          if (Cle<>'') and OpenKey(DefaultRootPath+'\'+Cle, false) and OpenKey('Main', false) then result:=ReadString('PathToExe');
          Free;
     end;
end;

function MaybeQuoted(S: string): string;
begin
     S:=Trim(S);
     if SameText(S, 'false') or SameText(S, 'true') or HasANumber(S) then result:=S else result:=QuotedStr(S);
end;

// Activer / Dsactiver mise  jour automatique Firefox
procedure FirefoxUpdateConfig(Mode: TMode3264);
const Fichier_JS_Nom='defaults\pref\channel-prefs.js';
      DefConf='mozilla.cfg';
      Tag_UpdateSoft=' // Gr par '+NOMAPPLI;
      Tag_1='pref("general.config.filename", "*");*';
      Tag_2='pref("general.config.obscure_value", 0);*';
var Fichier_JS, Fichier_CFG_Lu, Fichier_CFG_Lu_Temp, Fichier_CFG_AEcrire, Fichier_CFG_AEcrire_SansValeurs, Fichier_CFG_AAjouter, Temp: TStringList;
    Fichier_CFG_Nom, DossierFirefox: string;
    Fichier_JS_Modifie, Fichier_CFG_Modifie, Trouve: bool;
    AAccess, i, k: integer;
begin
     DossierFirefox:=ExtractFilePath(Firefox_GetExePath(Mode));
     if (DossierFirefox<>'') and DirectoryExists(DossierFirefox) then
     begin
          Fichier_CFG_AEcrire:=TStringList.Create;
          Fichier_CFG_AEcrire_SansValeurs:=TStringList.Create;
          Fichier_CFG_Lu:=TStringList.Create;
          Fichier_CFG_AAjouter:=TStringList.Create;
          Temp:=TStringList.Create;

          // 1. Cration du fichier de configuration  crire
          for i:=0 to length(Configuration.Firefox.Config)-1 do
          begin
               Fichier_CFG_AEcrire.Add('lockPref('+QuotedStr(Configuration.Firefox.Config[i].Key)+', '+MaybeQuoted(Configuration.Firefox.Config[i].Value)+');');
               Fichier_CFG_AEcrire_SansValeurs.Add('lockPref('+QuotedStr(Configuration.Firefox.Config[i].Key)+', *);*');

               if SameText(Configuration.Firefox.Config[i].Key, 'app.update.enabled') then
               begin
                    try
                       ForceDirectories(DossierFirefox+'distribution');
                       ModifyJSON(IncludeTrailingPathDelimiter(DossierFirefox+'distribution')+'policies.json', ['policies', 'DisableAppUpdate'], jsBoolean, SameText(Configuration.Firefox.Config[i].Value, 'false'));
                    except
                    end;
                    try
                       if Mode=Mode32Bits then AAccess:=KEY_ALL_ACCESS else AAccess:=KEY_ALL_ACCESS or $0100;
                       with TRegistry.Create(AAccess) do
                       try
                          RootKey:=HKEY_LOCAL_MACHINE;
                          if OpenKey('SOFTWARE\Policies\Mozilla\Firefox', true) then
                              if not ValueExists('DisableAppUpdate') or (ReadBool('DisableAppUpdate')<>SameText(Configuration.Firefox.Config[i].Value, 'false')) then WriteBool('DisableAppUpdate', SameText(Configuration.Firefox.Config[i].Value, 'false'));
                       finally
                          Free;
                       end;
                    except
                    end;
               end;
          end;

          // 2. Rcupration du chemin du fichier CFG (et criture du chemin dans le fichier JS s'il n'est pas prsent)
          Fichier_JS:=TStringList.Create;
          Fichier_CFG_Nom:=''; Fichier_JS_Modifie:=false;
          if FileExists(DossierFirefox+Fichier_JS_Nom) then try Fichier_JS.LoadFromFile(DossierFirefox+Fichier_JS_Nom); except end;
          Trouve:=false; i:=Fichier_JS.Count-1;
          while (i>=0) and not Trouve do
               if Match(Fichier_JS[i], Tag_1, Temp) and (Temp.Count>0) and FileExists(DossierFirefox+Temp[0]) then
               begin
                    Fichier_CFG_Nom:=Temp[0];
                    Trouve:=true;
               end
               else Dec(i);
          if not Trouve then
          begin
               Fichier_JS_Modifie:=true;
               Fichier_JS.Add(StringReplace(StringReplace(Tag_1, '*', DefConf, []), '*', Tag_UpdateSoft, []));
               Fichier_CFG_Nom:=DefConf;
          end;
          Trouve:=false; i:=Fichier_JS.Count-1;
          while (i>=0) and not Trouve do if Match(Fichier_JS[i], Tag_2, Temp) then Trouve:=true else Dec(i);
          if not Trouve then
          begin
               Fichier_JS_Modifie:=true;
               Fichier_JS.Add(StringReplace(Tag_2, '*', Tag_UpdateSoft, []));
          end;
          if Fichier_JS_Modifie then try try ForceDirectories(DossierFirefox+ExtractFilePath(Fichier_JS_Nom)); except end; Fichier_JS.SaveToFile(DossierFirefox+Fichier_JS_Nom); except end;
          Fichier_JS.Free;

          // 3. Lecture du fichier CFG
          if FileExists(DossierFirefox+Fichier_CFG_Nom) then try Fichier_CFG_Lu.LoadFromFile(DossierFirefox+Fichier_CFG_Nom); except end;

          // 4. Comparaison du fichier CFG avec le fichier de configuration  crire (sans tags) - pour compatibilit avec ancienne version d'UpdateSoft - suppression du CFG si identique
          if FileExists(DossierFirefox+Fichier_CFG_Nom) then
          begin
               Fichier_CFG_Lu_Temp:=TStringList.Create;
               Fichier_CFG_Lu_Temp.AddStrings(Fichier_CFG_Lu);
               i:=0;
               while (i<Fichier_CFG_Lu_Temp.Count) do if (Trim(Fichier_CFG_Lu_Temp[i])='') or (Fichier_CFG_AEcrire.IndexOf(Fichier_CFG_Lu_Temp[i])<>-1) then Fichier_CFG_Lu_Temp.Delete(i) else Inc(i);
               if Fichier_CFG_Lu_Temp.Count=0 then DeleteFile(DossierFirefox+Fichier_CFG_Nom);
               Fichier_CFG_Lu_Temp.Free;
          end;

          // 5. Ecriture du fichier de configuration (avec tags)
          for i:=0 to Fichier_CFG_AEcrire.Count-1 do Fichier_CFG_AEcrire[i]:=Trim(Fichier_CFG_AEcrire[i])+Tag_UpdateSoft;

          Fichier_CFG_Modifie:=false;
          for i:=Fichier_CFG_Lu.Count-1 downto 0 do
          begin
               // Recherche des entres dj ajoutes par UpdateSoft
               if Match(Fichier_CFG_Lu[i], '*'+Trim(Tag_UpdateSoft), Temp) then
               begin
                    k:=Fichier_CFG_AEcrire.IndexOf(Fichier_CFG_Lu[i]);
                    if k=-1 then
                    begin
                         // Si l'entre n'est plus d'actualit, on la supprime
                         Fichier_CFG_Lu.Delete(i);
                         Fichier_CFG_Modifie:=true;
                    end
                    else
                    begin
                         // Si l'entre est valable, on n'en tient plus compte
                         Fichier_CFG_AEcrire.Delete(k);
                         Fichier_CFG_AEcrire_SansValeurs.Delete(k);
                    end;
               end
               else
               if Trim(Fichier_CFG_Lu[i])<>'' then
               begin
                    // Recherche si l'entre qui n'tait pas dj ajoute par UpdateSoft correspond  une entre prise en charge
                    Trouve:=false; k:=0;
                    while not Trouve and (k<Fichier_CFG_AEcrire_SansValeurs.Count) do
                    if Match(Fichier_CFG_Lu[i], Fichier_CFG_AEcrire_SansValeurs[k], Temp) then
                    begin
                         // Si c'est le cas, on l'ajoutera en fin de fichier, en surcharge
                         Fichier_CFG_AAjouter.Add(Fichier_CFG_AEcrire[k]); Trouve:=true;
                         Fichier_CFG_AEcrire.Delete(k);
                         Fichier_CFG_AEcrire_SansValeurs.Delete(k);
                    end else Inc(k);
               end;
          end;
          if Fichier_CFG_AEcrire.Count>0 then
          begin
               Fichier_CFG_Modifie:=true;
               Fichier_CFG_Lu.AddStrings(Fichier_CFG_AEcrire);
          end;
          if Fichier_CFG_AAjouter.Count>0 then
          begin
               Fichier_CFG_Modifie:=true;
               Fichier_CFG_Lu.AddStrings(Fichier_CFG_AAjouter);
          end;
          if Fichier_CFG_Modifie or not FileExists(DossierFirefox+Fichier_CFG_Nom) then try try ForceDirectories(DossierFirefox+ExtractFilePath(Fichier_CFG_Nom)); except end; Fichier_CFG_Lu.SaveToFile(DossierFirefox+Fichier_CFG_Nom); except end;

          Fichier_CFG_AEcrire_SansValeurs.Free;
          Fichier_CFG_AAjouter.Free;
          Fichier_CFG_AEcrire.Free;
          Fichier_CFG_Lu.Free;
          Temp.Free;
     end;
end;

// Renvoie la version de Firefox installe
function VersionFirefoxInstalle(Mode: TMode3264): string;
var ExecutableFirefox: string;
begin
     ExecutableFirefox:=Firefox_GetExePath(Mode); result:='0.0.0.0'; 
     if ExecutableFirefox<>'' then
     begin
          if not FileExists(ExecutableFirefox) then ExecutableFirefox:='';
          if ExecutableFirefox<>'' then result:=GetVersion(ExecutableFirefox, true);
     end;
end;

// Lit la version la plus rcente de Firefox et le nom d'excutable associ parmi les excutables du dossier en cours
procedure FirefoxAInstaller(var Version: string ; var Fichier: TFileName ; Mode: TMode3264);
begin
     GetFichier(MOZILLA_FIREFOX_FILTER, Version, Fichier, 'setup.exe', Configuration.Firefox.ESR, false, Mode);
//     if (Fichier='') and not Configuration.Firefox.ESR then GetFichier(MOZILLA_FIREFOX_FILTER, Version, Fichier, 'setup.exe', true, false, Mode);
end;

function CompareTailles(List: TStringList; Index1, Index2: Integer): Integer;
begin
     result:=CompareValue(TSizeObject(List.Objects[Index1]).Valeur, TSizeObject(List.Objects[Index2]).Valeur);
end;

function TelechargerFirefox: bool;
var Version, URL: string;
    Fichier: TFileName;
    LeMode: TMode3264;
begin
     RenommerAnciensInstallateurs(MOZILLA_FIREFOX_FILTER);

     result:=true;
     for LeMode:=Mode32bits to Mode64bits do
         if ((Configuration.Firefox.Modules in [0, 2]) and (LeMode=Mode32bits)) or ((Configuration.Firefox.Modules in [1, 2]) and (LeMode=Mode64bits)) then
         try
            // Extraction de la DLL si elle n'existe pas
            ExtraireRessource(RT_RCDATA, '7zip_library', ExtractFilePath(ParamStr(0))+'7z.dll');
            // On tlcharge la dernire mise  jour de Firefox
            EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Initialisation du tlchargement');
            EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : ');
            FirefoxAInstaller(Version, Fichier, LeMode);
            if LeMode=Mode32bits then
                 if not Configuration.Firefox.ESR then URL:=MOZILLA_FIREFOX_HTTP else URL:=MOZILLA_FIREFOX_ESR_HTTP
            else
                 if not Configuration.Firefox.ESR then URL:=MOZILLA_FIREFOX64_HTTP else URL:=MOZILLA_FIREFOX64_ESR_HTTP;
            with DownloadFileIfNewest(URL, MOZILLA_FIREFOX_FILTER, false, TailleFichier(DossierInstallateurs+Fichier), true, Suffixe(LeMode)) do
            begin
                 if Code<=0 then
                 begin
                      if Code<0 then EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Installateur dj  jour', true)
                                else EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Installateur mis  jour', true);
                 end
                 else
                 begin
                      EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Erreur '+inttostr(Code)+' ('+Message+')');
                      result:=false;
                 end;
            end;
            EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Termin');
         except
            EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Erreur');
            result:=false;
         end;
end;

function InstallerFirefox: bool;
var Version, VersionInstallee: string;
    LeMode: TMode3264;
    Fichier: TFileName;
    resultat: bool;
begin
     resultat:=false;
     result:=true;
     for LeMode:=Mode32bits to Mode64bits do
         if ((Configuration.Firefox.Modules in [0, 2]) and (LeMode=Mode32bits)) or ((Configuration.Firefox.Modules in [1, 2]) and (LeMode=Mode64bits)) then
              if not ((LeMode=Mode64bits) and not IAmIn64Bits) then
              try
                 // Extraction de la DLL si elle n'existe pas
                 ExtraireRessource(RT_RCDATA, '7zip_library', ExtractFilePath(ParamStr(0))+'7z.dll');
                 // Recherche dans le dossier de l'excutable de la version la plus rcente de Firefox + nom de fichier associ...'
                 EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Initialisation de l''installation');
                 FirefoxAInstaller(Version, Fichier, LeMode);
                 if Version='' then EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Installateur non trouv') else EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Version '+Version +' trouve dans '+Fichier);
                 // Si la version install de Firefox mrite une mise  jour alors on la lance...'
                 VersionInstallee:=VersionFirefoxInstalle(LeMode);
                 if (CompareVersion(VersionInstallee, '0.0.0.0')=0) and Configuration.Firefox.Installe then EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Non install')
                 else
                 if CompareVersion(Version, VersionFirefoxInstalle(LeMode))>0 then
                 begin
                      if MODETEST then resultat:=true
                      else
                      begin
                           EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Mise  jour');
                           LanceAppliAttenteFin('"'+DossierInstallateurs+Fichier+'" /S', DossierInstallateurs, false, IfThen(Configuration.General.Stopper_Installation, Configuration.General.Stopper_Installation_Minutes*60*1000, INFINITE));
                      end;
                 end else if Version<>'' then EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Dj  jour');
                 EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Termin');
              except
                 EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Erreur');
                 result:=false;
              end
              else EcrireFichierDebug('Firefox'+Suffixe(LeMode)+' : Systme non compatible');

     if MODETEST then result:=resultat
     else
     // Mises  jour de la configuration de Firefox
     begin
          if Configuration.Firefox.Modules in [0, 2] then FirefoxUpdateConfig(Mode32bits);
          if Configuration.Firefox.Modules in [1, 2] then FirefoxUpdateConfig(Mode64bits);
     end;
end;

end.


