unit Fonctions_Flash;

interface

uses Windows, SysUtils, Commun, TaskScheduler;

function TelechargerFlash: bool;
function InstallerFlash: bool;

implementation

uses Principale, Journal, Fonctions, Classes, HTTPApp, Registry, Math;

function GetSystemWow64Directory(lpBuffer:LPTSTR;uSize:Uint):uint; stdcall; external 'Kernel32.dll' name 'GetSystemWow64DirectoryA';

// Activer / Dsactiver mise  jour automatique Flash
procedure FlashUpdate(Enabled: bool);
     function GetSys64Dir: string;
     var Buffer: array[0..MAX_PATH] of Char;
     begin Result:=''; if GetSystemWow64Directory(Buffer, MAX_PATH)<>0 then Result:=IncludeTrailingBackslash(string(Buffer)); end;
     function GetSystemDir: string;
     var Buffer: array[0..MAX_PATH] of Char;
     begin if GetSystemDirectory(Buffer, MAX_PATH)<>0 then Result:=IncludeTrailingBackslash(String(Buffer)); end;
const SubDir = 'Macromed\Flash';
      Tag_1='AutoUpdateDisable=1';
      Tag_2='SilentAutoUpdateEnable=0';
      UnTag_1='AutoUpdateDisable=0';
      UnTag_2='SilentAutoUpdateEnable=1';
      Conf='mms.cfg';
      Job='Adobe Flash Player Updater';
var Dossier, FichierJOB_ON, FichierJOB_OFF: string;
    procedure Patcher(Fichier: string);
    var Liste: TStringList;
        Modifie: bool;
    begin
         Liste:=TStringList.Create;
         Fichier:=Dossier+Conf;
         Modifie:=false;
         if FileExists(Fichier) then
         begin
              Liste.LoadFromFile(Fichier);
              Liste.CaseSensitive:=false;
              if not Enabled then
              begin
                   if (Liste.IndexOf(Tag_1)=-1) or (Liste.IndexOf(Tag_2)=-1) then
                   begin Liste.Clear; Liste.Add(Tag_1); Liste.Add(Tag_2); Modifie:=true; end;
              end
              else
              begin
                   if (Liste.IndexOf(Tag_1)<>-1) or (Liste.IndexOf(Tag_2)<>-1) then
                   begin Liste.Clear; Liste.Add(UnTag_1); Liste.Add(UnTag_2); Modifie:=true; end;
              end;
         end
         else
         if not Enabled then
         begin
              Liste.Add(Tag_1);
              Liste.Add(Tag_2);
              Modifie:=true;
         end;
         if Modifie then Liste.SaveToFile(Fichier);
         Liste.Free;
    end;
begin
     Dossier:=GetSys64Dir;
     if Dossier<>'' then
     begin
          Dossier:=IncludeTrailingBackslash(Dossier+SubDir);
          if DirectoryExists(Dossier) then Patcher(Dossier+Conf);
     end;
     DisableWowRedirection;
     Dossier:=IncludeTrailingBackslash(GetSystemDir+SubDir);
     if DirectoryExists(Dossier) then Patcher(Dossier+Conf);
     RevertWowRedirection;
     FichierJOB_ON:=IncludeTrailingPathDelimiter(RenvoiDossierWindows+'Tasks')+Job+'.job';
     FichierJOB_OFF:=ChangeFileExt(FichierJOB_ON, '.~job');
     if not FileExists(FichierJOB_ON) and FileExists(FichierJOB_OFF) then RenommerFichier(FichierJOB_OFF, FichierJOB_ON);
     EffacerFichier(FichierJOB_OFF);
     EnableTask(Job, '\', Enabled);
end;

// Lit la version la plus rcente de Flash ActiveX et le nom d'excutable associ parmi les excutables du dossier en cours
procedure FlashActiveXAInstaller(var Version: string ; var Fichier: TFileName);
begin GetFichier('install_flash_player_*active_x.exe', Version, Fichier); end;

// Lit la version la plus rcente de Flash Plugin et le nom d'excutable associ parmi les excutables du dossier en cours
procedure FlashPluginAInstaller(var Version: string ; var Fichier: TFileName);
begin GetFichier('install_flash_player_*plugin.exe', Version, Fichier); end;

// Renvoie la version de Flash ActiveX
function VersionFlashActiveXInstalle: string;
begin
     result:='0.0.0.0';
     with TRegistry.Create(KEY_READ) do
     begin
          RootKey:=HKEY_LOCAL_MACHINE;
          if OpenKey('\SOFTWARE\Macromedia\FlashPlayerActiveX', false) then
             result:=ReadString('Version');
          CloseKey;
          Free;
     end;
end;

// Renvoie la version de Flash Plugin
function VersionFlashPluginInstalle: string;
begin
     result:='0.0.0.0';
     with TRegistry.Create(KEY_READ) do
     begin
          RootKey:=HKEY_LOCAL_MACHINE;
          if OpenKey('\SOFTWARE\Macromedia\FlashPlayerPlugin', false) then
             result:=ReadString('Version');
          CloseKey;
          Free;
     end;
end;

function TelechargerFlash: bool;
{const LabelFlash : array [0..1] of string=('ActiveX', 'Plugin');
      LienFlash: array [0..1] of string=(ADOBE_FLASH_IE, ADOBE_FLASH_PLUGIN);
      FichierTemp_: array [0..1] of string=('install_flash_player_active_x.exe', 'install_flash_player_plugin.exe');
var i: integer;}
begin
     result:=true;
     try
        // On tlcharge les dernires mises  jour de Flash (ActiveX & Plugin)
        EcrireFichierDebug('Adobe Flash : Tlchargement non pris en charge');
        {
        EcrireFichierDebug('Adobe Flash : Initialisation du tlchargement');
        for i:=0 to 1 do
        if ((i=0) and (Configuration.Flash.Modules in [0, 2]) )or ((i=1) and (Configuration.Flash.Modules in [1, 2])) then
        begin
             EcrireFichierDebug('Adobe Flash ('+LabelFlash[i]+') : ');
             with DownloadFileIfNewest(LienFlash[i], FichierTemp_[i], false, TailleFichier(DossierInstallateurs+FichierTemp_[i])) do
             begin
                  if Code<=0 then
                  begin
                       if Code<0 then EcrireFichierDebug('Adobe Flash ('+LabelFlash[i]+') : Installateur dj  jour', true)
                                 else EcrireFichierDebug('Adobe Flash ('+LabelFlash[i]+') : Installateur mis  jour', true);
                  end
                  else
                  begin
                       EcrireFichierDebug('Adobe Flash ('+LabelFlash[i]+') : Erreur '+inttostr(Code)+' ('+Message+')');
                       result:=false;
                  end;
             end;
        end;
        EcrireFichierDebug('Adobe Flash : Termin');
        }
     except
        EcrireFichierDebug('Adobe Flash : Erreur');
        result:=false;
     end;
end;

function InstallerFlash: bool;
var VersionWindows, Version, VersionInstallee: string;
    Fichier: TFileName;
    resultat: bool;
begin
     resultat:=false;
     result:=true;
     if Configuration.Flash.Modules in [0, 2] then
     try
        // Recherche dans le dossier de l'excutable de la version la plus rcente de Flash ActiveX + nom de fichier associ
        EcrireFichierDebug('Adobe Flash (ActiveX) : Initialisation de l''installation');
        VersionWindows:=inttostr(LO(Windows.GetVersion))+'.'+inttostr(HI(Windows.GetVersion));
        if CompareVersion(VersionWindows, '6.2')<0 then
        begin
             FlashActiveXAInstaller(Version, Fichier);
             if Version=''  then EcrireFichierDebug('Adobe Flash (ActiveX) : Installateur non trouv') else EcrireFichierDebug('Adobe Flash (ActiveX) : Version '+Version+' trouve dans '+Fichier);
             // Si la version install de Flash ActiveX mrite une mise  jour alors on la lance
             VersionInstallee:=VersionFlashActiveXInstalle;
             if (CompareVersion(VersionInstallee, '0.0.0.0')=0) and Configuration.Flash.Installe then EcrireFichierDebug('Adobe Flash (ActiveX) : Non install')
             else
             if CompareVersion(Version, VersionInstallee)>0 then
             begin
                  EcrireFichierDebug('Adobe Flash (ActiveX) : Mise  jour');
                  if MODETEST then resultat:=true else LanceAppliAttenteFin('"'+DossierInstallateurs+Fichier+'" -install', DossierInstallateurs, false, IfThen(Configuration.General.Stopper_Installation, Configuration.General.Stopper_Installation_Minutes*60*1000, INFINITE));
             end else if Version<>'' then EcrireFichierDebug('Adobe Flash (ActiveX) : Dj  jour');
        end
        else EcrireFichierDebug('Adobe Flash (ActiveX) : Gr par le systme d''exploitation');
        EcrireFichierDebug('Adobe Flash (ActiveX) : Termin');
     except
        EcrireFichierDebug('Adobe Flash (ActiveX) : Erreur');
        result:=false;
     end;

     if Configuration.Flash.Modules in [1, 2] then
     try
        // Recherche dans le dossier de l'excutable de la version la plus rcente de Flash Plugin + nom de fichier associ
        EcrireFichierDebug('Adobe Flash (Plugin) : Initialisation de l''installation');
        FlashPluginAInstaller(Version, Fichier);
        if Version='' then EcrireFichierDebug('Adobe Flash (Plugin) : Installateur non trouv') else EcrireFichierDebug('Adobe Flash (Plugin) : Version '+Version+' trouve dans '+Fichier);
        // Si la version install de Flash Plugin mrite une mise  jour alors on la lance
        VersionInstallee:=VersionFlashPluginInstalle;
        if (CompareVersion(VersionInstallee, '0.0.0.0')=0) and Configuration.Flash.Installe then EcrireFichierDebug('Adobe Flash (Plugin) : Non install')
        else
        if CompareVersion(Version, VersionInstallee)>0 then
        begin
             EcrireFichierDebug('Adobe Flash (Plugin) : Mise  jour');
             if MODETEST then resultat:=true else LanceAppliAttenteFin('"'+DossierInstallateurs+Fichier+'" -install', DossierInstallateurs, false, IfThen(Configuration.General.Stopper_Installation, Configuration.General.Stopper_Installation_Minutes*60*1000, INFINITE));
        end else if Version<>'' then EcrireFichierDebug('Adobe Flash (Plugin) : Dj  jour');
        EcrireFichierDebug('Adobe Flash (Plugin) : Termin');
     except
        EcrireFichierDebug('Adobe Flash (Plugin) : Erreur');
        result:=false;
     end;

     if MODETEST then result:=resultat
     else
     begin
          // Mises  jour par Flash
          case Configuration.Flash.Update of
          1: FlashUpdate(false);
          2: FlashUpdate(true);
          end;
     end;
end;

end.
