unit Fonctions_Index_Education;

interface

uses Windows, SysUtils, WinInet, CRC32, Fonctions, Commun, uLkJSON, DateUtils, Winsvc, IniFiles;

{$DEFINE NO_ISS}

{$IFNDEF NO_ISS}
     {$R Ressource_Index_Education.RES}
{$ENDIF}

function TelechargerIndex_Education: bool;
function InstallerIndex_Education: bool;

implementation

uses Principale, Journal, Classes, Registry, Math, StrUtils;

type TLogiciel = (IE_Pronote, IE_EDT);

const Logiciel_Exename : array[TLogiciel] of string= ('Client Pronote', 'Client EDT');
      Logiciel_URI : array[TLogiciel] of string=('pronote', 'edt');

// Activer / Dsactiver mise  jour automatique Firefox
procedure Index_EducationUpdateConfig;
var ServiceControlManager, ServiceHandle: SC_Handle;
    lpServiceConfig: PQueryServiceConfigA;
    nSize, nBytesNeeded: cardinal;
    ServiceStatus: TServiceStatus;
    dummy: PAnsiChar;
begin
     ServiceControlManager:=OpenSCManager('', nil, STANDARD_RIGHTS_REQUIRED or SC_MANAGER_CREATE_SERVICE);
     if ServiceControlManager<>0 then
     begin
          ServiceHandle:=OpenService(ServiceControlManager, 'MajIndexEducationService', SERVICE_ALL_ACCESS);
          if ServiceHandle<>0 then
          try
             QueryServiceConfig(ServiceHandle, nil, 0, nSize);
             lpServiceConfig := AllocMem(nSize);
             try
                if QueryServiceConfig(ServiceHandle, lpServiceConfig, nSize, nBytesNeeded) and QueryServiceStatus(ServiceHandle, ServiceStatus) then
                begin
                     if ((lpServiceConfig.dwStartType=SERVICE_DISABLED) or (ServiceStatus.dwCurrentState<>SERVICE_RUNNING)) and not Configuration.Index_Education.Update then
                     begin
                          ChangeServiceConfig(ServiceHandle, SERVICE_NO_CHANGE, SERVICE_AUTO_START, SERVICE_NO_CHANGE, nil, nil, nil, nil, nil, nil, nil);
                          if ServiceStatus.dwCurrentState<>SERVICE_RUNNING then begin dummy:=nil; StartService(ServiceHandle, 0, dummy); end;
                     end
                     else
                     if ((lpServiceConfig.dwStartType<>SERVICE_DISABLED) or (ServiceStatus.dwCurrentState<>SERVICE_STOPPED)) and Configuration.Index_Education.Update then
                     begin
                          if ServiceStatus.dwCurrentState<>SERVICE_STOPPED then ControlService(ServiceHandle, SERVICE_CONTROL_STOP, ServiceStatus);
                          ChangeServiceConfig(ServiceHandle, SERVICE_NO_CHANGE, SERVICE_DISABLED, SERVICE_NO_CHANGE, nil, nil, nil, nil, nil, nil, nil);
                     end;
                end;
             finally
                Dispose(lpServiceConfig);
             end;
          except
          end;
          CloseServiceHandle(ServiceHandle);
     end;
     CloseServiceHandle(ServiceControlManager);
end;

// Renvoie le dossier d'installation
function GetPath(Logiciel: TLogiciel ; Mode: TMode3264): string;
begin
     if Logiciel=IE_Pronote then
        if Mode=Mode32bits then result:=Configuration.Index_Education.Dossier_Pronote32 else result:=Configuration.Index_Education.Dossier_Pronote64
     else
        if Mode=Mode32bits then result:=Configuration.Index_Education.Dossier_EDT32 else result:=Configuration.Index_Education.Dossier_EDT64;
end;

// Renvoie la version de Firefox installe
function VersionIndex_EducationInstalle(Logiciel: TLogiciel ; Mode: TMode3264): string;
var ExecutableIndex_Education: string;
begin
     if Logiciel=IE_Pronote then ExecutableIndex_Education:='Client Pronote.exe' else ExecutableIndex_Education:='Client EDT.exe';
     ExecutableIndex_Education:=IncludeTrailingPathDelimiter(GetPath(Logiciel, Mode))+ExecutableIndex_Education;
     result:='0.0.0.0';
     if ExecutableIndex_Education<>'' then
     begin
          if not FileExists(ExecutableIndex_Education) then ExecutableIndex_Education:='';
          if ExecutableIndex_Education<>'' then result:=GetVersion(ExecutableIndex_Education, true);
     end;
end;

// Lit la version la plus rcente de Firefox et le nom d'excutable associ parmi les excutables du dossier en cours
procedure Index_EducationAInstaller(var Version: string ; var Fichier: TFileName ; Logiciel: TLogiciel ; Mode: TMode3264);
var ExecutableIndex_Education: string;
begin
     if Logiciel=IE_Pronote then ExecutableIndex_Education:='Client Pronote' else ExecutableIndex_Education:='Client EDT';
     GetFichier(ExecutableIndex_Education+Suffixe(Mode)+'.exe', Version, Fichier);
end;

// Tlchargement des produits Index Education
function TelechargerIndex_Education: bool;
var Version, VersionTelechargee, URL: string;
    Fichier: TFileName;
    i: integer; 
    LeMode: TMode3264;
    LeLogiciel: TLogiciel;
    MillesimeInstallateur, Millesime: word;
    MemoryStream: TMemoryStream;
    JSonObj: TlkJsonObject;
    JSONOK: bool;
    VersionData: TEXEVersionData;
begin
     result:=true;
     if (MonthOf(Now)>8) or ((MonthOf(Now)=8) and (DaysInMonth(Now)>=15)) then Millesime:=YearOf(Now) else Millesime:=YearOf(Now)-1;
     for LeLogiciel:=IE_Pronote to IE_EDT do
          if ((Configuration.Index_Education.Logiciels in [0, 2]) and (LeLogiciel=IE_Pronote)) or ((Configuration.Index_Education.Logiciels in [1, 2]) and (LeLogiciel=IE_EDT)) then
            try
               for LeMode:=Mode32bits to Mode64bits do
                    if ((Configuration.Index_Education.Modules in [0, 2]) and (LeMode=Mode32bits)) or ((Configuration.Index_Education.Modules in [1, 2]) and (LeMode=Mode64bits)) then
                    begin
                         // Extraction des DLL si elles n'existent pas
                         if not FileExists(ExtractFilePath(ParamStr(0))+'libeay32.dll') then try ExtraireRessource(RT_RCDATA, 'libeay32', ExtractFilePath(ParamStr(0))+'libeay32.dll'); except end;
                         if not FileExists(ExtractFilePath(ParamStr(0))+'ssleay32.dll') then try ExtraireRessource(RT_RCDATA, 'ssleay32', ExtractFilePath(ParamStr(0))+'ssleay32.dll'); except end;
                         
                         // Rcupration de la dernire version et de l'URL de tlchargement
                         MemoryStream:=TMemoryStream.Create;
                         EcrireFichierDebug(Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+' : Initialisation du tlchargement');
                         DownloadStream(INDEX_EDUCATION_HTTP+'composant=client&lg=fr&produit='+Logiciel_URI[LeLogiciel]+'&millesime='+inttostr(Millesime)+'&VersionBits=-'+inttostr(IfThen(LeMode=Mode64bits, 64, 32)), MemoryStream, Configuration.General.Proxy, Configuration.General.Proxy_Adresse, 100*1024, DEFAULT_CONNECT_TIMEOUT, false, '', nil, true);
                         MemoryStream.Position:=0;
                         JSonObj:=nil;
                         try
                            JSonObj := TlkJSONStreamed.LoadFromStream(MemoryStream) as TlkJsonObject;
                         except
                         end;
                         Version:='';
                         URL:='';
                         if Assigned(JSonObj) then
                         begin
                              Version:=JSonObj.Field['Version'].Value;
                              URL:=JSonObj.Field['Fichier'].Value;
                              JSonObj.Free;
                              JSONOK:=true;
                         end
                         else
                         begin
                              EcrireFichierDebug(Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+' : Echec de lecture du fichier JSON d''informations');
                              result:=false;
                              JSONOK:=false;
                         end;
                         MemoryStream.Free;
                         if JSONOK then
                         begin
                              Index_EducationAInstaller(VersionTelechargee, Fichier, LeLogiciel, LeMode);
                              // Vrification du millsime
                              if GetEXEVersionData(DossierInstallateurs+Fichier, VersionData) then
                              begin
                                   for i:=1 to length(VersionData.FileDescription) do if StrToIntDef(VersionData.FileDescription[i], -1)=-1 then VersionData.FileDescription[i]:=' ';
                                   VersionData.FileDescription:=Trim(VersionData.FileDescription);
                                   if length(VersionData.FileDescription)=4 then MillesimeInstallateur:=StrToIntDef(VersionData.FileDescription, 0) else MillesimeInstallateur:=0;
                                   if MillesimeInstallateur>0 then VersionTelechargee:=inttostr(MillesimeInstallateur)+'.'+Copy(VersionTelechargee, 1, PosEx('.', VersionTelechargee, PosEx('.', VersionTelechargee, Pos('.', VersionTelechargee)+1)+1)-1);
                              end;
                              if (Version<>'') and (URL<>'') and (CompareVersion(Version, VersionTelechargee)>0) then
                              begin
                                   EcrireFichierDebug(Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+' : ');
                                   if DownloadFile(URL, DossierInstallateurs+Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+'.exe', Configuration.General.Proxy, Configuration.General.Proxy_Adresse, GetRemoteFileSize(URL, Configuration.General.Proxy, Configuration.General.Proxy_Adresse), DEFAULT_CONNECT_TIMEOUT, true, FicheJournal.Journal.Lines[FicheJournal.Journal.Lines.Count-1], nil, true)>0 then
                                      EcrireFichierDebug(Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+' : Installateur mis  jour version '+Version, true)
                                   else
                                   begin
                                        EcrireFichierDebug(Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+' : Erreur', true);
                                        result:=false;
                                   end;
                              end
                              else
                              EcrireFichierDebug(Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+' : Installateur dj  jour', true)
                         end;
                    end;
               except
               end;
end;

// Installation des produits Index Education
function InstallerIndex_Education: bool;
var LeMode: TMode3264;
    LeLogiciel: TLogiciel;
    i: integer;
    MillesimeInstallateur: word;
    VersionTelechargee: string;
    Fichier: TFileName;
    resultat: bool;
    VersionData: TEXEVersionData;
    {$IFNDEF NO_ISS}
    DossierTemp, GUID: string;
    SL: TStringList;
    {$ENDIF}
begin
     resultat:=false;
     result:=true;
     for LeLogiciel:=IE_Pronote to IE_EDT do
          if ((Configuration.Index_Education.Logiciels in [0, 2]) and (LeLogiciel=IE_Pronote)) or ((Configuration.Index_Education.Logiciels in [1, 2]) and (LeLogiciel=IE_EDT)) then
            try
               for LeMode:=Mode32bits to Mode64bits do
                    if ((Configuration.Index_Education.Modules in [0, 2]) and (LeMode=Mode32bits)) or ((Configuration.Index_Education.Modules in [1, 2]) and (LeMode=Mode64bits)) then
                    begin
                        if not ((LeMode=Mode64bits) and not IAmIn64Bits) then
                        try
                           Index_EducationAInstaller(VersionTelechargee, Fichier, LeLogiciel, LeMode);
                           if GetEXEVersionData(DossierInstallateurs+Fichier, VersionData) then
                           begin
                                for i:=1 to length(VersionData.FileDescription) do if StrToIntDef(VersionData.FileDescription[i], -1)=-1 then VersionData.FileDescription[i]:=' ';
                                VersionData.FileDescription:=Trim(VersionData.FileDescription);
                                if length(VersionData.FileDescription)=4 then MillesimeInstallateur:=StrToIntDef(VersionData.FileDescription, 0) else MillesimeInstallateur:=0;
                                if MillesimeInstallateur>0 then VersionTelechargee:=inttostr(MillesimeInstallateur)+'.'+Copy(VersionTelechargee, 1, PosEx('.', VersionTelechargee, PosEx('.', VersionTelechargee, Pos('.', VersionTelechargee)+1)+1)-1);
                           end;
                           if CompareVersion(VersionTelechargee, VersionIndex_EducationInstalle(LeLogiciel, LeMode))>0 then
                           begin
                                if GetPath(LeLogiciel, LeMode)<>'' then
                                begin
                                     if MODETEST then resultat:=true
                                     else
                                     begin
                                          {$IFDEF NO_ISS}
                                          if Configuration.Index_Education.Logiciels in [0..2] then KillProcessesForFile(Logiciel_Exename[IE_Pronote]+'.exe');
                                          if Configuration.Index_Education.Logiciels in [1..2] then KillProcessesForFile(Logiciel_Exename[IE_EDT]+'.exe');
                                          EcrireFichierDebug(Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+' : Mise  jour');
                                          SetEnvironmentVariable('INDEX_IS_AGENT', '1');
                                          SetEnvironmentVariable('INDEX_IS_PATHEXE', PChar(GetPath(LeLogiciel, LeMode)));
                                          LanceAppliAttenteFin('"'+DossierInstallateurs+Fichier+'" /hide_splash /hide_progress', DossierInstallateurs);
                                          {$ELSE}
                                          if Configuration.Index_Education.Logiciels in [0..2] then KillProcessesForFile(Logiciel_Exename[IE_Pronote]+'.exe');
                                          if Configuration.Index_Education.Logiciels in [1..2] then KillProcessesForFile(Logiciel_Exename[IE_EDT]+'.exe');
                                          EcrireFichierDebug(Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+' : Mise  jour');
                                          DossierTemp:=RenvoiDossierTemp(true);
                                          LanceAppliAttenteFin('"'+DossierInstallateurs+Fichier+'" -extract_all:"'+DossierTemp+'"', DossierInstallateurs);
                                          with TIniFile.Create(DossierTemp+'Disk1\setup.ini') do
                                          begin
                                               GUID:=ReadString('Startup', 'ProductGUID', '');
                                               Free;
                                          end;
                                          EffacerDossier(DossierTemp+'Disk1');
                                          ExtraireRessource(RT_RCDATA, 'ISS', DossierTemp+'Setup.iss');
                                          SL:=TStringList.Create;
                                          SL.LoadFromFile(DossierTemp+'Setup.iss');
                                          for i:=0 to SL.Count-1 do SL[i]:=StringReplace(SL[i], '*', GUID, [rfReplaceAll]);
                                          SL.SaveToFile(DossierTemp+'Setup.iss');
                                          SL.Free;
                                          with TIniFile.Create(DossierTemp+'Setup.iss') do
                                          begin
                                               WriteString('{'+GUID+'}-SdAskDestPath-0', 'szDir', GetPath(LeLogiciel, LeMode));
                                              Free;
                                          end;
                                          LanceAppliAttenteFin('"'+DossierInstallateurs+Fichier+'" -s -f1"'+DossierTemp+'Setup.iss"', DossierInstallateurs);
                                          EffacerDossier(DossierTemp);
                                          {$ENDIF}
                                     end;
                                end
                                else EcrireFichierDebug(Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+' : Le dossier d''installation est inconnu.');
                           end else if VersionTelechargee<>'' then EcrireFichierDebug(Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+' : Dj  jour');
                           EcrireFichierDebug(Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+' : Termin');
                        except
                           EcrireFichierDebug(Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+' : Erreur');
                           result:=false;
                        end
                        else EcrireFichierDebug(Logiciel_Exename[LeLogiciel]+Suffixe(LeMode)+' : Systme non compatible');
                    end;
            except
            end;

     if MODETEST then result:=resultat else {Dsactivation / Activation du service de mise  jour} Index_EducationUpdateConfig;
end;

end.


