unit Fonctions_Java;

interface

uses Windows, SysUtils, Commun, uLkJSON;

function TelechargerJava: bool;
function InstallerJava: bool;

implementation

uses Principale, Journal, Fonctions, Classes, Registry, Math;

// Activer / Dsactiver mise  jour automatique Java
procedure JavaUpdate(Enabled: bool);
var i: integer;
    AAccess: cardinal;
begin
     for i:=1 to 2 do
     begin
          if i=1 then AAccess:=KEY_ALL_ACCESS else AAccess:=KEY_ALL_ACCESS or $0100;
          with TRegistry.Create(AAccess) do
          begin
               RootKey:=HKEY_LOCAL_MACHINE;
               if OpenKey('\SOFTWARE\Javasoft\Java Update\Policy', false) then
               begin
                    WriteInteger('EnableJavaUpdate', Abs(Integer(Enabled)));
                    WriteInteger('EnableAutoUpdateCheck', Abs(Integer(Enabled)));
                    WriteInteger('NotifyDownload', Abs(Integer(Enabled)));
               end;
               CloseKey;
               Free;
          end;
     end;
end;

// Renvoie le dossier de Java
function HomeJavaInstalle(LeMode: TMode3264 ; MajorVersion: integer): string;
var KeyName: string;
    Mode: cardinal;
begin
     result:='';
     if LeMode=Mode32bits then Mode:=KEY_READ else Mode:=KEY_READ or $0100;
     with TRegistry.Create(Mode) do
     begin
          RootKey:=HKEY_LOCAL_MACHINE;
          if MajorVersion=7 then KeyName:='Java7FamilyVersion' else KeyName:='CurrentVersion';
          if OpenKey('\SOFTWARE\JavaSoft\Java Runtime Environment', false) and (ReadString(KeyName)<>'') and KeyExists(ReadString(KeyName)) and OpenKey(ReadString(KeyName), false) then
             result:=ReadString('JavaHome');
          CloseKey;
          Free;
     end;
     if result<>'' then result:=IncludeTrailingPathDelimiter(result);
end;

// Renvoie la version de Java
function VersionJavaInstalle(LeMode: TMode3264 ; MajorVersion: integer): string;
var DossierJava: string;
begin
     DossierJava:=HomeJavaInstalle(LeMode, MajorVersion); result:='0.0.0.0';
     if DossierJava<>'' then
     begin
          DossierJava:=IncludeTrailingPathDelimiter(DossierJava+'bin');
          if not FileExists(DossierJava+'java.exe') then DossierJava:='';
          if DossierJava<>'' then result:=GetVersion(DossierJava+'java.exe');
     end;
end;

procedure Scinder(Chaine: string; Liste : TStringList; Delimiteur: char); 
begin 
    Liste.Clear; 
    while Pos(Delimiteur, Chaine)>0 do 
    begin 
          if Pos(Delimiteur, Chaine)<>1 then Liste.Add(Copy(Chaine,1,Pos(Delimiteur, Chaine)-1)); 
          Chaine:=Copy(Chaine,Pos(Delimiteur, Chaine)+1,length(Chaine)); 
    end; 
    if Chaine<>'' then Liste.Add(Chaine); 
end;

// Lit la version la plus rcente de Java version MajorVersion (7 ou 8) et le nom d'excutable associ parmi les excutables du dossier en cours
procedure JavaAInstaller(Mode: TMode3264 ; MajorVersion: integer ; var Version: string ; var Fichier: TFileName);
var Suffixe: string;
    Liste: TStringList;
    i: integer;
begin
     if Mode=Mode32bits then Suffixe:='i586' else Suffixe:='x64';
     GetFichier('jre-'+inttostr(MajorVersion)+'u*-windows-'+Suffixe+'.exe', Version, Fichier);
     if (MajorVersion=8) and (Version<>'') then
     begin
          Liste:=TStringList.Create;
          Scinder(Version, Liste, '.');
          for i:=0 to Liste.Count-1 do
          if (StrToIntDef(Liste[i], 0)>=100) and (StrToIntDef(Liste[i], 0) mod 10 = 0) then Liste[i]:=Copy(Liste[i], 1, length(Liste[i])-1);
          Liste.Delimiter:='.';
          Version:=Liste.DelimitedText;
          Liste.Free;
     end;
end;

// Tlchargement de la dernire mise  jour de Java
function TelechargerJava: bool;
const Page = 'https://www.java.com/content/published/api/v1.1/items'+'?q=((id%20eq%20%22CORE7B1FF38771234E749E94A8C83F78F516%22%20'+{'or%20id%20eq%20%22CORE2580389FDCBD4E4FAD1600F26AC09911%22%20'+}'or%20id%20eq%20%22COREFA37E773006D4BE183DB8D7F504C5718%22'+'%20or%20id%20eq%20%22CORE121973D840234867BA5272E547116044%22)%20and%20(language%20eq%20%22en%22))'+'&channelToken=1f7d2611846d4457b213dfc9048724dc';
      FichierTemp_: array [Mode32bits..Mode64bits] of string=('jre-8u-windows-i586.exe', 'jre-8u-windows-x64.exe');
var L: TStringList;
    Mode: TMode3264;
    LienJava: array [Mode32bits..Mode64bits] of string;
    JSonObj: TlkJsonObject;
    JSONStream: TlkJSONstreamed;
    NodeItems: TlkJsonBase;
    MS: TMemoryStream;
    SecID, bundleUrl: string;
    Headers: TStringStream;
begin
     result:=true;
     L:=TStringList.Create;
     try
        // On tlcharge les dernires mises  jour de Java (32 bits & 64 bits)
        EcrireFichierDebug('Java : Initialisation du tlchargement');

        // On lit le fichier de donnes JSON
        MS:=TMemoryStream.Create;
        Headers := TStringStream.Create('');
        with Headers do
        begin
             WriteString('User-Agent: '+USER_AGENT+SLineBreak);
             WriteString('Accept-Language: fr,fr-FR;q=0.8,en-US;q=0.5,en;q=0.3'+SLineBreak);
             WriteString('Keep-Alive: 300'+SLineBreak);
             WriteString('Connection: keep-alive'+SLineBreak);
             WriteString('Accept-Encoding: deflate, br'+SLineBreak+SLineBreak);
        end;
        if DownloadStream(Page, MS, Configuration.General.Proxy, Configuration.General.Proxy_Adresse, 0, DEFAULT_CONNECT_TIMEOUT, false, '', Headers).Code=0 then
        begin
             MS.Position:=0;
             JSONStream:=TlkJSONstreamed.Create;
             JSonObj:=nil;
             try
                JSonObj:=JSONStream.LoadFromStream(MS) as TlkJsonObject;
             except
             end;
             JSONStream.Free;
             // On rcupre les informations pour la cration des liens de tlchargement
             bundleUrl:=''; SecID:=''; LienJava[Mode32bits]:=''; LienJava[Mode64bits]:='';
             if Assigned(JSonObj) then
             begin
                  NodeItems:=JSonObj.Field['items'];
                  if Assigned(NodeItems) then
                  begin
                       if NodeItems.Count>=3 then
                       try
                          bundleUrl:=NodeItems.Child[0].Field['fields'].Field['json'].Field['bundleUrl'].Value;
                          SecID:=NodeItems.Child[1].Field['fields'].Field['json'].Field['secID'].Value;
                          LienJava[Mode32bits]:=bundleUrl+NodeItems.Child[1].Field['fields'].Field['json'].Field['win_offline_bundle'].Value+'_'+SecID;
                          LienJava[Mode64bits]:=bundleUrl+NodeItems.Child[1].Field['fields'].Field['json'].Field['win_x64_bundle'].Value+'_'+SecID;
                       except
                       end;
                  end;
                  JSonObj.Free;
             end;

             // On tlcharge les fichiers dont on a rcupr l'URL}
             for Mode:=Mode32bits to Mode64bits do
             if ((Mode=Mode32bits) and (Configuration.Java.Modules in [0, 2]) )or ((Mode=Mode64bits) and (Configuration.Java.Modules in [1, 2])) then
             begin
                  EcrireFichierDebug('Java 8'+Suffixe(Mode)+' : ');
                  with DownloadFileIfNewest(LienJava[Mode], FichierTemp_[Mode], false, TailleFichier(DossierInstallateurs+FichierTemp_[Mode])) do
                  begin
                       if Code<=0 then
                       begin
                            if Code<0 then EcrireFichierDebug('Java 8'+Suffixe(Mode)+' : Installateur dj  jour', true)
                                      else EcrireFichierDebug('Java 8'+Suffixe(Mode)+' : Installateur mis  jour', true);
                       end
                       else
                       begin
                            EcrireFichierDebug('Java 8'+Suffixe(Mode)+' : Erreur '+inttostr(Code)+' ('+Message+')');
                            result:=false;
                       end;
                  end;
             end;
        end;
        MS.Free;
        Headers.Free;
        EcrireFichierDebug('Java : Termin');
     except
        EcrireFichierDebug('Java : Erreur');
        result:=false;
     end;
     L.Free;
end;

// Tlchargement de la dernire mise  jour de Java
function TelechargerJava2: bool;
const LabelJava : array [0..1] of string=('32 bits', '64 bits');
      Page = 'http://java.com/fr/download/manual.jsp';
      FichierTemp_: array [0..1] of string=('jre-8u-windows-i586.exe', 'jre-8u-windows-x64.exe');
var L: TStringList;
    i: integer;
    LienJava: array [0..1] of string;
begin
     result:=true;
     L:=TStringList.Create;
     try
        // On tlcharge les dernires mises  jour de Java (32 bits & 64 bits)
        EcrireFichierDebug('Java : Initialisation du tlchargement');
        // On supprime le fichier %TEMP%/manual.jsp s'il existe
        EffacerFichier(RenvoiDossierTemp+'manual.jsp');

        // On tlcharge la nouvelle version prsente sur la page et on copie le fichier dans %TEMP/manual.jsp
        if DownloadFile(Page, RenvoiDossierTemp+'manual.jsp', Configuration.General.Proxy, Configuration.General.Proxy_Adresse)>0 then
        begin
             // On charge le fichier %TEMP%/manual.jsp en mmoire
             L.LoadFromFile(RenvoiDossierTemp+'manual.jsp');
             // On supprime le fichier %TEMP%/manual.jsp en mmoire
             EffacerFichier(RenvoiDossierTemp+'manual.jsp');
             // On cherche les liens dans le code HTML de la page, il doivent tre inclus dans les balises mentionnant "Windows Hors ligne" et "Windows (64 bits)".
             LienJava[0]:=''; LienJava[1]:='';
             while ((LienJava[0]='') or (LienJava[1]='')) and (L.Count>0) do
             begin
                  if (LienJava[0]='') and Filtre(L[0], '*Windows Hors ligne"*') then LienJava[0]:=L[0];
                  if (LienJava[1]='') and Filtre(L[0], '*Windows (64 bits)"*') then LienJava[1]:=L[0];
                  L.Delete(0);
             end;
             for i:=0 to 1 do
             begin
                  LienJava[i]:=Copy(LienJava[i], Pos('href="', LienJava[i])+6, MAXINT);
                  LienJava[i]:=Copy(LienJava[i], 1, Pos('"', LienJava[i])-1);
             end;
             // On tlcharge les fichiers dont on a rcupr l'URL}
             for i:=0 to 1 do
             if ((i=0) and (Configuration.Java.Modules in [0, 2]) )or ((i=1) and (Configuration.Java.Modules in [1, 2])) then
             begin
                  EcrireFichierDebug('Java 8 ('+LabelJava[i]+') : ');
                  with DownloadFileIfNewest(LienJava[i], FichierTemp_[i], false, TailleFichier(DossierInstallateurs+FichierTemp_[i])) do
                  begin
                       if Code<=0 then
                       begin
                            if Code<0 then EcrireFichierDebug('Java 8 ('+LabelJava[i]+') : Installateur dj  jour', true)
                                      else EcrireFichierDebug('Java 8 ('+LabelJava[i]+') : Installateur mis  jour', true);
                       end
                       else
                       begin
                            EcrireFichierDebug('Java 8 ('+LabelJava[i]+') : Erreur '+inttostr(Code)+' ('+Message+')');
                            result:=false;
                       end;
                  end;
             end;
        end;
        EcrireFichierDebug('Java : Termin');
     except
        EcrireFichierDebug('Java : Erreur');
        result:=false;
     end;
     L.Free;
end;


procedure JavaConfig;
const SECURITE_NIVEAU: array[2..4] of string=('VERY_HIGH', 'HIGH', 'MEDIUM');
      SECURITE_IGNORER=0;
      SECURITE_DEFAUT=1;
      SITES_IGNORER=0;
      SITES_DEFAUT=1;
      SITES_GERE=2;
      // Teste si Fichier contient tout le Contenu
      function SontIdentiques(Contenu: TStringList ; Fichier: TFileName): bool;
      var FichierTemp: TStringList;
          i: integer;
      begin
           FichierTemp:=TStringList.Create;
           try
              if FileExists(Fichier) then FichierTemp.LoadFromFile(Fichier);
           except
           end;
           result:=true;
           i:=0;
           while (i<Contenu.Count) and result do
             if FichierTemp.IndexOf(Contenu[i])=-1 then result:=false else Inc(i);
           FichierTemp.Free;
      end;
var DossierConfig: string;
    FichierConfig, FichierDeploiement: TStringList;
begin
     DossierConfig:=IncludeTrailingPathDelimiter(RenvoiDossierWindows+'Sun\Java\Deployment');
     if (Configuration.Java.Securite in [1..4]) or (Configuration.Java.Sites_Autorisation in [1..2]) then
     begin
          if (Configuration.Java.Securite>SECURITE_DEFAUT) or (Configuration.Java.Sites_Autorisation>SITES_DEFAUT) then
          begin
               FichierConfig:=TStringList.Create;
               FichierDeploiement:=TStringList.Create;
               try ForceDirectories(DossierConfig); except end;

               FichierConfig.Add('deployment.system.config='+DossierConfig+'deployment.properties');
               if not SontIdentiques(FichierConfig, DossierConfig+'deployment.config') then try FichierConfig.SaveToFile(DossierConfig+'deployment.config'); except end;

               if Configuration.Java.Securite>SECURITE_DEFAUT then
               begin
                    FichierDeploiement.Add('deployment.security.level='+SECURITE_NIVEAU[Configuration.Java.Securite]);
                    FichierDeploiement.Add('deployment.security.level.locked');
               end;
               if Configuration.Java.Sites_Autorisation>SITES_DEFAUT then
                    FichierDeploiement.Add('deployment.user.security.exception.sites='+StringReplace(DossierConfig, '\', '/', [rfReplaceAll])+'deployment.exception.sites');
               if not SontIdentiques(FichierDeploiement, DossierConfig+'deployment.properties') then try FichierDeploiement.SaveToFile(DossierConfig+'deployment.properties'); except end;
               if (Configuration.Java.Sites_Autorisation>SITES_DEFAUT) and not SontIdentiques(Configuration.Java.Sites, DossierConfig+'deployment.exception.sites') then try Configuration.Java.Sites.SaveToFile(DossierConfig+'deployment.exception.sites'); except end;

               if Configuration.Java.Sites_Autorisation=SITES_DEFAUT then EffacerFichier(DossierConfig+'deployment.exception.sites');

               FichierDeploiement.Free;
               FichierConfig.Free;
          end
          else
          begin
               if (Configuration.Java.Securite=SECURITE_DEFAUT) and (Configuration.Java.Sites_Autorisation=SITES_DEFAUT) then
               begin
                    EffacerFichier(DossierConfig+'deployment.config');
                    EffacerFichier(DossierConfig+'deployment.properties');
               end;
               if Configuration.Java.Sites_Autorisation=SITES_DEFAUT then EffacerFichier(DossierConfig+'deployment.exception.sites');
          end;
     end;
end;

function RechercherUninstallStringJava7(LeMode: TMode3264 ; JavaHome: string): string;
const KeyRacine='\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\';
var Mode: cardinal;
    Liste: TStringList;
    i: integer;
begin
     result:='';
     if LeMode=Mode32bits then Mode:=KEY_READ else Mode:=KEY_READ or $0100;
     with TRegistry.Create(Mode) do
     begin
          RootKey:=HKEY_LOCAL_MACHINE;
          if OpenKey(KeyRacine, false) then
          begin
               Liste:=TStringList.Create;
               GetKeyNames(Liste);
               i:=0;
               while (i<Liste.Count) and (result='') do
               begin
                    CloseKey;
                    if OpenKey(KeyRacine+Liste[i], false) then
                    begin
                         if SameText(IncludeTrailingPathDelimiter(ReadString('InstallLocation')), IncludeTrailingPathDelimiter(JavaHome)) then
                            result:=ReadString('UninstallString');
                    end;
                    Inc(i);
               end;
               Liste.Free;
          end;
          Free;
     end;
end;

function RechercherUninstallStringJava8(LeMode: TMode3264 ; var KeyName: string): string;
const KeyRacine='\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\';
var Mode: cardinal;
    Liste: TStringList;
    i: integer;
begin
     result:='';
     if LeMode=Mode32bits then Mode:=KEY_READ else Mode:=KEY_READ or $0100;
     with TRegistry.Create(Mode) do
     begin
          RootKey:=HKEY_LOCAL_MACHINE;
          if OpenKey(KeyRacine, false) then
          begin
               Liste:=TStringList.Create;
               GetKeyNames(Liste);
               i:=Liste.IndexOf(KeyName)+1;
               while (i<Liste.Count) and (result='') do
               begin
                    CloseKey;
                    if OpenKey(KeyRacine+Liste[i], false) then
                    begin
                         if SameText(ReadString('Publisher'), 'Oracle Corporation') and (Pos('java', ReadString('Contact'))>0) and (ReadInteger('VersionMajor')=8) then
                         begin
                              KeyName:=Liste[i];
                              result:=StringReplace(ReadString('UninstallString'), '/i', '/x', [rfIgnoreCase]);
                         end;
                    end;
                    Inc(i);
               end;
               Liste.Free;
          end;
          Free;
     end;
end;

function NettoyerVersionJava(Valeur: string): string;
var L: TStringList;
begin
     L:=TStringList.Create;
     L.Delimiter:='.';
     L.DelimitedText:=Valeur;
     if (L.Count=4) and (length(L[2])>1) and (Copy(L[2], length(L[2]), 1)='0') then L[2]:=IntToStr(StrToIntDef(L[2], 0) div 10);
     Result:=L.DelimitedText;
     L.Free;
end;

function InstallerJava: bool;
var i, Minversion, MaxVersion: integer;
    resultat: bool;
    Version, VersionInstallee, JavaHome, UninstallString, KeyName: string;
    Fichier: TFileName;
    Mode: TMode3264;
begin
     resultat:=false;
     result:=true;

     MinVersion:=8; MaxVersion:=8;

     if Configuration.Java.Modules in [0, 2] then
     begin
          Mode:=Mode32bits;
          // Dsinstallation de Java 7 sur systmes rcents
          if Configuration.Java.Desinstalle and not MODETEST then
          begin
               JavaHome:=HomeJavaInstalle(Mode, 7);
               if JavaHome<>'' then
               begin
                    UninstallString:=StringReplace(RechercherUninstallStringJava7(Mode, JavaHome), '/x', '/qn /norestart /x', [rfReplaceAll, rfIgnoreCase]);
                    if UninstallString<>'' then
                    begin
                         EcrireFichierDebug('Java 7'+Suffixe(Mode)+' : Dsinstallation');
                         LanceAppliAttenteFin(UninstallString, DossierInstallateurs, false, IfThen(Configuration.General.Stopper_Installation, Configuration.General.Stopper_Installation_Minutes*60*1000, INFINITE));
                    end;
               end;
          end;

          for i:=MinVersion to MaxVersion do
          try
             // Recherche dans le dossier de l'excutable de la version la plus rcente de Java 32 bits + nom de fichier associ
             EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Initialisation de l''installation');
             JavaAInstaller(Mode, i, Version, Fichier);
             if Version='' then EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Installateur non trouv') else EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Version '+Version+' trouve dans '+Fichier);
             // Si la version install de Java 32 bits mrite une mise  jour alors on la lance
             VersionInstallee:=VersionJavaInstalle(Mode, i);
             if (CompareVersion(VersionInstallee, '0.0.0.0')=0) and Configuration.Java.Installe then EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Non install')
             else
             begin
                  Version:=NettoyerVersionJava(Version);
                  VersionInstallee:=NettoyerVersionJava(VersionInstallee);
                  if CompareVersion(Version, VersionInstallee)>0 then
                  begin
                       if MODETEST then resultat:=true
                       else
                       begin
                            // Teste si une version 8 existe dj
                            KeyName:='';
                            if (i=8) and Configuration.Java.Desinstalle then
                            repeat
                                  UninstallString:=StringReplace(RechercherUninstallStringJava8(Mode, KeyName), '/x', '/qn /norestart /x', [rfReplaceAll, rfIgnoreCase]);
                                  if UninstallString<>'' then
                                  begin
                                       EcrireFichierDebug('Java 8'+Suffixe(Mode)+' : Dsinstallation');
                                       LanceAppliAttenteFin(UninstallString, DossierInstallateurs, false, IfThen(Configuration.General.Stopper_Installation, Configuration.General.Stopper_Installation_Minutes*60*1000, INFINITE));

                                  end;
                            until UninstallString='';
                            EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Mise  jour');
                            LanceAppliAttenteFin('"'+DossierInstallateurs+Fichier+'" /s', DossierInstallateurs, false, IfThen(Configuration.General.Stopper_Installation, Configuration.General.Stopper_Installation_Minutes*60*1000, INFINITE));
                       end;
                  end else if Version<>'' then EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Dj  jour');
             end;
             EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Termin');
          except
             EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Erreur');
             result:=false;
          end;
     end;

     if Configuration.Java.Modules in [1, 2] then
     begin
          Mode:=Mode64bits;
          // Si le systme d'exploitation est en 64 bits
          if IAmIn64Bits then
          begin
               // Dsinstallation de Java 7 sur systmes rcents
               if Configuration.Java.Desinstalle and not MODETEST then
               begin
                    JavaHome:=HomeJavaInstalle(Mode, 7);
                    if JavaHome<>'' then
                    begin
                         UninstallString:=StringReplace(RechercherUninstallStringJava7(Mode, JavaHome), '/x', '/qn /norestart /x', [rfReplaceAll, rfIgnoreCase]);
                         if UninstallString<>'' then
                         begin
                              EcrireFichierDebug('Java 7'+Suffixe(Mode)+' : Dsinstallation');
                              LanceAppliAttenteFin(UninstallString, DossierInstallateurs, false, IfThen(Configuration.General.Stopper_Installation, Configuration.General.Stopper_Installation_Minutes*60*1000, INFINITE));
                         end;
                    end;
               end;

               for i:=MinVersion to MaxVersion do
               try
                  // Recherche dans le dossier de l'excutable de la version la plus rcente de Java 64 bits + nom de fichier associ
                  EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Initialisation de l''installation');
                  JavaAInstaller(Mode, i, Version, Fichier);
                  if Version='' then EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Installateur non trouv') else EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Version '+Version+' trouve dans '+Fichier);
                  // Si la version install de Java 64 bits mrite une mise  jour alors on la lance
                  VersionInstallee:=VersionJavaInstalle(Mode, i);
                  if (CompareVersion(VersionInstallee, '0.0.0.0')=0) and Configuration.Java.Installe then EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Non install')
                  else
                  begin
                        Version:=NettoyerVersionJava(Version);
                        VersionInstallee:=NettoyerVersionJava(VersionInstallee);
                       if CompareVersion(Version, VersionInstallee)>0 then
                       begin
                            if MODETEST then resultat:=true
                            else
                            begin
                                 // Teste si une version 8 existe dj
                                 KeyName:='';
                                 if (i=8) and Configuration.Java.Desinstalle then
                                 begin
                                      KeyName:='';
                                      repeat
                                            UninstallString:=StringReplace(RechercherUninstallStringJava8(Mode, KeyName), '/x', '/qn /norestart /x', [rfReplaceAll, rfIgnoreCase]);
                                            if UninstallString<>'' then
                                            begin
                                                 EcrireFichierDebug('Java 8'+Suffixe(Mode)+' : Dsinstallation');
                                                 LanceAppliAttenteFin(UninstallString, DossierInstallateurs, false, IfThen(Configuration.General.Stopper_Installation, Configuration.General.Stopper_Installation_Minutes*60*1000, INFINITE));
                                            end;
                                      until UninstallString='';
                                 end;
                                 EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Mise  jour');
                                 LanceAppliAttenteFin('"'+DossierInstallateurs+Fichier+'" /s', DossierInstallateurs, false, IfThen(Configuration.General.Stopper_Installation, Configuration.General.Stopper_Installation_Minutes*60*1000, INFINITE));
                            end;
                       end else if Version<>'' then EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Dj  jour');
                  end;
                  EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Termin');
               except
                  EcrireFichierDebug('Java '+inttostr(i)+Suffixe(Mode)+' : Erreur');
                  result:=false;
               end;
           end
           else EcrireFichierDebug('Java'+Suffixe(Mode)+' : Systme non compatible');
     end;

     if MODETEST then result:=resultat
     else
     begin
          // Configuration de Java
          JavaConfig;
          // Mises  jour par Java
          case Configuration.Java.Update of
          1: JavaUpdate(false);
          2: JavaUpdate(true);
          end;
     end;
end;

end.
