unit Fonctions_UpdateSoft;

interface

uses Windows, SysUtils, Classes, HTTPApp, Commun, Signature, Registry;

function TelechargerUpdateSoft(RestartImmediatlyIfUpdated: bool): smallint;
procedure GetUpdateSoftMAJInfos(var MAJ: bool; var Version, URL: string);
procedure MiseAJourService;

implementation

uses Principale, Fonctions, URLMon;

procedure GetUpdateSoftMAJInfos(var MAJ: bool; var Version, URL: string);
var L: TStringList;
    Fichier: TFileName;
begin
     MAJ:=false;
     Version:='';
     URL:='';
     L:=TStringList.Create;
     Fichier:=RenvoiDossierTemp+ChangeFileExt(ExtractFileName(ParamStr(0)), '.txt');
     EffacerFichier(Fichier);
     try
        if DownloadFile(URLVersion, Fichier, Configuration.General.Proxy, Configuration.General.Proxy_Adresse)>0 then
        begin
             L.LoadFromFile(Fichier);
             if L.Count=2 then
             if (CompareVersion(L[0], GetVersion(ParamStr(0)))>0) and (IsValidURL(nil, PWideChar(WideString(L[1])), 0) = S_OK) and SameText(ExtractFileExt(UnixPathToDosPath(L[1])), '.exe') then
             begin
                  MAJ:=true;
                  Version:=L[0];
                  URL:=L[1];
             end;
        end;
     except
     end;
     EffacerFichier(Fichier);
     L.Free;
end;

function TelechargerUpdateSoft(RestartImmediatlyIfUpdated: bool): smallint;
var MAJ: bool;
    Version, URL, FichierEXE: string;
    TokenList: TTokenList;
begin
     result:=1;
     // On tlcharge les infos de dernire version
     try
        EcrireFichierDebug('UpdateSoft : Initialisation du tlchargement');
        ActionProcessus(ExtractFileName(ParamStr(0)), [apToken], TokenList);
        if length(TokenList)=0 then
        begin
             GetUpdateSoftMAJInfos(MAJ, Version, URL);
             if MAJ then
             begin
                  FichierEXE:=RenvoiDossierTemp+ExtractFileName(ChangeFileExt(ParamStr(0), '.exe'));
                  EffacerFichier(FichierEXE);
                  EcrireFichierDebug('UpdateSoft : Tlchargement de la mise  jour '+Version+'  l''adresse '+URL);
                  if not FileExists(FichierEXE) and (DownloadFile(URL, FichierEXE, Configuration.General.Proxy, Configuration.General.Proxy_Adresse)>0) then
                  begin
                       EcrireFichierDebug('UpdateSoft : Mise  jour tlcharge');
                       if IsCompanySigningCertificate(FichierEXE, APP_PUBLISHER) and (CompareVersion(GetVersion(FichierEXE), Version)=0) then
                       begin
                            EffacerFichier(ParamStr(0)+'.temp');
                            EffacerFichier(ChangeFileExt(ParamStr(0), '.chm'));
                            CopierFichier(FichierEXE, ParamStr(0)+'.temp');
                            if RestartImmediatlyIfUpdated then EcrireFichierDebug('UpdateSoft : Redmarrage') else EcrireFichierDebug('UpdateSoft : Mise  jour en version '+GetVersion(FichierEXE)+' au prochain lancement');
                            result:=2;
                       end
                       else
                       begin
                            EcrireFichierDebug('UpdateSoft : Erreur (Archive corrompue)');
                            result:=0;
                       end;
                  end;
                  EffacerFichier(FichierEXE);
             end
             else EcrireFichierDebug('UpdateSoft : Dj  jour');
        end
        else
        begin
             Finalize(TokenList);
             EcrireFichierDebug('UpdateSoft : Une autre instance est dj en cours d''excution');
        end;
        EcrireFichierDebug('UpdateSoft : Termin');
     except
        EcrireFichierDebug('UpdateSoft : Erreur');
        result:=0;
     end;
end;

procedure MiseAJourService;
var FichierEXE, FichierService, User: string;
begin
     if IsServiceInstalled(false, User) then
     try
        FichierService:='';
        with TRegistry.Create(KEY_READ) do
        begin
             RootKey:=HKEY_LOCAL_MACHINE;
             if OpenKey(SERVICE_CONFIGURATION_KEY, false) then FichierService:=ReadString('ImagePath');
             Free;
        end;
        if FileExists(FichierService) and (GetVersion(FichierService)<>'') then
        begin
             EcrireFichierDebug('UpdateSoft : Vrification de la version du service');
             EffacerFichier(ChangeFileExt(FichierService, '.tmp'));
             FichierEXE:=RenvoiDossierTemp+ExtractFileName(ChangeFileExt(ParamStr(0), '.exe'));
             EffacerFichier(FichierEXE);
             ExtraireRessource(RT_RCDATA, 'SERVICE', FichierEXE);
             if CompareVersion(GetVersion(FichierEXE), GetVersion(FichierService))>0 then
             begin
                  EcrireFichierDebug('UpdateSoft : Mise  jour du service en version '+GetVersion(FichierEXE)+'  son prochain lancement');
                  CopierFichier(FichierEXE, ChangeFileExt(FichierService, '.tmp'));
             end;
             EffacerFichier(FichierEXE);
        end
        else EcrireFichierDebug('UpdateSoft : Service introuvable');
     except
     end;
end;

end.
