unit Fonctions_VLC;

interface

uses Windows, SysUtils, WinInet, Fonctions, Commun;

function TelechargerVLC: bool;
function InstallerVLC: bool;
//procedure VLCAInstaller(var Version: string ; var Fichier: TFileName ; Mode: TMode3264);

implementation

uses Principale, Journal, HTTPApp, Classes, Registry, Math;

// Activer / Dsactiver mise  jour automatique VLC
procedure VLCUpdate(Enabled: bool ; Mode: TMode3264);
var ExecutableVLC, Dossier: string;
const Fichier0='vlcrc';
      Fichier1='vlc-qt-interface.ini';
      VLC_Original='vlc-original.exe';
var AAccess: integer;
begin
     // Retrait de l'ancienne version
     Dossier:=IncludeTrailingPathDelimiter(RenvoiDossierCommonAppData+'vlc');
     EffacerFichier(Dossier+Fichier0);
     EffacerFichier(Dossier+Fichier1);
     RemoveDir(Dossier); // Supprime le dossier s'il est vide
     if Mode=Mode32bits then AAccess:=KEY_READ else AAccess:=KEY_READ or $0100;
     with TRegistry.Create(AAccess) do
     begin
          RootKey:=HKEY_LOCAL_MACHINE;
          if OpenKey('\SOFTWARE\VideoLAN\VLC', false) then
             ExecutableVLC:=ReadString('');
          Free;
     end;
     if (ExecutableVLC<>'') and FileExists(ExecutableVLC) then
     begin
          if Enabled then
          begin
               if (GetVersion(ExecutableVLC)='') and FileExists(ExtractFilePath(ExecutableVLC)+VLC_Original) then
               begin
                    EffacerFichier(ExecutableVLC);
                    RenommerFichier(ExtractFilePath(ExecutableVLC)+VLC_Original, ExecutableVLC);
               end;
          end
          else
          begin
               if GetVersion(ExecutableVLC)<>'' then
               begin
                    EffacerFichier(ExtractFilePath(ExecutableVLC)+VLC_Original);
                    if RenommerFichier(ExecutableVLC, ExtractFilePath(ExecutableVLC)+VLC_Original) then ExtraireRessource(RT_RCDATA, 'VLC', ExecutableVLC);
               end
               else
               if TailleFichier(ExecutableVLC)<>TailleRessource(RT_RCDATA, 'VLC') then
               begin
                    EffacerFichier(ExecutableVLC);
                    ExtraireRessource(RT_RCDATA, 'VLC', ExecutableVLC);
               end;
          end;
     end;
end;

// Renvoie la version de VLC installe
function VersionVLCInstalle(Mode: TMode3264): string;
var ExecutableVLC: string;
    AAccess: integer;
const VLC_Original='vlc-original.exe';
begin
     ExecutableVLC:=''; result:='0.0.0.0';
     if Mode=Mode32Bits then AAccess:=KEY_READ else AAccess:=KEY_READ or $0100;
     with TRegistry.Create(AAccess) do
     begin
          RootKey:=HKEY_LOCAL_MACHINE;
          if OpenKey('\SOFTWARE\VideoLAN\VLC', false) then
             ExecutableVLC:=ReadString('');
          Free;
     end;
     if ExecutableVLC<>'' then
     begin
          if not FileExists(ExecutableVLC) then ExecutableVLC:='';
          if ExecutableVLC<>'' then
          begin
               if TailleFichier(ExecutableVLC)=61952 then
               begin
                    result:='1.0.0.0';
                    EffacerFichier(ExecutableVLC);
                    EffacerFichier(ExtractFilePath(ExecutableVLC)+VLC_Original);
               end
               else
               begin
                    result:=GetVersion(ExecutableVLC);
                    if (result='') and FileExists(ExtractFilePath(ExecutableVLC)+VLC_Original) then
                         if TailleFichier(ExtractFilePath(ExecutableVLC)+VLC_Original)=61952 then
                         begin
                              result:='1.0.0.0';
                              EffacerFichier(ExtractFilePath(ExecutableVLC)+VLC_Original);
                              EffacerFichier(ExecutableVLC);
                         end
                         else result:=GetVersion(ExtractFilePath(ExecutableVLC)+VLC_Original);
               end;
          end;
     end;
end;

// Lit la version la plus rcente de VLC et le nom d'excutable associ parmi les excutables du dossier en cours
procedure VLCAInstaller(var Version: string ; var Fichier: TFileName ; Mode: TMode3264);
const Mask32bits='vlc-*-win32.exe';
      Mask64bits='vlc-*-win64.exe';
var Sr: TSearchRec;
    Mask, VersionTemp: string;
begin
     Version:=''; Fichier:='';
     if Mode=Mode32bits then Mask:=Mask32bits else Mask:=Mask64bits;
     if FindFirst(DossierInstallateurs+Mask,faAnyFile,sr)=0 then
     begin
          repeat
                VersionTemp:=Copy(Sr.Name, Pos('*', Mask), MAXINT);
                VersionTemp:=Copy(VersionTemp, 1, length(VersionTemp)-(length(Mask)-Pos('*', Mask)));
                if CompareVersion(VersionTemp, Version)>=0 then
                begin
                     if Fichier<>'' then EffacerFichier(DossierInstallateurs+Fichier);
                     Fichier:=Sr.FindData.cFileName;
                     Version:=VersionTemp;
                end;
          until FindNext(sr)<>0;
          FindClose(sr);
     end;
end;

function TelechargerVLC: bool;
var Version: string;
    Fichier: TFileName;
    Mode: TMode3264;
begin
     result:=true;
     if Configuration.VLC.Modules in [0, 2] then
     begin
          Mode:=Mode32bits;
          try
             // On tlcharge la dernire mise  jour de VLC
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Initialisation du tlchargement');
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : ');
             VLCAInstaller(Version, Fichier, Mode);

             with DownloadFileIfNewest(PREFIXE_HTTP+VIDEOLAN_HTTP+VIDEOLAN_VLC_HTTPDIR32bits, VIDEOLAN_VLC_FILTER, true, TailleFichier(DossierInstallateurs+Fichier), false) do
             begin
                  if Code<=0 then
                  begin
                       if Code<0 then EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Installateur dj  jour', true)
                                 else EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Installateur mis  jour', true);
                  end
                  else
                  begin
                       EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Erreur '+inttostr(Code)+' ('+Message+')');
                       result:=false;
                  end;
             end;
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Termin');
          except
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Erreur');
             result:=false;
          end;
     end;
     if Configuration.VLC.Modules in [1, 2] then
     begin
          Mode:=Mode64bits;
          try
             // On tlcharge la dernire mise  jour de VLC
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Initialisation du tlchargement');
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : ');
             VLCAInstaller(Version, Fichier, Mode);

             with DownloadFileIfNewest(PREFIXE_HTTP+VIDEOLAN_HTTP+VIDEOLAN_VLC_HTTPDIR64bits, VIDEOLAN_VLC_FILTER, true, TailleFichier(DossierInstallateurs+Fichier), false) do
             begin
                  if Code<=0 then
                  begin
                       if Code<0 then EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Installateur dj  jour', true)
                                 else EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Installateur mis  jour', true);
                  end
                  else
                  begin
                       EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Erreur '+inttostr(Code)+' ('+Message+')');
                       result:=false;
                  end;
             end;
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Termin');
          except
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Erreur');
             result:=false;
          end;
     end;
end;

function InstallerVLC: bool;
var Version, VersionInstallee: string;
    Fichier: TFileName;
    resultat: bool;
    Mode: TMode3264;
begin
     resultat:=false;
     result:=true;
     if Configuration.VLC.Modules in [0, 2] then
     begin
          Mode:=Mode32bits;
          try
             // Recherche dans le dossier de l'excutable de la version la plus rcente de VLC + nom de fichier associ...'
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Initialisation de l''installation');
             VLCAInstaller(Version, Fichier, Mode);
             if Version='' then EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Installateur non trouv') else EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Version '+Version +' trouve dans '+Fichier);
             // Si la version install de VLC mrite une mise  jour alors on la lance...'
             VersionInstallee:=VersionVLCInstalle(Mode);
             if (CompareVersion(VersionInstallee, '0.0.0.0')=0) and Configuration.VLC.Installe then EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Non install')
             else
             if CompareVersion(Version, VersionInstallee)>0 then
             begin
                  if MODETEST then resultat:=true
                  else
                  begin
                       VLCUpdate(true, Mode);
                       EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Mise  jour');
                       LanceAppliAttenteFin('"'+DossierInstallateurs+Fichier+'" /S /NCRC', DossierInstallateurs, false, IfThen(Configuration.General.Stopper_Installation, Configuration.General.Stopper_Installation_Minutes*60*1000, INFINITE));
                  end;
             end else if Version<>'' then EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Dj  jour');
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Termin');
          except
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Erreur');
             result:=false;
          end;
     end;

     if Configuration.VLC.Modules in [1, 2] then
     begin
          Mode:=Mode64bits;
          if IAmIn64Bits then
          try
             // Recherche dans le dossier de l'excutable de la version la plus rcente de VLC + nom de fichier associ...'
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Initialisation de l''installation');
             VLCAInstaller(Version, Fichier, Mode);
             if Version='' then EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Installateur non trouv') else EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Version '+Version +' trouve dans '+Fichier);
             // Si la version install de VLC mrite une mise  jour alors on la lance...'
             VersionInstallee:=VersionVLCInstalle(Mode);
             if (CompareVersion(VersionInstallee, '0.0.0.0')=0) and Configuration.VLC.Installe then EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Non install')
             else
             if CompareVersion(Version, VersionInstallee)>0 then
             begin
                  if MODETEST then resultat:=true
                  else
                  begin
                       VLCUpdate(true, Mode);
                       EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Mise  jour');
                       LanceAppliAttenteFin('"'+DossierInstallateurs+Fichier+'" /S /NCRC', DossierInstallateurs, false, IfThen(Configuration.General.Stopper_Installation, Configuration.General.Stopper_Installation_Minutes*60*1000, INFINITE));
                  end;
             end else if Version<>'' then EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Dj  jour');
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Termin');
          except
             EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Erreur');
             result:=false;
          end
          else EcrireFichierDebug('VLC'+Suffixe(Mode)+' : Systme non compatible');
     end;

     if MODETEST then result:=resultat
     else
     // Mises  jour par VLC
     case Configuration.VLC.Update of
     1:
     begin
          if Configuration.VLC.Modules in [0, 2] then VLCUpdate(false, Mode32bits);
          if Configuration.VLC.Modules in [1, 2] then VLCUpdate(false, Mode64bits);
     end;
     2:
     begin
          if Configuration.VLC.Modules in [0, 2] then VLCUpdate(true, Mode32bits);
          if Configuration.VLC.Modules in [1, 2] then VLCUpdate(true, Mode64bits);
     end;
     end;
end;
    
end.
