unit Journal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls, Math, Buttons, ColorButton, Commun, WTSUtils, ActiveX, WbemScripting_TLB;

type
  TFicheJournal = class(TForm)
    Journal: TMemo;
    MainMenu1: TMainMenu;
    Enregistrer: TSaveDialog;
    HorlogeChangementScript: TTimer;
    Panel: TPanel;
    Bouton: TColorButton;
    Fichier1: TMenuItem;
    Enregistrer1: TMenuItem;
    N1: TMenuItem;
    HorlogeStop: TTimer;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Enregistrer1Click(Sender: TObject);
    procedure HorlogeChangementScriptTimer(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure BoutonClick(Sender: TObject);
    procedure HorlogeStopTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FRegisteredSessionNotification : Boolean;
    procedure CacherApplication;
    procedure MontrerApplication;
    procedure MenuItemAdvancedDrawItem(Sender: TObject; ACanvas: TCanvas; ARect: TRect; State: TOwnerDrawState);
    procedure AppMessage(var Msg: TMSG; var HAndled: Boolean);
  public
    { Dclarations publiques }
  end;

  TUpdateThread = class(TThread)
  protected
    Erreur: bool;
    ReprendreDebutLigne: bool;
    LeMessage: string;
    Message: string;
    procedure Execute; override;
    procedure Affichage;
    procedure FinThread;
    procedure NotifierSessionsActives;
  public
    procedure Afficher(_Message: string ; _ReprendreDebutLigne: bool=false);
    procedure SessionEvent(SessionID: cardinal);
  end;

type TUpdateMode=(UM_None, UM_Now, UM_NextStart);
var
  FicheJournal: TFicheJournal;
  UpdateThread: TUpdateThread;
  MettreAJour: TUpdateMode=UM_None;
  IndexFichierCourant: integer=0;

implementation

uses Principale, Fonctions, Fonctions_Java, Fonctions_Flash, Fonctions_Firefox, Fonctions_Thunderbird, Fonctions_VLC, Fonctions_Index_Education,
     Fonctions_UpdateSoft, Fonctions_AIR, APropos;

{$R *.dfm}

procedure TFicheJournal.CacherApplication;
begin
     ShowWindow(Application.Handle, SW_HIDE);
     if Application.MainForm<>nil then Application.MainForm.Visible:=false else Application.ShowMainForm :=false;
end;

procedure TFicheJournal.MontrerApplication;
begin
     if Application.MainForm<>nil then
     begin
          Application.Restore;
          Application.MainForm.Visible:=true;
          Application.MainForm.Refresh;
          ShowWindow(Application.Handle, SW_SHOW);
          SetForegroundWindow(Application.MainForm.Handle);
     end;
end;

procedure TFicheJournal.FormCreate(Sender: TObject);
var i: integer;
begin
     FRegisteredSessionNotification := RegisterSessionNotification(Handle, NOTIFY_FOR_ALL_SESSIONS);
     Application.OnMessage := AppMessage;
     DoubleBuffered:=true;
     Journal.DoubleBuffered:=true;
     Caption:=NOMAPPLI+' '+GetVersion+' - Journal d''activit';
     CacherApplication;
     HorlogeChangementScript.Enabled:=true;
     DoubleBuffered:=true;
     for i:=0 to ComponentCount-1 do
     begin
          if (Components[i] is TPanel) then
          begin
               TPanel(Components[i]).ParentBackground := FALSE;
               TPanel(Components[i]).ParentBackground := TRUE;
               TPanel(Components[i]).ParentBackground := FALSE;
               TPanel(Components[i]).DoubleBuffered:=true;
          end
          else
          if Components[i] is TMenuItem then TMenuItem(Components[i]).OnAdvancedDrawItem:=MenuItemAdvancedDrawItem
          else
          if Components[i] is TColorButton then with TColorButton(Components[i]) do begin DoubleBuffered:=true; HoverColor:=Color; BackColor:=Color; end
          else
          if Components[i] is TWinControl then TWinControl(Components[i]).DoubleBuffered:=true;
     end;
end;

procedure TFicheJournal.Enregistrer1Click(Sender: TObject);
begin
     if Enregistrer.Execute then Journal.Lines.SaveToFile(Enregistrer.FileName);
end;

procedure TFicheJournal.HorlogeChangementScriptTimer(Sender: TObject);
begin
     HorlogeChangementScript.Enabled:=false;
     HorlogeStop.Enabled:=false;
     repeat
           Inc(IndexFichierCourant)
     until (IndexFichierCourant>ParamCount) or FileExists(ParamStr(IndexFichierCourant));
     if IndexFichierCourant>ParamCount then
     begin IndexFichierCourant:=-1; Close; end
     else
     begin
          Journal.Clear;
          Bouton.Tag:=0;
          Bouton.Caption:='&Interrompre';
          DestructionThread(UpdateThread, true, true);
          LireConfiguration(Configuration, ParamStr(IndexFichierCourant));
          if Configuration.General.Fenetre then MontrerApplication else CacherApplication;
          UpdateThread:=TUpdateThread.Create(true);
          UpdateThread.LeMessage:='';
          UpdateThread.FreeOnTerminate:=false;
          UpdateThread.Resume;
          if Configuration.General.Stopper then
          begin
               HorlogeStop.Enabled:=false;
               HorlogeStop.Interval:=Max(2, Configuration.General.Stopper_Minutes)*1000*60;
               HorlogeStop.Enabled:=true;
          end;
     end;
end;

procedure TFicheJournal.N1Click(Sender: TObject);
begin
     FicheAPropos.ShowModal;
end;

procedure TUpdateThread.Afficher(_Message: string ; _ReprendreDebutLigne: bool=false);
begin
     Message:=_Message;
     ReprendreDebutLigne:=_ReprendreDebutLigne;
     Synchronize(Affichage);
end;

procedure TUpdateThread.Affichage;
begin
     if Assigned(FicheJournal) then
     with FicheJournal.Journal do
     begin
          if (Lines.Count<>0) or (Message<>'') then
          begin
               Lines.BeginUpdate;
               if ReprendreDebutLigne and (Lines.Count>0) then Lines[Lines.Count-1]:=Message else Lines.Add(Message);
               SendMessage(Handle, EM_LINESCROLL, 0, Lines.Count);
               Lines.EndUpdate;
          end;
     end;
end;

type _OSVERSIONINFOEX = record
    dwOSVersionInfoSize : DWORD;
    dwMajorVersion      : DWORD;
    dwMinorVersion      : DWORD;
    dwBuildNumber       : DWORD;
    dwPlatformId        : DWORD;
    szCSDVersion        : array[0..127] of AnsiChar;
    wServicePackMajor   : WORD;
    wServicePackMinor   : WORD;
    wSuiteMask          : WORD;
    wProductType        : BYTE;
    wReserved           : BYTE;
  end;
  OSVERSIONINFOEX=_OSVERSIONINFOEX;
  TOSVERSIONINFOEX = _OSVERSIONINFOEX;

procedure GetWindowsVersion(out MajorVersion: integer ; out MinorVersion: integer ; out SubVersion: integer);
     procedure GetWindowsVersionName_(out MajorVersion: integer ; out MinorVersion: integer);
     const sQuery = 'SELECT * FROM Win32_OperatingSystem';
     var Item : SWbemObject;
         NumProp : LongWord;
         ObjectSet : ISWbemObjectSet;
         OleProperty : OleVariant;
         Version: string;
     begin
          try
             ObjectSet := CoSWbemLocator.Create.ConnectServer('', 'root\cimv2', '', '', '', '', 0, nil ).ExecQuery(sQuery, 'WQL', wbemFlagBidirectional, nil );
             if Succeeded((ObjectSet._NewEnum as IEnumVariant).Next(1, OleProperty, NumProp)) and (NumProp > 0) and Succeeded(IDispatch(OleProperty).QueryInterface(SWBemObject, Item)) then
             begin
                  try Version:=Trim(Item.Properties_.Item('Version', 0).Get_Value); except Version:=''; end;
                  MajorVersion:=StrToIntDef(Copy(Version, 1, Pos('.', Version)-1), 0);
                  Version:=Copy(Version, Pos('.', Version)+1, MAXINT);
                  MinorVersion:=StrToIntDef(Copy(Version, 1, Pos('.', Version)-1), 0);
                  SubVersion:=StrToIntDef(Copy(Version, Pos('.', Version)+1, MAXINT), 0);
             end;
          except
          end;
     end;
begin
     try
        try
           CoInitialize(nil);
           GetWindowsVersionName_(MajorVersion, MinorVersion);
        finally
           CoUninitialize;
        end;
     except
     end;
end;

const VER_NT_WORKSTATION    :Integer = 1;

function GetVersionExA(var lpVersionInformation: TOSVersionInfoEX): BOOL; stdcall; external kernel32;

type TOSVersion = (W_XP, W_2003, W_Vista, W_2008, W_7, W_8, W_2012, W_10, W_11, W_Unknown);

function OSVersion: TOSVersion;
var VersionInfo: TOSVERSIONINFOEX;
    Major, Minor, SubVersion: integer;
begin
     result:=W_Unknown;
     VersionInfo.dwOSVersionInfoSize:=sizeof(VersionInfo);
     GetVersionExA(VersionInfo);

     if (VersionInfo.dwMajorVersion=6) and (VersionInfo.dwMinorVersion=2) then
     begin
          GetWindowsVersion(Major, Minor, SubVersion);
          VersionInfo.dwMajorVersion:=Major;
          VersionInfo.dwMinorVersion:=Minor;
     end;

     case VersionInfo.dwMajorVersion of
     5:
     begin
          // XP et 2003
          if VersionInfo.wProductType = VER_NT_WORKSTATION then result:=W_XP else result:=W_2003;
     end;
     6:
     begin
          // Vista
          if (VersionInfo.dwMinorVersion=0) and (VersionInfo.wProductType = VER_NT_WORKSTATION) then result:=W_Vista else
          // 2008
          if (VersionInfo.dwMinorVersion in [0..1]) and (VersionInfo.wProductType <> VER_NT_WORKSTATION) then result:=W_2008 else
          // 7
          if (VersionInfo.dwMinorVersion=1) and (VersionInfo.wProductType = VER_NT_WORKSTATION) then result:=W_7 else
          // 8
          if (VersionInfo.dwMinorVersion in [2..3]) and (VersionInfo.wProductType = VER_NT_WORKSTATION) then result:=W_8 else
          // 2012
          if (VersionInfo.dwMinorVersion in [2..3]) and (VersionInfo.wProductType <> VER_NT_WORKSTATION) then result:=W_2012 else
     end;
     10 :
     begin
          // 10
          if SubVersion<22000 then result:=W_10 else
          // 11
          result:=W_11;
     end;
     end;
end;

function OSVersionString: string;
begin
     case OSVersion of
     W_XP: result:='Windows XP';
     W_2003: result:='Windows Serveur 2003';
     W_Vista: result:='Windows Vista';
     W_2008: result:='Windows Serveur 2008';
     W_7: result:='Windows 7';
     W_8: result:='Windows 8';
     W_2012: result:='Windows 2012';
     W_10: result:='Windows 10';
     W_11: result:='Windows 11';
     else result:='';
     end;
end;

function OSCompatible(ListOS: TOS): bool;
begin
     case OSVersion of
     W_XP: result:=ListOS.Win_XP;
     W_2003: result:=ListOS.Win_2003;
     W_Vista: result:=ListOS.Win_Vista;
     W_2008: result:=ListOS.Win_2008;
     W_7: result:=ListOS.Win_7;
     W_8: result:=ListOS.Win_8;
     W_2012: result:=ListOS.Win_2012;
     W_10: result:=ListOS.Win_10;
     W_11: result:=ListOS.Win_11;
     else result:=false;
     end;
end;

procedure TUpdateThread.Execute;
var Upd: smallint;
    i: integer;
    LaunchedByService: bool;
    procedure Ajouter(var Chaine: string ; Ajout: string);
    begin
         if Chaine<>'' then Chaine:=Chaine+', ';
         Chaine:=Chaine+Ajout;
    end;
begin
     Erreur:=false;
     LaunchedByService:=SameText(GetParentProcessName, NOMFICHIERSERVICECLIENT);
     if LaunchedByService then Configuration.General.Fenetre_Ouverte:=false;
     try
        EcrireFichierDebug;

        if OSCompatible(Configuration.OS) then
        begin
             EcrireFichierDebug('UpdateSoft : Systme compatible pour le script actif ('+OSVersionString+')');
             // Tlchargement
             if Configuration.General.Mode in [0, 2] then
             begin
                  ForceDirectories(DossierInstallateurs);
                  TransfertInstallateursVersSetup;
                  if Configuration.General.UpdateSoft then
                  begin
                       Upd:=TelechargerUpdateSoft(not LaunchedByService);
                       Erreur:=(Upd=0) or Erreur;
                       if Upd=2 then
                       begin
                            if LaunchedByService then MettreAJour:=UM_NextStart else MettreAJour:=UM_Now;
                            Synchronize(FinThread);
                            exit;
                       end;
                  end;
                  MiseAJourService;
                  if Configuration.Flash.Actif then Erreur:=not TelechargerFlash or Erreur;
                  if Configuration.Firefox.Actif then Erreur:=not TelechargerFirefox or Erreur;
                  if Configuration.Thunderbird.Actif then Erreur:=not TelechargerThunderbird or Erreur;
                  if Configuration.VLC.Actif then Erreur:=not TelechargerVLC or Erreur;
                  if Configuration.AIR.Actif then Erreur:=not TelechargerAIR or Erreur;
                  if Configuration.Index_Education.Actif then Erreur:=not TelechargerIndex_Education or Erreur;
                  if Configuration.Java.Actif then Erreur:=not TelechargerJava or Erreur;
                  EffacerFichier(TEMP_FILE);
             end;
             // Installation
             if Configuration.General.Mode in [1, 2] then
             begin
                  if not (Configuration.General.Mode in [0, 2]) then MiseAJourService;

                  if Configuration.General.AfficherMessage then
                  begin
                       MODETEST:=true;
                       if Configuration.Flash.Actif and (Configuration.Flash.Exclusions.IndexOf(NomOrdinateur)=-1) and InstallerFlash then Ajouter(LeMessage, 'Adobe Flash');
                       if Configuration.Firefox.Actif and InstallerFirefox then Ajouter(LeMessage, 'Firefox');
                       if Configuration.Thunderbird.Actif and InstallerThunderbird then Ajouter(LeMessage, 'Thunderbird');
                       if Configuration.VLC.Actif and InstallerVLC then Ajouter(LeMessage, 'VLC');
                       if Configuration.AIR.Actif and InstallerAIR then Ajouter(LeMessage, 'Adobe AIR');
                       if Configuration.Index_Education.Actif and InstallerIndex_Education then Ajouter(LeMessage, 'Index Education');
                       if Configuration.Java.Actif and (Configuration.Java.Exclusions.IndexOf(NomOrdinateur)=-1) and InstallerJava then Ajouter(LeMessage, 'Java');
                       if LeMessage<>'' then NotifierSessionsActives;
                       MODETEST:=false;
                  end;
                  if Configuration.Flash.Actif and (Configuration.Flash.Exclusions.IndexOf(NomOrdinateur)=-1) then Erreur:=not InstallerFlash or Erreur;
                  if Configuration.Firefox.Actif then Erreur:=not InstallerFirefox or Erreur;
                  if Configuration.Thunderbird.Actif then Erreur:=not InstallerThunderbird or Erreur;
                  if Configuration.VLC.Actif then Erreur:=not InstallerVLC or Erreur;
                  if Configuration.AIR.Actif then Erreur:=not InstallerAIR or Erreur;
                  if Configuration.Index_Education.Actif then Erreur:=not InstallerIndex_Education or Erreur;
                  if Configuration.Java.Actif and (Configuration.Java.Exclusions.IndexOf(NomOrdinateur)=-1) then Erreur:=not InstallerJava or Erreur;
                  if LeMessage<>'' then
                  begin
                       for i:=0 to length(ListeSessionsID)-1 do
                            NotifierSession(ListeSessionsID[i], NOMAPPLI, 'Fin des mises  jour.', 5, true);
                       LeMessage:='';
                       Finalize(ListeSessionsID);
                  end;
             end;
        end
        else EcrireFichierDebug('UpdateSoft : Systme non compatible pour ce script actif ('+OSVersionString+')');
     except
     end;
     Synchronize(FinThread);
end;

procedure TUpdateThread.FinThread;
begin
     if Assigned(FicheJournal) then
     with FicheJournal do
     begin
          if MettreAJour in [UM_Now, UM_NextStart] then
          begin
               if MettreAJour=UM_Now then MettreAJourExecutable;
               halt;
          end
          else
          begin
               HorlogeStop.Enabled:=false;
               if Erreur and Configuration.General.Fenetre and Configuration.General.Fenetre_Ouverte then
               begin
                    Bouton.Tag:=1;
                    if IndexFichierCourant=ParamCount then Bouton.Caption:='&Fin' else Bouton.Caption:='&Continuer';
               end
               else
               begin
                    HorlogeChangementScript.Enabled:=false;
                    HorlogeChangementScript.Enabled:=true;
               end;
          end;
     end;
end;

procedure TFicheJournal.BoutonClick(Sender: TObject);
begin
     if Assigned(UpdateThread) and not UpdateThread.Terminated and (Bouton.Tag=0) then
        if MessageDlg(#13+'Souhaitez-vous stopper l''excution du script en cours ?', mtConfirmation, [mbYes, mbNo], 0)=mrYes then
        begin
             Application.ProcessMessages;
             HorlogeStop.Enabled:=false;
             DestructionThread(UpdateThread, true, true);
             if (IndexFichierCourant<ParamCount) and (MessageDlg(#13+'Souhaitez-vous excuter les script suivants ?', mtConfirmation, [mbYes, mbNo], 0)=mrNo) then IndexFichierCourant:=ParamCount;
        end else exit;
     HorlogeChangementScript.Enabled:=false;
     HorlogeChangementScript.Enabled:=true;
end;

procedure TFicheJournal.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
     CanClose:=IndexFichierCourant=-1;
     if not CanClose then Bouton.Click;
end;

procedure TFicheJournal.HorlogeStopTimer(Sender: TObject);
var i: integer;
begin
     HorlogeStop.Enabled:=false;
     EcrireFichierDebug('UpdateSoft : Arrt du script, dlai dpass');
     try
        if Assigned(UpdateThread) then
        with UpdateThread do
        if LeMessage<>'' then
        begin
             for i:=0 to length(ListeSessionsID)-1 do
                  NotifierSession(ListeSessionsID[i], NOMAPPLI, 'Arrt des mises  jour.', 5, true);
             LeMessage:='';
             Finalize(ListeSessionsID);
        end;
     except
     end;
     DestructionThread(UpdateThread, true, true);
     HorlogeChangementScript.Enabled:=false;
     HorlogeChangementScript.Enabled:=true;
end;

type TMyMenuItem = class(TMenuItem);

procedure TFicheJournal.MenuItemAdvancedDrawItem(Sender: TObject; ACanvas: TCanvas; ARect: TRect; State: TOwnerDrawState);
var OldAdvancedDrawItem: TAdvancedMenuDrawItemEvent;
    i, MaxIndex: integer;
begin
     with ACanvas do
     begin
          MaxIndex:=-1; i:=MainMenu1.Items.Count-1;
          while (MaxIndex=-1) and (i>=0) do if MainMenu1.Items[i].Visible then MaxIndex:=i else Dec(i);
          Brush.Color := Self.Color;
          OldAdvancedDrawItem := TMenuItem(Sender).OnAdvancedDrawItem;
          if (Parent = nil) and (TMenuItem(Sender).MenuIndex = MaxIndex) and not (odHotLight in State) and not (odSelected in State) then
          begin
               ARect.Right := Width;
               FillRect(ARect);
          end;
          try
             TMenuItem(Sender).OnAdvancedDrawItem := nil;
             TMyMenuItem(Sender).AdvancedDrawItem(ACanvas, ARect, State, false);
          finally
             TMenuItem(Sender).OnAdvancedDrawItem := OldAdvancedDrawItem;
          end;
     end;
end;

procedure TFicheJournal.FormDestroy(Sender: TObject);
begin
     if FRegisteredSessionNotification then UnRegisterSessionNotification(Handle);
     HorlogeStop.Enabled:=false;
     HorlogeChangementScript.Enabled:=false;
     DestructionThread(UpdateThread, false, true);
end;

procedure TFicheJournal.AppMessage(var Msg: TMSG; var Handled: Boolean);
begin
     Handled := False;
     if (Msg.Message = WM_WTSSESSION_CHANGE) and Assigned(UpdateThread) and (UpdateThread.LeMessage<>'') then
     case Msg.wParam of
     WTS_CONSOLE_CONNECT, WTS_REMOTE_CONNECT, WTS_SESSION_LOGON: UpdateThread.SessionEvent(msg.Lparam);
     end;
end;

procedure TUpdateThread.NotifierSessionsActives;
type PJwWTSSessionInfoAArray = ^TJwWTSSessionInfoAArray;
     TJwWTSSessionInfoAArray = array[0..0] of WTS_SESSION_INFO;
var pArrSessInfo: PJwWTSSessionInfoAArray;
    SessionCount: DWORD;
    i: integer;
begin
     if WTSEnumerateSessions(WTS_CURRENT_SERVER_HANDLE, 0, 1, PWTS_SESSION_INFO(pArrSessInfo), SessionCount) then
     begin
          for i := 0 to SessionCount-1 do if pArrSessInfo^[i].State=WTSActive then SessionEvent(pArrSessInfo^[i].SessionId);
          WTSFreeMemory(pArrSessInfo);
     end;
end;

procedure TUpdateThread.SessionEvent(SessionID: cardinal);
begin if LeMessage<>'' then NotifierSession(SessionID, NOMAPPLI, 'Des mises  jour sont en cours pour '+LeMessage+'.'+#13+#13+'Attendez le message de fin avant d''utiliser les applications concernes.', 10); end;

end.
