unit LsaApi;

{$WEAKPACKAGEUNIT}

interface

uses Windows, SysUtils;

const STATUS_SUCCESS = 0;

      POLICY_VIEW_LOCAL_INFORMATION              = $00000001;
      POLICY_VIEW_AUDIT_INFORMATION              = $00000002;
      POLICY_GET_PRIVATE_INFORMATION             = $00000004;
      POLICY_TRUST_ADMIN                         = $00000008;
      POLICY_CREATE_ACCOUNT                      = $00000010;
      POLICY_CREATE_SECRET                       = $00000020;
      POLICY_CREATE_PRIVILEGE                    = $00000040;
      POLICY_SET_DEFAULT_QUOTA_LIMITS            = $00000080;
      POLICY_SET_AUDIT_REQUIREMENTS              = $00000100;
      POLICY_AUDIT_LOG_ADMIN                     = $00000200;
      POLICY_SERVER_ADMIN                        = $00000400;
      POLICY_LOOKUP_NAMES                        = $00000800;

      POLICY_ALL_ACCESS     = STANDARD_RIGHTS_REQUIRED         or
                              POLICY_VIEW_LOCAL_INFORMATION    or
                              POLICY_VIEW_AUDIT_INFORMATION    or
                              POLICY_GET_PRIVATE_INFORMATION   or
                              POLICY_TRUST_ADMIN               or
                              POLICY_CREATE_ACCOUNT            or
                              POLICY_CREATE_SECRET             or
                              POLICY_CREATE_PRIVILEGE          or
                              POLICY_SET_DEFAULT_QUOTA_LIMITS  or
                              POLICY_SET_AUDIT_REQUIREMENTS    or
                              POLICY_AUDIT_LOG_ADMIN           or
                              POLICY_SERVER_ADMIN              or
                              POLICY_LOOKUP_NAMES;


      SE_SERVICE_LOGON_NAME             = 'SeServiceLogonRight';

type NTStatus = DWORD;

     LSA_HANDLE = pointer;
     PLSA_HANDLE = ^LSA_HANDLE;

     TLSAUnicodeString = packed record
       Length : WORD;
       MaximumLength : WORD;
       Buffer : PWideChar
     end;
     PLSAUnicodeString = ^TLSAUnicodeString;


     TLSAString = packed record
       Length : WORD;
       MaximumLength : WORD;
       Buffer : PChar;
     end;
     PLSAString = ^TLSAString;

     TLSAObjectAttributes = packed record
       Length : ULONG;
       RootDirectory : THandle;
       ObjectName : PLSAUnicodeString;
       Attributes : ULONG;
       SecurityDescriptor : pointer;
       SecurityQualityOfService : pointer;
     end;
     PLSAObjectAttributes = ^TLSAObjectAttributes;

function LsaOpenPolicy(SystemName : PLsaUnicodeString; const ObjectAttributes : TLsaObjectAttributes; DesiredAccess : ACCESS_MASK; var PolicyHandle : LSA_HANDLE) : NTSTATUS; stdcall;
function LsaAddAccountRights(PolicyHandle : LSA_HANDLE; AccountSid : PSID; const UserRights : PLsaUnicodeString; CountOfRights : ULONG) : NTSTATUS; stdcall;
function LsaNtStatusToWinError(status : NTStatus) : ULONG; stdcall;
function GetAccountSID(AccountName: string ; var SID: PSID): bool;

implementation

const LSADll = 'advapi32.dll';

function LsaOpenPolicy;                     external LSADll;
function LsaAddAccountRights;               external LSADll;
function LsaNtStatusToWinError;             external LSADll;

function GetAccountSID(AccountName: string ; var SID: PSID): bool;
var cbSid: DWORD;
    cbReferencedDomainName : DWORD;
    ReferencedDomainName: string;
    peUse: SID_NAME_USE;
    Success: BOOL;
begin
     result:=false;
     SID:=nil;
     try
        cbSid := 0;
        cbReferencedDomainName := 0;
        Success := LookupAccountName(nil, PChar(AccountName), nil, cbSid, nil, cbReferencedDomainName, peUse);
        if (not Success) and (GetLastError = ERROR_INSUFFICIENT_BUFFER) then
        begin
             SetLength(ReferencedDomainName, cbReferencedDomainName);
             SID := AllocMem(cbSid);
             Result:=LookupAccountName(nil, PChar(AccountName), SID, cbSid, PChar(ReferencedDomainName), cbReferencedDomainName, peUse);
        end;
     except
     end;
end;

end.

