unit TaskScheduler;

interface

uses Windows, SysUtils, ActiveX, OleServer, Classes, Variants, ComObj;

function EnableTask(TaskName: WideString ; Folder: WideString='\'; Enable: bool=true): bool;
function DeleteTask(TaskName: WideString ; Folder: WideString='\'): bool;
function TaskExists(TaskName: WideString ; Folder: WideString='\'): bool;
function CreateDailyTask(TaskName: Widestring ; Folder: WideString='\' ; CommandLine: WideString='' ;  Arguments: WideString='' ;  WorkingDirectory: WideString='' ; Hour: byte = 0 ; Minute: byte=0; Author: WideString='' ; Description: WideString=''): bool;
function GetTaskNextTime(TaskName: WideString ; Folder: WideString='\'): TDateTime;

const TASK_ACTION_EXEC = $00000000;
      TASK_TRIGGER_DAILY = $00000002;
      TASK_CREATE_OR_UPDATE = $00000006;
      TASK_LOGON_SERVICE_ACCOUNT = $00000005;
      TASK_ENUM_HIDDEN = $00000001;
      TASK_FLAG_DISABLED = $4;
      CLSID_CTaskScheduler:   TGUID = '{148BD52A-A2AB-11CE-B11F-00AA00530503}';
      CLSID_CTask:            TGUID = '{148BD520-A2AB-11CE-B11F-00AA00530503}';
      IID_ITask:              TGUID = '{148BD524-A2AB-11CE-B11F-00AA00530503}';
      IID_IPersistFile:       TGUID = '{0000010B-0000-0000-C000-000000000046}';

type
  _TASK_LOGON_TYPE = TOleEnum;
  _TASK_STATE = TOleEnum;
  _TASK_TRIGGER_TYPE2 = TOleEnum;
  _TASK_INSTANCES_POLICY = TOleEnum;
  _TASK_RUNLEVEL = TOleEnum;
  _TASK_COMPATIBILITY = TOleEnum;
  _TASK_ACTION_TYPE = TOleEnum;

  PUserType1 = ^_SYSTEMTIME; {*}

  TTriggerType = (TASK_TIME_TRIGGER_ONCE,
                  TASK_TIME_TRIGGER_DAILY,
                  TASK_TIME_TRIGGER_WEEKLY,
                  TASK_TIME_TRIGGER_MONTHLYDATE,
                  TASK_TIME_TRIGGER_MONTHLYDOW,
                  TASK_EVENT_TRIGGER_ON_IDLE,
                  TASK_EVENT_TRIGGER_AT_SYSTEMSTART,
                  TASK_EVENT_TRIGGER_AT_LOGON);
  TASK_TRIGGER_TYPE  = TTriggerType;

  TDaily = record
    DaysInterval: WORD;
  end;

  TWeekly = record
    WeeksInterval: WORD;
    rgfDaysOfTheWeek: WORD;
  end;

  TMonthlyDate = record
    rgfDays: DWORD;
    rgfMonths: WORD;
  end;

  TMonthlyDow = record
    wWhichWeek: WORD;
    rgfDaysOfTheWeek: WORD;
    rgfMonths: WORD;
  end;
  TTriggerTypeUnion = record
    case Integer of
      1: (Daily: TDaily);
      2: (Weekly: TWeekly);
      3: (MonthlyDate: TMonthlyDate);
      4: (MonthlyDOW: TMonthlyDow);
  end;  

  ITaskService = interface;
  ITaskFolder = interface;
  IRunningTaskCollection = interface;
  ITaskDefinition = interface;
  ITaskFolderCollection = interface;
  IRegisteredTask = interface;
  IRegisteredTaskCollection = interface;
  IRunningTask = interface;
  IRegistrationInfo = interface;
  ITriggerCollection = interface;
  ITaskSettings = interface;
  IPrincipal = interface;
  IActionCollection = interface;
  ITrigger = interface;
  IIdleSettings = interface;
  INetworkSettings = interface;
  IRepetitionPattern = interface;
  IAction = interface;
  ITaskScheduler     = interface;
  IScheduledWorkItem = interface;
  ITask              = interface;
  ITaskTrigger       = interface;
  IEnumWorkItems     = interface;

  TTaskTrigger = record
    cbTriggerSize   : WORD;
    Reserved1       : WORD;
    wBeginYear      : WORD;
    wBeginMonth     : WORD;
    wBeginDay       : WORD;
    wEndYear        : WORD;
    wEndMonth       : WORD;
    wEndDay         : WORD;
    wStartHour      : WORD;
    wStartMinute    : WORD;
    MinutesDuration : DWORD;
    MinutesInterval : DWORD;
    rgFlags         : DWORD;
    TriggerType     : TASK_TRIGGER_TYPE;
    AnyType         : TTriggerTypeUnion;
    Reserved2       : WORD;
    wRandomMinutesInterval: WORD;
  end;

  IEnumWorkItems = interface
    ['{148BD528-A2AB-11CE-B11F-00AA00530503}']
    function Next(celt: ULONG; out rgpwszNames: PLPWSTR; out pceltFetched: ULONG): HRESULT; stdcall;
    function Skip(celt: ULONG): HRESULT; stdcall;
    function Reset: HRESULT; stdcall;
    function Clone(out pEnumWorkItems: IEnumWorkItems): HRESULT; stdcall;
  end;  

  ITaskTrigger = interface
    ['{148BD52A-A2AB-11CE-B11F-00AA00530503}']
    function SetTrigger(const pTrigger: TTaskTrigger): HRESULT; stdcall;
    function GetTrigger(out pTrigger: TTaskTrigger): HRESULT; stdcall;
    function GetTriggerString(out ppwszTrigger: PWideChar): HRESULT; stdcall;
  end;

  ITaskScheduler = interface
    ['{148BD527-A2AB-11CE-B11F-00AA00530503}']
    function SetTargetComputer(pwszComputer: PWideChar): HRESULT; stdcall;
    function GetTargetComputer(out ppwszComputer: PWideChar): HRESULT; stdcall;
    function Enum(out ppEnumWorkItems: IEnumWorkItems): HRESULT; stdcall;
    function Activate(pwszName: PWideChar; const riid: TGUID; out ppUnk: IUnknown): HRESULT; stdcall;
    function Delete(pwszName: PWideChar): HRESULT; stdcall;
    function NewWorkItem(pwszTaskName: PWideChar; const rclsid: TCLSID; const riid: TGUID; out ppUnk: IUnknown): HRESULT; stdcall;
    function AddWorkItem(pwszTaskName: PWideChar; pWorkItem: IScheduledWorkItem): HRESULT; stdcall;
    function IsOfType(pwszName: PWideChar; const riid: TGUID): HRESULT; stdcall;
  end;

  IScheduledWorkItem = interface
    ['{a6b952f0-a4b1-11d0-997d-00aa006887ec}']
    function CreateTrigger(out piNewTrigger: WORD; out ppTrigger: ITaskTrigger): HRESULT; stdcall;
    function DeleteTrigger(iTrigger: WORD): HRESULT; stdcall;
    function GetTriggerCount(out pwCount: WORD): HRESULT; stdcall;
    function GetTrigger(iTrigger: WORD; out ppTrigger: ITaskTrigger): HRESULT; stdcall;
    function GetTriggerString(iTrigger: WORD; out ppwszTrigger: PWideString): HRESULT; stdcall;
    function GetRunTimes(const pstBegin: TSystemTime; const pstEnd: TSystemTime; out pCount: WORD; out rgstTaskTimes: TSystemTime): HRESULT; stdcall;
    function GetNextRunTime(out pstNextRun: TSystemTime): HRESULT; stdcall;
    function SetIdleWait(wIdleMinutes: WORD; wDeadlineMinutes: WORD): HRESULT; stdcall;
    function GetIdleWait(out pwIdleMinutes: WORD; out pwDeadlineMinutes: WORD): HRESULT; stdcall;
    function Run: HRESULT; stdcall;
    function Terminate: HRESULT; stdcall;
    function EditWorkItem(hParent: HWND; dwReserved: DWORD): HRESULT; stdcall;
    function GetMostRecentRunTime(out pstLastRun: TSystemTime): HRESULT; stdcall;
    function GetStatus(out phrStatus: HRESULT): HRESULT; stdcall;
    function GetExitCode(out pdwExitCode: DWORD): HRESULT; stdcall;
    function SetComment(pwszComment: PWideChar): HRESULT; stdcall;
    function GetComment(out ppwszComment: PWideChar): HRESULT; stdcall;
    function SetCreator(pwszCreator: PWideChar): HRESULT; stdcall;
    function GetCreator(out ppwszCreator: PWideChar): HRESULT; stdcall;
    function SetWorkItemData(cbData: WORD; var rgbData: BYTE): HRESULT; stdcall;
    function GetWorkItemData(out pcbData: WORD; out prgbData: BYTE): HRESULT; stdcall;
    function SetErrorRetryCount(wRetryCount: WORD): HRESULT; stdcall;
    function GetErrorRetryCount(out pwRetryCount: WORD): HRESULT; stdcall;
    function SetErrorRetryInterval(wRetryInterval: WORD): HRESULT; stdcall;
    function GetErrorRetryInterval(out pwRetryInterval: WORD): HRESULT; stdcall;
    function SetFlags(dwFlags: DWORD): HRESULT; stdcall;
    function GetFlags(out pdwFlags: DWORD): HRESULT; stdcall;
    function SetAccountInformation(pwszAccountName: PWideChar; pwszPassword: PWideChar): HRESULT; stdcall;
    function GetAccountInformation(out ppwszAccountName: PWideChar): HRESULT; stdcall;
  end;

  ITask = interface(IScheduledWorkItem)
    ['{148BD524-A2AB-11CE-B11F-00AA00530503}']
    function SetApplicationName(pwszApplicationName: PWideChar): HRESULT; stdcall;
    function GetApplicationName(out ppwszApplicationName: PWideChar): HRESULT; stdcall;
    function SetParameters(pwszParameters: PWideChar): HRESULT; stdcall;
    function GetParameters(out ppwszParameters: PWideChar): HRESULT; stdcall;
    function SetWorkingDirectory(pwszWorkingDirectory: PWideChar): HRESULT; stdcall;
    function GetWorkingDirectory(out ppwszWorkingDirectory: PWideChar): HRESULT; stdcall;
    function SetPriority(dwPriority: DWORD): HRESULT; stdcall;
    function GetPriority(out pdwPriority: DWORD): HRESULT; stdcall;
    function SetTaskFlags(dwFlags: DWORD): HRESULT; stdcall;
    function GetTaskFlags(out pdwFlags: DWORD): HRESULT; stdcall;
    function SetMaxRunTime(dwMaxRunTimeMS: DWORD): HRESULT; stdcall;
    function GetMaxRunTime(out pdwMaxRunTimeMS: DWORD): HRESULT; stdcall;
  end;

// *********************************************************************//
// Interface   : IRepetitionPattern
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {7FB9ACF1-26BE-400E-85B5-294B9C75DFD6}
// *********************************************************************//
  IRepetitionPattern = interface(IDispatch)
    ['{7FB9ACF1-26BE-400E-85B5-294B9C75DFD6}']
    function Get_Interval: WideString; safecall;
    procedure Set_Interval(const pInterval: WideString); safecall;
    function Get_Duration: WideString; safecall;
    procedure Set_Duration(const pDuration: WideString); safecall;
    function Get_StopAtDurationEnd: WordBool; safecall;
    procedure Set_StopAtDurationEnd(pStop: WordBool); safecall;
    property Interval: WideString read Get_Interval write Set_Interval;
    property Duration: WideString read Get_Duration write Set_Duration;
    property StopAtDurationEnd: WordBool read Get_StopAtDurationEnd write Set_StopAtDurationEnd;
  end;

// *********************************************************************//
// Interface   : ITrigger
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {09941815-EA89-4B5B-89E0-2A773801FAC3}
// *********************************************************************//
  ITrigger = interface(IDispatch)
    ['{09941815-EA89-4B5B-89E0-2A773801FAC3}']
    function Get_type_: _TASK_TRIGGER_TYPE2; safecall;
    function Get_Id: WideString; safecall;
    procedure Set_Id(const pId: WideString); safecall;
    function Get_Repetition: IRepetitionPattern; safecall;
    procedure Set_Repetition(const ppRepeat: IRepetitionPattern); safecall;
    function Get_ExecutionTimeLimit: WideString; safecall;
    procedure Set_ExecutionTimeLimit(const pTimeLimit: WideString); safecall;
    function Get_StartBoundary: WideString; safecall;
    procedure Set_StartBoundary(const pStart: WideString); safecall;
    function Get_EndBoundary: WideString; safecall;
    procedure Set_EndBoundary(const pEnd: WideString); safecall;
    function Get_Enabled: WordBool; safecall;
    procedure Set_Enabled(pEnabled: WordBool); safecall;
    property type_: _TASK_TRIGGER_TYPE2 read Get_type_;
    property Id: WideString read Get_Id write Set_Id;
    property Repetition: IRepetitionPattern read Get_Repetition write Set_Repetition;
    property ExecutionTimeLimit: WideString read Get_ExecutionTimeLimit write Set_ExecutionTimeLimit;
    property StartBoundary: WideString read Get_StartBoundary write Set_StartBoundary;
    property EndBoundary: WideString read Get_EndBoundary write Set_EndBoundary;
    property Enabled: WordBool read Get_Enabled write Set_Enabled;
  end;
  

// *********************************************************************//
// Interface   : IAction
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {BAE54997-48B1-4CBE-9965-D6BE263EBEA4}
// *********************************************************************//
  IAction = interface(IDispatch)
    ['{BAE54997-48B1-4CBE-9965-D6BE263EBEA4}']
    function Get_Id: WideString; safecall;
    procedure Set_Id(const pId: WideString); safecall;
    function Get_type_: _TASK_ACTION_TYPE; safecall;
    property Id: WideString read Get_Id write Set_Id;
    property type_: _TASK_ACTION_TYPE read Get_type_;
  end;

// *********************************************************************//
// Interface   : IExecAction
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {4C3D624D-FD6B-49A3-B9B7-09CB3CD3F047}
// *********************************************************************//
  IExecAction = interface(IAction)
    ['{4C3D624D-FD6B-49A3-B9B7-09CB3CD3F047}']
    function Get_Path: WideString; safecall;
    procedure Set_Path(const pPath: WideString); safecall;
    function Get_Arguments: WideString; safecall;
    procedure Set_Arguments(const pArgument: WideString); safecall;
    function Get_WorkingDirectory: WideString; safecall;
    procedure Set_WorkingDirectory(const pWorkingDirectory: WideString); safecall;
    property Path: WideString read Get_Path write Set_Path;
    property Arguments: WideString read Get_Arguments write Set_Arguments;
    property WorkingDirectory: WideString read Get_WorkingDirectory write Set_WorkingDirectory;
  end;
  
// *********************************************************************//
// Interface   : IActionCollection
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {02820E19-7B98-4ED2-B2E8-FDCCCEFF619B}
// *********************************************************************//
  IActionCollection = interface(IDispatch)
    ['{02820E19-7B98-4ED2-B2E8-FDCCCEFF619B}']
    function Get_Count: Integer; safecall;
    function Get_Item(index: Integer): IAction; safecall;
    function Get__NewEnum: IUnknown; safecall;
    function Get_XmlText: WideString; safecall;
    procedure Set_XmlText(const pText: WideString); safecall;
    function Create(Type_: _TASK_ACTION_TYPE): IAction; safecall;
    procedure Remove(index: OleVariant); safecall;
    procedure Clear; safecall;
    function Get_Context: WideString; safecall;
    procedure Set_Context(const pContext: WideString); safecall;
    property Count: Integer read Get_Count;
    property Item[index: Integer]: IAction read Get_Item; default;
    property _NewEnum: IUnknown read Get__NewEnum;
    property XmlText: WideString read Get_XmlText write Set_XmlText;
    property Context: WideString read Get_Context write Set_Context;
  end;
  

// *********************************************************************//
// Interface   : IPrincipal
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {D98D51E5-C9B4-496A-A9C1-18980261CF0F}
// *********************************************************************//
  IPrincipal = interface(IDispatch)
    ['{D98D51E5-C9B4-496A-A9C1-18980261CF0F}']
    function Get_Id: WideString; safecall;
    procedure Set_Id(const pId: WideString); safecall;
    function Get_DisplayName: WideString; safecall;
    procedure Set_DisplayName(const pName: WideString); safecall;
    function Get_UserId: WideString; safecall;
    procedure Set_UserId(const pUser: WideString); safecall;
    function Get_LogonType: _TASK_LOGON_TYPE; safecall;
    procedure Set_LogonType(pLogon: _TASK_LOGON_TYPE); safecall;
    function Get_GroupId: WideString; safecall;
    procedure Set_GroupId(const pGroup: WideString); safecall;
    function Get_RunLevel: _TASK_RUNLEVEL; safecall;
    procedure Set_RunLevel(pRunLevel: _TASK_RUNLEVEL); safecall;
    property Id: WideString read Get_Id write Set_Id;
    property DisplayName: WideString read Get_DisplayName write Set_DisplayName;
    property UserId: WideString read Get_UserId write Set_UserId;
    property LogonType: _TASK_LOGON_TYPE read Get_LogonType write Set_LogonType;
    property GroupId: WideString read Get_GroupId write Set_GroupId;
    property RunLevel: _TASK_RUNLEVEL read Get_RunLevel write Set_RunLevel;
  end;
  
// *********************************************************************//
// Interface   : INetworkSettings
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {9F7DEA84-C30B-4245-80B6-00E9F646F1B4}
// *********************************************************************//
  INetworkSettings = interface(IDispatch)
    ['{9F7DEA84-C30B-4245-80B6-00E9F646F1B4}']
    function Get_Name: WideString; safecall;
    procedure Set_Name(const pName: WideString); safecall;
    function Get_Id: WideString; safecall;
    procedure Set_Id(const pId: WideString); safecall;
    property Name: WideString read Get_Name write Set_Name;
    property Id: WideString read Get_Id write Set_Id;
  end;

// *********************************************************************//
// Interface   : ITaskSettings
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {8FD4711D-2D02-4C8C-87E3-EFF699DE127E}
// *********************************************************************//
  ITaskSettings = interface(IDispatch)
    ['{8FD4711D-2D02-4C8C-87E3-EFF699DE127E}']
    function Get_AllowDemandStart: WordBool; safecall;
    procedure Set_AllowDemandStart(pAllowDemandStart: WordBool); safecall;
    function Get_RestartInterval: WideString; safecall;
    procedure Set_RestartInterval(const pRestartInterval: WideString); safecall;
    function Get_RestartCount: SYSINT; safecall;
    procedure Set_RestartCount(pRestartCount: SYSINT); safecall;
    function Get_MultipleInstances: _TASK_INSTANCES_POLICY; safecall;
    procedure Set_MultipleInstances(pPolicy: _TASK_INSTANCES_POLICY); safecall;
    function Get_StopIfGoingOnBatteries: WordBool; safecall;
    procedure Set_StopIfGoingOnBatteries(pStopIfOnBatteries: WordBool); safecall;
    function Get_DisallowStartIfOnBatteries: WordBool; safecall;
    procedure Set_DisallowStartIfOnBatteries(pDisallowStart: WordBool); safecall;
    function Get_AllowHardTerminate: WordBool; safecall;
    procedure Set_AllowHardTerminate(pAllowHardTerminate: WordBool); safecall;
    function Get_StartWhenAvailable: WordBool; safecall;
    procedure Set_StartWhenAvailable(pStartWhenAvailable: WordBool); safecall;
    function Get_XmlText: WideString; safecall;
    procedure Set_XmlText(const pText: WideString); safecall;
    function Get_RunOnlyIfNetworkAvailable: WordBool; safecall;
    procedure Set_RunOnlyIfNetworkAvailable(pRunOnlyIfNetworkAvailable: WordBool); safecall;
    function Get_ExecutionTimeLimit: WideString; safecall;
    procedure Set_ExecutionTimeLimit(const pExecutionTimeLimit: WideString); safecall;
    function Get_Enabled: WordBool; safecall;
    procedure Set_Enabled(pEnabled: WordBool); safecall;
    function Get_DeleteExpiredTaskAfter: WideString; safecall;
    procedure Set_DeleteExpiredTaskAfter(const pExpirationDelay: WideString); safecall;
    function Get_Priority: SYSINT; safecall;
    procedure Set_Priority(pPriority: SYSINT); safecall;
    function Get_Compatibility: _TASK_COMPATIBILITY; safecall;
    procedure Set_Compatibility(pCompatLevel: _TASK_COMPATIBILITY); safecall;
    function Get_Hidden: WordBool; safecall;
    procedure Set_Hidden(pHidden: WordBool); safecall;
    function Get_IdleSettings: IIdleSettings; safecall;
    procedure Set_IdleSettings(const ppIdleSettings: IIdleSettings); safecall;
    function Get_RunOnlyIfIdle: WordBool; safecall;
    procedure Set_RunOnlyIfIdle(pRunOnlyIfIdle: WordBool); safecall;
    function Get_WakeToRun: WordBool; safecall;
    procedure Set_WakeToRun(pWake: WordBool); safecall;
    function Get_NetworkSettings: INetworkSettings; safecall;
    procedure Set_NetworkSettings(const ppNetworkSettings: INetworkSettings); safecall;
    property AllowDemandStart: WordBool read Get_AllowDemandStart write Set_AllowDemandStart;
    property RestartInterval: WideString read Get_RestartInterval write Set_RestartInterval;
    property RestartCount: SYSINT read Get_RestartCount write Set_RestartCount;
    property MultipleInstances: _TASK_INSTANCES_POLICY read Get_MultipleInstances write Set_MultipleInstances;
    property StopIfGoingOnBatteries: WordBool read Get_StopIfGoingOnBatteries write Set_StopIfGoingOnBatteries;
    property DisallowStartIfOnBatteries: WordBool read Get_DisallowStartIfOnBatteries write Set_DisallowStartIfOnBatteries;
    property AllowHardTerminate: WordBool read Get_AllowHardTerminate write Set_AllowHardTerminate;
    property StartWhenAvailable: WordBool read Get_StartWhenAvailable write Set_StartWhenAvailable;
    property XmlText: WideString read Get_XmlText write Set_XmlText;
    property RunOnlyIfNetworkAvailable: WordBool read Get_RunOnlyIfNetworkAvailable write Set_RunOnlyIfNetworkAvailable;
    property ExecutionTimeLimit: WideString read Get_ExecutionTimeLimit write Set_ExecutionTimeLimit;
    property Enabled: WordBool read Get_Enabled write Set_Enabled;
    property DeleteExpiredTaskAfter: WideString read Get_DeleteExpiredTaskAfter write Set_DeleteExpiredTaskAfter;
    property Priority: SYSINT read Get_Priority write Set_Priority;
    property Compatibility: _TASK_COMPATIBILITY read Get_Compatibility write Set_Compatibility;
    property Hidden: WordBool read Get_Hidden write Set_Hidden;
    property IdleSettings: IIdleSettings read Get_IdleSettings write Set_IdleSettings;
    property RunOnlyIfIdle: WordBool read Get_RunOnlyIfIdle write Set_RunOnlyIfIdle;
    property WakeToRun: WordBool read Get_WakeToRun write Set_WakeToRun;
    property NetworkSettings: INetworkSettings read Get_NetworkSettings write Set_NetworkSettings;
  end;

// *********************************************************************//
// Interface   : IIdleSettings
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {84594461-0053-4342-A8FD-088FABF11F32}
// *********************************************************************//
  IIdleSettings = interface(IDispatch)
    ['{84594461-0053-4342-A8FD-088FABF11F32}']
    function Get_IdleDuration: WideString; safecall;
    procedure Set_IdleDuration(const pDelay: WideString); safecall;
    function Get_WaitTimeout: WideString; safecall;
    procedure Set_WaitTimeout(const pTimeout: WideString); safecall;
    function Get_StopOnIdleEnd: WordBool; safecall;
    procedure Set_StopOnIdleEnd(pStop: WordBool); safecall;
    function Get_RestartOnIdle: WordBool; safecall;
    procedure Set_RestartOnIdle(pRestart: WordBool); safecall;
    property IdleDuration: WideString read Get_IdleDuration write Set_IdleDuration;
    property WaitTimeout: WideString read Get_WaitTimeout write Set_WaitTimeout;
    property StopOnIdleEnd: WordBool read Get_StopOnIdleEnd write Set_StopOnIdleEnd;
    property RestartOnIdle: WordBool read Get_RestartOnIdle write Set_RestartOnIdle;
  end;
  
// *********************************************************************//
// Interface   : ITriggerCollection
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {85DF5081-1B24-4F32-878A-D9D14DF4CB77}
// *********************************************************************//
  ITriggerCollection = interface(IDispatch)
    ['{85DF5081-1B24-4F32-878A-D9D14DF4CB77}']
    function Get_Count: Integer; safecall;
    function Get_Item(index: Integer): ITrigger; safecall;
    function Get__NewEnum: IUnknown; safecall;
    function Create(Type_: _TASK_TRIGGER_TYPE2): ITrigger; safecall;
    procedure Remove(index: OleVariant); safecall;
    procedure Clear; safecall;
    property Count: Integer read Get_Count;
    property Item[index: Integer]: ITrigger read Get_Item; default;
    property _NewEnum: IUnknown read Get__NewEnum;
  end;

// *********************************************************************//
// Interface   : IRegistrationInfo
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {416D8B73-CB41-4EA1-805C-9BE9A5AC4A74}
// *********************************************************************//
  IRegistrationInfo = interface(IDispatch)
    ['{416D8B73-CB41-4EA1-805C-9BE9A5AC4A74}']
    function Get_Description: WideString; safecall;
    procedure Set_Description(const pDescription: WideString); safecall;
    function Get_Author: WideString; safecall;
    procedure Set_Author(const pAuthor: WideString); safecall;
    function Get_Version: WideString; safecall;
    procedure Set_Version(const pVersion: WideString); safecall;
    function Get_Date: WideString; safecall;
    procedure Set_Date(const pDate: WideString); safecall;
    function Get_Documentation: WideString; safecall;
    procedure Set_Documentation(const pDocumentation: WideString); safecall;
    function Get_XmlText: WideString; safecall;
    procedure Set_XmlText(const pText: WideString); safecall;
    function Get_URI: WideString; safecall;
    procedure Set_URI(const pUri: WideString); safecall;
    function Get_SecurityDescriptor: OleVariant; safecall;
    procedure Set_SecurityDescriptor(pSddl: OleVariant); safecall;
    function Get_Source: WideString; safecall;
    procedure Set_Source(const pSource: WideString); safecall;
    property Description: WideString read Get_Description write Set_Description;
    property Author: WideString read Get_Author write Set_Author;
    property Version: WideString read Get_Version write Set_Version;
    property Date: WideString read Get_Date write Set_Date;
    property Documentation: WideString read Get_Documentation write Set_Documentation;
    property XmlText: WideString read Get_XmlText write Set_XmlText;
    property URI: WideString read Get_URI write Set_URI;
    property SecurityDescriptor: OleVariant read Get_SecurityDescriptor write Set_SecurityDescriptor;
    property Source: WideString read Get_Source write Set_Source;
  end;
  
// *********************************************************************//
// Interface   : IRunningTask
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {653758FB-7B9A-4F1E-A471-BEEB8E9B834E}
// *********************************************************************//
  IRunningTask = interface(IDispatch)
    ['{653758FB-7B9A-4F1E-A471-BEEB8E9B834E}']
    function Get_Name: WideString; safecall;
    function Get_InstanceGuid: WideString; safecall;
    function Get_Path: WideString; safecall;
    function Get_State: _TASK_STATE; safecall;
    function Get_CurrentAction: WideString; safecall;
    procedure Stop; safecall;
    procedure Refresh; safecall;
    function Get_EnginePID: LongWord; safecall;
    property Name: WideString read Get_Name;
    property InstanceGuid: WideString read Get_InstanceGuid;
    property Path: WideString read Get_Path;
    property State: _TASK_STATE read Get_State;
    property CurrentAction: WideString read Get_CurrentAction;
    property EnginePID: LongWord read Get_EnginePID;
  end;
  
// *********************************************************************//
// Interface   : IRegisteredTaskCollection
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {86627EB4-42A7-41E4-A4D9-AC33A72F2D52}
// *********************************************************************//
  IRegisteredTaskCollection = interface(IDispatch)
    ['{86627EB4-42A7-41E4-A4D9-AC33A72F2D52}']
    function Get_Count: Integer; safecall;
    function Get_Item(index: OleVariant): IRegisteredTask; safecall;
    function Get__NewEnum: IUnknown; safecall;
    property Count: Integer read Get_Count;
    property Item[index: OleVariant]: IRegisteredTask read Get_Item; default;
    property _NewEnum: IUnknown read Get__NewEnum;
  end;
  

// *********************************************************************//
// Interface   : ITaskDefinition
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {F5BC8FC5-536D-4F77-B852-FBC1356FDEB6}
// *********************************************************************//
  ITaskDefinition = interface(IDispatch)
    ['{F5BC8FC5-536D-4F77-B852-FBC1356FDEB6}']
    function Get_RegistrationInfo: IRegistrationInfo; safecall;
    procedure Set_RegistrationInfo(const ppRegistrationInfo: IRegistrationInfo); safecall;
    function Get_Triggers: ITriggerCollection; safecall;
    procedure Set_Triggers(const ppTriggers: ITriggerCollection); safecall;
    function Get_Settings: ITaskSettings; safecall;
    procedure Set_Settings(const ppSettings: ITaskSettings); safecall;
    function Get_Data: WideString; safecall;
    procedure Set_Data(const pData: WideString); safecall;
    function Get_Principal: IPrincipal; safecall;
    procedure Set_Principal(const ppPrincipal: IPrincipal); safecall;
    function Get_Actions: IActionCollection; safecall;
    procedure Set_Actions(const ppActions: IActionCollection); safecall;
    function Get_XmlText: WideString; safecall;
    procedure Set_XmlText(const pXml: WideString); safecall;
    property RegistrationInfo: IRegistrationInfo read Get_RegistrationInfo write Set_RegistrationInfo;
    property Triggers: ITriggerCollection read Get_Triggers write Set_Triggers;
    property Settings: ITaskSettings read Get_Settings write Set_Settings;
    property Data: WideString read Get_Data write Set_Data;
    property Principal: IPrincipal read Get_Principal write Set_Principal;
    property Actions: IActionCollection read Get_Actions write Set_Actions;
    property XmlText: WideString read Get_XmlText write Set_XmlText;
  end;
  
// *********************************************************************//
// Interface   : IRunningTaskCollection
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {6A67614B-6828-4FEC-AA54-6D52E8F1F2DB}
// *********************************************************************//
  IRunningTaskCollection = interface(IDispatch)
    ['{6A67614B-6828-4FEC-AA54-6D52E8F1F2DB}']
    function Get_Count: Integer; safecall;
    function Get_Item(index: OleVariant): IRunningTask; safecall;
    function Get__NewEnum: IUnknown; safecall;
    property Count: Integer read Get_Count;
    property Item[index: OleVariant]: IRunningTask read Get_Item; default;
    property _NewEnum: IUnknown read Get__NewEnum;
  end;  

// *********************************************************************//
// Interface   : ITaskService
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {2FABA4C7-4DA9-4013-9697-20CC3FD40F85}
// *********************************************************************//
  ITaskService = interface(IDispatch)
    ['{2FABA4C7-4DA9-4013-9697-20CC3FD40F85}']
    function GetFolder(const Path: WideString): ITaskFolder; safecall;
    function GetRunningTasks(flags: Integer): IRunningTaskCollection; safecall;
    function NewTask(flags: LongWord): ITaskDefinition; safecall;
    procedure Connect(serverName: OleVariant; user: OleVariant; domain: OleVariant; 
                      password: OleVariant); safecall;
    function Get_Connected: WordBool; safecall;
    function Get_TargetServer: WideString; safecall;
    function Get_ConnectedUser: WideString; safecall;
    function Get_ConnectedDomain: WideString; safecall;
    function Get_HighestVersion: LongWord; safecall;
    property Connected: WordBool read Get_Connected;
    property TargetServer: WideString read Get_TargetServer;
    property ConnectedUser: WideString read Get_ConnectedUser;
    property ConnectedDomain: WideString read Get_ConnectedDomain;
    property HighestVersion: LongWord read Get_HighestVersion;
  end;
    
// *********************************************************************//
// Dclaration de classe proxy de serveur OLE
// Objet serveur        : TTaskScheduler
// Chane d'aide        : 
// Interface par dfaut : ITaskService
// DISP Int. Df. ?     : No
// Interface vnements : 
// TypeFlags            : (2) CanCreate
// *********************************************************************//
  TTaskScheduler = class(TOleServer)
  private
    FIntf:        ITaskService;
    function      GetDefaultInterface: ITaskService;
  protected
    procedure InitServerData; override;
    function Get_Connected: WordBool;
    function Get_TargetServer: WideString;
    function Get_ConnectedUser: WideString;
    function Get_ConnectedDomain: WideString;
    function Get_HighestVersion: LongWord;
  public
    procedure Connect; override;
    procedure ConnectTo(svrIntf: ITaskService);
    procedure Disconnect; override;
    function GetFolder(const Path: WideString): ITaskFolder;
    function GetRunningTasks(flags: Integer): IRunningTaskCollection;
    function NewTask(flags: LongWord): ITaskDefinition;
    procedure Connect1; overload;
    procedure Connect1(serverName: OleVariant); overload;
    procedure Connect1(serverName: OleVariant; user: OleVariant); overload;
    procedure Connect1(serverName: OleVariant; user: OleVariant; domain: OleVariant); overload;
    procedure Connect1(serverName: OleVariant; user: OleVariant; domain: OleVariant; 
                       password: OleVariant); overload;
    property DefaultInterface: ITaskService read GetDefaultInterface;
    property Connected: WordBool read Get_Connected;
    property TargetServer: WideString read Get_TargetServer;
    property ConnectedUser: WideString read Get_ConnectedUser;
    property ConnectedDomain: WideString read Get_ConnectedDomain;
    property HighestVersion: LongWord read Get_HighestVersion;
  end;

// *********************************************************************//
// Interface   : ITaskFolder
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {8CFAC062-A080-4C15-9A88-AA7C2AF80DFC}
// *********************************************************************//
  ITaskFolder = interface(IDispatch)
    ['{8CFAC062-A080-4C15-9A88-AA7C2AF80DFC}']
    function Get_Name: WideString; safecall;
    function Get_Path: WideString; safecall;
    function GetFolder(const Path: WideString): ITaskFolder; safecall;
    function GetFolders(flags: Integer): ITaskFolderCollection; safecall;
    function CreateFolder(const subFolderName: WideString; sddl: OleVariant): ITaskFolder; safecall;
    procedure DeleteFolder(const subFolderName: WideString; flags: Integer); safecall;
    function GetTask(const Path: WideString): IRegisteredTask; safecall;
    function GetTasks(flags: Integer): IRegisteredTaskCollection; safecall;
    procedure DeleteTask(const Name: WideString; flags: Integer); safecall;
    function RegisterTask(const Path: WideString; const XmlText: WideString; flags: Integer;
                          UserId: OleVariant; password: OleVariant; LogonType: _TASK_LOGON_TYPE;
                          sddl: OleVariant): IRegisteredTask; safecall;
    function RegisterTaskDefinition(const Path: WideString; const pDefinition: ITaskDefinition;
                                    flags: Integer; UserId: OleVariant; password: OleVariant;
                                    LogonType: _TASK_LOGON_TYPE; sddl: OleVariant): IRegisteredTask; safecall;
    function GetSecurityDescriptor(securityInformation: Integer): WideString; safecall;
    procedure SetSecurityDescriptor(const sddl: WideString; flags: Integer); safecall;
    property Name: WideString read Get_Name;
    property Path: WideString read Get_Path;
  end;

// *********************************************************************//
// Interface   : ITaskFolderCollection
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {79184A66-8664-423F-97F1-637356A5D812}
// *********************************************************************//
  ITaskFolderCollection = interface(IDispatch)
    ['{79184A66-8664-423F-97F1-637356A5D812}']
    function Get_Count: Integer; safecall;
    function Get_Item(index: OleVariant): ITaskFolder; safecall;
    function Get__NewEnum: IUnknown; safecall;
    property Count: Integer read Get_Count;
    property Item[index: OleVariant]: ITaskFolder read Get_Item; default;
    property _NewEnum: IUnknown read Get__NewEnum;
  end;


// *********************************************************************//
// Interface   : IRegisteredTask
// Indicateurs : (4544) Dual NonExtensible OleAutomation Dispatchable
// GUID        : {9C86F320-DEE3-4DD1-B972-A303F26B061E}
// *********************************************************************//
  IRegisteredTask = interface(IDispatch)
    ['{9C86F320-DEE3-4DD1-B972-A303F26B061E}']
    function Get_Name: WideString; safecall;
    function Get_Path: WideString; safecall;
    function Get_State: _TASK_STATE; safecall;
    function Get_Enabled: WordBool; safecall;
    procedure Set_Enabled(pEnabled: WordBool); safecall;
    function Run(params: OleVariant): IRunningTask; safecall;
    function RunEx(params: OleVariant; flags: Integer; sessionID: Integer; const user: WideString): IRunningTask; safecall;
    function GetInstances(flags: Integer): IRunningTaskCollection; safecall;
    function Get_LastRunTime: TDateTime; safecall;
    function Get_LastTaskResult: Integer; safecall;
    function Get_NumberOfMissedRuns: Integer; safecall;
    function Get_NextRunTime: TDateTime; safecall;
    function Get_Definition: ITaskDefinition; safecall;
    function Get_Xml: WideString; safecall;
    function GetSecurityDescriptor(securityInformation: Integer): WideString; safecall;
    procedure SetSecurityDescriptor(const sddl: WideString; flags: Integer); safecall;
    procedure Stop(flags: Integer); safecall;
    procedure GetRunTimes(var pstStart: _SYSTEMTIME; var pstEnd: _SYSTEMTIME; var pCount: LongWord; 
                          out pRunTimes: PUserType1); safecall;
    property Name: WideString read Get_Name;
    property Path: WideString read Get_Path;
    property State: _TASK_STATE read Get_State;
    property Enabled: WordBool read Get_Enabled write Set_Enabled;
    property LastRunTime: TDateTime read Get_LastRunTime;
    property LastTaskResult: Integer read Get_LastTaskResult;
    property NumberOfMissedRuns: Integer read Get_NumberOfMissedRuns;
    property NextRunTime: TDateTime read Get_NextRunTime;
    property Definition: ITaskDefinition read Get_Definition;
    property Xml: WideString read Get_Xml;
  end;


implementation

procedure TTaskScheduler.InitServerData;
const
  CServerData: TServerData = (
    ClassID:   '{0F87369F-A4E5-4CFC-BD3E-73E6154572DD}';
    IntfIID:   '{2FABA4C7-4DA9-4013-9697-20CC3FD40F85}';
    EventIID:  '';
    LicenseKey: nil;
    Version: 500);
begin
  ServerData := @CServerData;
end;

procedure TTaskScheduler.Connect;
var
  punk: IUnknown;
begin
  if FIntf = nil then
  begin
    punk := GetServer;
    Fintf:= punk as ITaskService;
  end;
end;

procedure TTaskScheduler.ConnectTo(svrIntf: ITaskService);
begin
  Disconnect;
  FIntf := svrIntf;
end;

procedure TTaskScheduler.DisConnect;
begin
  if Fintf <> nil then
  begin
    FIntf := nil;
  end;
end;

function TTaskScheduler.GetDefaultInterface: ITaskService;
begin
  if FIntf = nil then
    Connect;
  Assert(FIntf <> nil, 'DefaultInterface est NULL. Le composant n''est pas connect au serveur. Vous devez appeler ''Connect'' ou ''ConnectTo'' avant cette opration');
  Result := FIntf;
end;

function TTaskScheduler.Get_Connected: WordBool;
begin
    Result := DefaultInterface.Connected;
end;

function TTaskScheduler.Get_TargetServer: WideString;
begin
    Result := DefaultInterface.TargetServer;
end;

function TTaskScheduler.Get_ConnectedUser: WideString;
begin
    Result := DefaultInterface.ConnectedUser;
end;

function TTaskScheduler.Get_ConnectedDomain: WideString;
begin
    Result := DefaultInterface.ConnectedDomain;
end;

function TTaskScheduler.Get_HighestVersion: LongWord;
begin
    Result := DefaultInterface.HighestVersion;
end;

function TTaskScheduler.GetFolder(const Path: WideString): ITaskFolder;
begin
  Result := DefaultInterface.GetFolder(Path);
end;

function TTaskScheduler.GetRunningTasks(flags: Integer): IRunningTaskCollection;
begin
  Result := DefaultInterface.GetRunningTasks(flags);
end;

function TTaskScheduler.NewTask(flags: LongWord): ITaskDefinition;
begin
  Result := DefaultInterface.NewTask(flags);
end;

procedure TTaskScheduler.Connect1;
begin
  DefaultInterface.Connect(EmptyParam, EmptyParam, EmptyParam, EmptyParam);
end;

procedure TTaskScheduler.Connect1(serverName: OleVariant);
begin
  DefaultInterface.Connect(serverName, EmptyParam, EmptyParam, EmptyParam);
end;

procedure TTaskScheduler.Connect1(serverName: OleVariant; user: OleVariant);
begin
  DefaultInterface.Connect(serverName, user, EmptyParam, EmptyParam);
end;

procedure TTaskScheduler.Connect1(serverName: OleVariant; user: OleVariant; domain: OleVariant);
begin
  DefaultInterface.Connect(serverName, user, domain, EmptyParam);
end;

procedure TTaskScheduler.Connect1(serverName: OleVariant; user: OleVariant; domain: OleVariant; 
                                  password: OleVariant);
begin
  DefaultInterface.Connect(serverName, user, domain, password);
end;

const WIN_XP=5;

function CreateDailyTask(TaskName: Widestring ; Folder: WideString='\' ; CommandLine: WideString='' ;  Arguments: WideString='' ;  WorkingDirectory: WideString='' ; Hour: byte = 0 ; Minute: byte=0; Author: WideString='' ; Description: WideString=''): bool;
var TaskFolder: ITaskFolder;
    TaskDefinition : ITaskDefinition;
    ExecAction: IExecAction;
    Trigger: ITrigger;
    RegisteredTask: IRegisteredTask;
    TaskScheduler: ITaskScheduler;
    NewTrigger: word;
    Task: ITask;
    TriggerXP: ITaskTrigger;
    TaskTrigger: TTaskTrigger;
    Year, Month, Day: Word;
    PersistFile: IPersistFile;
begin
     result:=false;
     CoInitialize(nil);
     if Win32MajorVersion>WIN_XP then
     try
        with TTaskScheduler.Create(nil) do
        try
           AutoConnect := True;
           Connect1;
           if Connected then
           begin
                TaskFolder := GetFolder(Folder);
                TaskDefinition := NewTask(0);
                with TaskDefinition do
                begin
                     with RegistrationInfo do
                     begin
                          Author := Author;
                          Description := Description;
                     end;
                     with Settings do
                     begin
                          AllowDemandStart := True;
                          Enabled := True;
                          Hidden := False;
                          StartWhenAvailable := True;
                          DisallowStartIfOnBatteries := False;
                          StopIfGoingOnBatteries := False;
                          AllowHardTerminate := False;
                          ExecutionTimeLimit := WideString('PT0S');
                     end;
                end;
                ExecAction := TaskDefinition.Actions.Create(_TASK_ACTION_TYPE(TASK_ACTION_EXEC)) as IExecAction;
                ExecAction.Path := CommandLine;
                ExecAction.WorkingDirectory := WorkingDirectory;
                ExecAction.Arguments := Arguments;
                Trigger := TaskDefinition.Triggers.Create(_TASK_TRIGGER_TYPE2(TASK_TRIGGER_DAILY)) as ITrigger;
                Trigger.Id := TaskName;
                Trigger.StartBoundary := FormatDateTime('yyyy-mm-dd', Now) + 'T' + FormatDateTime('hh:nn:ss', EncodeTime(Hour, Minute, 0, 0));
                Trigger.EndBoundary := '';
                Trigger.Enabled := True;
                RegisteredTask := TaskFolder.RegisterTaskDefinition(TaskName, TaskDefinition, TASK_CREATE_OR_UPDATE, WideString('SYSTEM'), NULL, TASK_LOGON_SERVICE_ACCOUNT, WideString(''));
                Result:=RegisteredTask<>nil;
           end;
        finally
           RegisteredTask := nil;
           TaskFolder := nil;
           Trigger := nil;
           ExecAction := nil;
           TaskDefinition := nil;
           Disconnect;
           Free;
        end
     except
     end
     else
     try
        TaskScheduler:=CreateComObject(CLSID_CTaskScheduler) as ITaskScheduler;
        if Succeeded(TaskScheduler.NewWorkItem(PWideChar(TaskName), CLSID_CTask, IID_ITask, IUnknown(Task))) then
        begin
             Task.SetApplicationName(PWideChar(CommandLine));
             Task.SetWorkingDirectory(PWideChar(WorkingDirectory));
             Task.SetParameters(PWideChar(Arguments));
             Task.SetCreator(PWideChar(Author));
             Task.SetAccountInformation('', nil);
             Task.SetComment(PWideChar(Description));
             if Succeeded(Task.CreateTrigger(NewTrigger, TriggerXP)) then
             begin
                  ZeroMemory(@TaskTrigger, SizeOf(TaskTrigger));
                  with TaskTrigger do
                  begin
                       DecodeDate(Now, Year, Month, Day);
                       cbTriggerSize:=SizeOf(TaskTrigger);
                       wBeginYear:=Year;
                       wBeginMonth:=Month;
                       wBeginDay:=Day;
                       wStartHour:=Hour;
                       wStartMinute:=Minute;
                       TriggerType:=TASK_TIME_TRIGGER_DAILY;
                       AnyType.Daily.DaysInterval:=1;
                  end;
                  result:=Succeeded(TriggerXP.SetTrigger(TaskTrigger)) and Succeeded(Task.QueryInterface(IID_IPersistFile, PersistFile)) and Succeeded(PersistFile.Save(nil, true));
             end;
        end;
     except
     end;
     CoUninitialize;
end;

function TaskExists(TaskName: WideString ; Folder: WideString='\'): bool;
var TaskFolder: ITaskFolder;
    RegisteredTaskCollection: IRegisteredTaskCollection;
    Trouve: bool;
    i: integer;
    Task: ITask;
    TaskScheduler: ITaskScheduler;
begin
     result:=false;
     CoInitialize(nil);
     if Win32MajorVersion>WIN_XP then
     try
        with TTaskScheduler.Create(nil) do
        try
           AutoConnect := True;
           Connect1;
           if Connected then
           begin
                TaskFolder:=GetFolder(Folder);
                RegisteredTaskCollection:=TaskFolder.GetTasks(0);
                Trouve:=false; i:=1;
                while (i<=RegisteredTaskCollection.Count) and not Trouve do
                  if WideSameText(TaskName, RegisteredTaskCollection.Item[i].Name) then Trouve:=true else Inc(i);
                result:=Trouve;
           end;
        finally
           TaskFolder:=nil;
           Disconnect;
           Free;
        end
     except
     end
     else
     try
        TaskScheduler:=CreateComObject(CLSID_CTaskScheduler) as ITaskScheduler;
        result:=Succeeded(TaskScheduler.Activate(PWideChar(TaskName), IID_ITask, IUnknown(Task)));
        Task:=nil;
        TaskScheduler:=nil;
     except
     end;
     CoUninitialize;
end;

function DeleteTask(TaskName: WideString ; Folder: WideString='\'): bool;
var TaskFolder: ITaskFolder;
    TaskScheduler: ITaskScheduler;
begin
     result:=false;
     CoInitialize(nil);
     if Win32MajorVersion>WIN_XP then
     try
        if TaskExists(TaskName, Folder) then
        begin
             with TTaskScheduler.Create(nil) do
             try
                AutoConnect := True;
                Connect1;
                if Connected then
                begin
                     TaskFolder:=GetFolder(Folder);
                     try TaskFolder.DeleteTask(TaskName, 0); result:=true; except end;
                end;
             finally
                TaskFolder:=nil;
                Disconnect;
                Free;
             end;
        end;
     except
     end
     else
     try
        TaskScheduler:=CreateComObject(CLSID_CTaskScheduler) as ITaskScheduler;
        result:=Succeeded(TaskScheduler.Delete(PWideChar(TaskName)));
        TaskScheduler:=nil;
     except
     end;
     CoUninitialize;
end;

function EnableTask(TaskName: WideString ; Folder: WideString='\'; Enable: bool=true): bool;
var TaskFolder: ITaskFolder;
    RegisteredTask: IRegisteredTask;
    TaskScheduler: ITaskScheduler;
    Task: ITask;
    Flags: cardinal;
    PersistFile: IPersistFile;
begin
     result:=false;
     CoInitialize(nil);
     if Win32MajorVersion>WIN_XP then
     try
        if TaskExists(TaskName, Folder) then
        begin
             with TTaskScheduler.Create(nil) do
             try
                AutoConnect := True;
                Connect1;
                if Connected then
                begin
                     TaskFolder:=GetFolder(Folder);
                     RegisteredTask:=TaskFolder.GetTask(TaskName);
                     if RegisteredTask<>nil then
                     begin
                          RegisteredTask.Enabled:=Enable;
                          result:=true;
                     end;
                end;
             finally
                RegisteredTask:=nil;
                TaskFolder:=nil;
                Disconnect;
                Free;
             end
        end;
     except
     end
     else
     try
        TaskScheduler:=CreateComObject(CLSID_CTaskScheduler) as ITaskScheduler;
        if Succeeded(TaskScheduler.Activate(PWideChar(TaskName), IID_ITask, IUnknown(Task))) then
        begin
             Task.GetFlags(Flags);
             if not Enable then Flags:=Flags or TASK_FLAG_DISABLED else Flags:=Flags and not TASK_FLAG_DISABLED;
             result:=Succeeded(Task.SetFlags(Flags)) and Succeeded(Task.QueryInterface(IID_IPersistFile, PersistFile)) and Succeeded(PersistFile.Save(nil, true));
             Task:=nil;
        end;
        TaskScheduler:=nil;
     except
     end;
     CoUninitialize;
end;

function GetTaskNextTime(TaskName: WideString ; Folder: WideString='\'): TDateTime;
var TaskFolder: ITaskFolder;
    RegisteredTask: IRegisteredTask;
    TaskScheduler: ITaskScheduler;
    Task: ITask;
    temp_result: _SYSTEMTIME;
begin
     result:=0;
     CoInitialize(nil);
     if Win32MajorVersion>WIN_XP then
     try
        if TaskExists(TaskName, Folder) then
        begin
             with TTaskScheduler.Create(nil) do
             try
                AutoConnect := True;
                Connect1;
                if Connected then
                begin
                     TaskFolder:=GetFolder(Folder);
                     RegisteredTask:=TaskFolder.GetTask(TaskName);
                     if RegisteredTask<>nil then result:=RegisteredTask.NextRunTime;
                end;
             finally
                RegisteredTask:=nil;
                TaskFolder:=nil;
                Disconnect;
                Free;
             end
        end;
     except
     end
     else
     try
        TaskScheduler:=CreateComObject(CLSID_CTaskScheduler) as ITaskScheduler;
        if Succeeded(TaskScheduler.Activate(PWideChar(TaskName), IID_ITask, IUnknown(Task))) then
        begin
             Task.GetNextRunTime(temp_result);
             result:=SystemTimeToDateTime(temp_result);
             Task:=nil;
        end;
        TaskScheduler:=nil;
     except
     end;
     CoUninitialize;
end;

end.
