program UpdateSoft;

uses
  Forms,
  Windows,
  SysUtils,
  Dialogs,
  Commun,
  Math,
  Principale in 'Principale.pas' {FicheUpdateSoft},
  APropos in 'APropos.pas' {FicheAPropos},
  Fonctions in 'Fonctions.pas',
  Journal in 'Journal.pas' {FicheJournal},
  Fonctions_Flash in 'Fonctions_Flash.pas',
  Fonctions_Java in 'Fonctions_Java.pas',
  Fonctions_AIR in 'Fonctions_AIR.pas',
  Fonctions_UpdateSoft in 'Fonctions_UpdateSoft.pas',
  Fonctions_Thunderbird in 'Fonctions_Thunderbird.pas',
  Fonctions_VLC in 'Fonctions_VLC.pas',
  Fonctions_Firefox in 'Fonctions_Firefox.pas',
  Signature in 'Signature.pas',
  Attente in 'Attente.pas' {FicheAttente},
  WTSUtils in 'WTSUtils.pas',
  LsaApi in 'LsaApi.pas';

{$R *.res}
{$R Ressource.res}
{$R Ressource_VLC.res}
{$R Ressource_SERVICE.res}

type TEtat=(E_None, E_Partage, E_Script, E_Utilisateur, E_MotDePasse, E_Service_Utilisateur, E_Service_MotDePasse, E_Programmation_Heure, E_Programmation_Minute);
     TAction=(A_None, A_Install, A_Test, A_Uninstall);
var OffSet: integer;
    Partage, Script, Utilisateur, MotDePasse, Service_Utilisateur, Service_MotDePasse: string;
    Heure, Minute: shortint;
    Etat: TEtat;
    Action: TAction;
begin
     DeleteFile(ExtractFilePath(ParamStr(0))+'7za.dll');
     if SameText(ChangeFileExt(ExtractFileName(ParamStr(0)), ''), NOMAPPLI) then
     begin
          Application.Initialize;
          SetWindowText(Application.Handle, NOMAPPLI);
          if ParamCount>=1 then
          begin
               OffSet:=1; Action:=A_None; Etat:=E_None;
               Partage:=''; Script:=''; Utilisateur:=''; MotDePasse:=''; Service_Utilisateur:=''; Service_MotDePasse:='';
               Heure:=-1; Minute:=-1;
               while OffSet<=ParamCount do
               begin
                    case Etat of
                    E_None:
                    begin
                         if SameText(ParamStr(OffSet), PARAM_SERVICE_INSTALL) then begin Action:=A_Install; Etat:=E_Partage; Inc(Offset); end else
                         if SameText(ParamStr(OffSet), PARAM_SERVICE_TEST) then begin Action:=A_Test; Etat:=E_Partage; Inc(Offset); end else
                         if SameText(ParamStr(OffSet), PARAM_SERVICE_UNINSTALL) then begin Action:=A_Uninstall; OffSet:=ParamCount+1 end else OffSet:=ParamCount+1;
                    end;
                    E_Partage:
                    begin
                         Partage:=ParamStr(OffSet);
                         Inc(OffSet);
                         Etat:=E_Script;
                    end;
                    E_Script:
                    begin
                         Script:=ParamStr(OffSet);
                         Inc(OffSet);
                         Etat:=E_Utilisateur;
                    end;
                    E_Utilisateur:
                    begin
                         if SameText(ParamStr(OffSet), PARAM_SERVICE_CONTEXT) then Etat:=E_Service_Utilisateur
                         else
                         if SameText(ParamStr(OffSet), PARAM_PROGRAMMATION) then Etat:=E_Programmation_Heure
                         else
                         begin
                              Utilisateur:=ParamStr(OffSet);
                              Inc(OffSet);
                              Etat:=E_MotDePasse;
                         end;
                    end;
                    E_MotDePasse:
                    begin
                         if SameText(ParamStr(OffSet), PARAM_SERVICE_CONTEXT) then Etat:=E_Service_Utilisateur
                         else
                         if SameText(ParamStr(OffSet), PARAM_PROGRAMMATION) then Etat:=E_Programmation_Heure
                         else
                         begin
                              MotDePasse:=ParamStr(OffSet);
                              Inc(OffSet);
                              Etat:=E_Service_Utilisateur;
                         end;
                    end;
                    E_Service_Utilisateur:
                    begin
                         if SameText(ParamStr(OffSet), PARAM_SERVICE_CONTEXT) then Inc(OffSet)
                         else
                         if SameText(ParamStr(OffSet), PARAM_PROGRAMMATION) then Etat:=E_Programmation_Heure
                         else
                         begin
                              Service_Utilisateur:=ParamStr(OffSet);
                              Inc(OffSet);
                              Etat:=E_Service_MotDePasse;
                         end;
                    end;
                    E_Service_MotDePasse:
                    begin
                         if SameText(ParamStr(OffSet), PARAM_PROGRAMMATION) then Etat:=E_Programmation_Heure
                         else
                         begin
                              Service_MotDePasse:=ParamStr(OffSet);
                              Inc(OffSet);
                              Etat:=E_Programmation_Heure;
                         end;
                    end;
                    E_Programmation_Heure:
                    begin
                         if SameText(ParamStr(OffSet), PARAM_PROGRAMMATION) then Inc(OffSet)
                         else
                         begin
                              Heure:=StrToIntDef(ParamStr(OffSet), -1);
                              Inc(OffSet);
                              Etat:=E_Programmation_Minute;
                         end;
                    end;
                    E_Programmation_Minute:
                    begin
                         Minute:=StrToIntDef(ParamStr(OffSet), -1);
                         OffSet:=ParamCount+1;
                    end;
                    end;
               end;

               case Action of
               // Installation du service
               A_Install:
               begin
                    InstallerService(Mode_Installation, Partage, Script, Utilisateur, MotDePasse, Service_Utilisateur, Service_MotDePasse);
                    if InRange(Heure, 0, 23) and InRange(Minute, 0, 59) then CreerTachePlanifiee(EncodeTime(Heure, Minute, 0, 0)) else SupprimerTachePlanifiee
               end;
               // Test du service
               A_Test: InstallerService(Mode_Test, Partage, Script, Utilisateur, MotDePasse, Service_Utilisateur, Service_MotDePasse);
               // Dsinstallation du service
               A_Uninstall: InstallerService(Mode_Desinstallation);
               // Excution des scripts
               A_None:
               if not DejaLance then
               begin
                    Application.CreateForm(TFicheJournal, FicheJournal);
  Application.CreateForm(TFicheAPropos, FicheAPropos);
  Application.Run;
               end;
               end;
          end
          else
          begin
               // Lancement normal
               Application.CreateForm(TFicheUpdateSoft, FicheUpdateSoft);
               Application.CreateForm(TFicheAttente, FicheAttente);
               Application.CreateForm(TFicheAPropos, FicheAPropos);
               Application.Run;
          end;
     end
     else MessageDlg(#13'L''excutable doit se nommer "'+NOMAPPLI+'.exe" pour fonctionner.', mtError, [mbOK], 0);
end.
