unit UniteService;

interface

{$WARN SYMBOL_PLATFORM OFF}

//{$DEFINE DEBUG_MODE} // Active la cration d'un fichier de dbogage Debug.txt

uses SvcMgr, Windows, Messages, SysUtils, Registry, Commun, WinCred, WinSvc, TaskScheduler, Signature, Classes, ShellAPI;

type TMode = (Mode_Test, Mode_Installation, Mode_Desinstallation, Mode_Normal);
     TLogMessage=(LOG_UNUSED, LOG_START, LOG_STOP, LOG_NETWORK, LOG_FILENOTFOUND, LOG_CREDENTIALS, LOG_TESTOK);
     TUpdateSoft = class(TService)
       procedure ServiceCreate(Sender: TObject);
       procedure ServiceExecute(Sender: TService);
       procedure ServiceStart(Sender: TService; var Started: Boolean);
       procedure ServiceStop(Sender: TService; var Stopped: Boolean);
       function FindCmdLineSwitchValue(Switch: string; const Chars: TSysCharSet; IgnoreCase: Boolean): string;
       function FindCmdLineSwitch(Switch: string; const Chars: TSysCharSet; IgnoreCase: Boolean): integer;
       function FindSwitch(const Switch: string): bool;
       function FindSwitchValue(const Switch: string): string;
     public
       Mode: TMode;
       Host, Folder, Script, User: string;
       function GetServiceController: TServiceController; override;
       function ConnectDrive: DWORD;
       function DisconnectDrive: DWORD;
       procedure LireConfiguration;
       procedure EcrireConfiguration(WriteTag: bool=false);
       procedure Log(Valeur: TLogMessage ; Complement: string ='' ; LogInRegistryIfTestMode: bool=false);
       function GetPassword: PChar;
     end;

var UpdateSoft: TUpdateSoft;

const LOG_MESSAGE :
      array[LOG_START..LOG_TESTOK] of string=
          (
            'Dmarrage du service.',
            'Arrt du service.',
            'Ressource rseau inaccessible : %s',
            'Fichier inaccessible : %s',
            'Le gestionnaire d''identification n''est pas fonctionnel sur le compte %s de votre systme d''exploitation : les informations d''identification ne pourront pas tre conserves.'#13#13+'Modifiez les informations de contexte de lancement.',
            'OK'
          );

implementation

uses StrUtils, ComObj;

var MiseAJourService: bool=false;

const SERVICE_MESSAGE_KEY ='\SYSTEM\CurrentControlSet\Services\Eventlog\Application\'+NOMAPPLI;
      SERVICE_UNINSTALL_KEY='\Software\Microsoft\Windows\CurrentVersion\Uninstall\'+NOMAPPLI;
var ConnectDriveResult: cardinal=0;
    ProcHandle: cardinal=0;

{$R *.DFM}

procedure EcrireDebug(Message: string);
{$IFDEF DEBUG_MODE}
var F: TextFile;
{$ENDIF}
begin
{$IFDEF DEBUG_MODE}
     AssignFile(F, ExtractFilePath(ParamStr(0))+'Debug.txt');
     if not FileExists(ExtractFilePath(ParamStr(0))+'Debug.txt') then Rewrite(F) else Append(F);
     Writeln(F, Message);
     CloseFile(F);
{$ENDIF}
end;

// Renvoie le nom de l'utilisateur courant
function NomUtilisateur:string;
var Buffer : array[0..255] of char; BufferSize : DWORD;
begin BufferSize := sizeOf(Buffer); GetUserName(@buffer, BufferSize); Result:=Buffer; if Result='' then Result:='SYSTEM'; end;

// Cre l'entre de registre afin de voir correctement les messages dans le journal d'vnements
procedure TraceMessagesByRegistry;
begin
     try
        with TRegistry.Create(KEY_READ or KEY_WRITE) do
        try
           RootKey := HKEY_LOCAL_MACHINE;
           if OpenKey(SERVICE_MESSAGE_KEY, true) then
           begin
                WriteString('EventMessageFile', ParamStr(0));
                WriteInteger('TypesSupported', 7);
                CloseKey;
           end;
        finally
           Free;
        end;
     except
     end;
end;

function ReadHost(FileName: TFileName): string;
var i: integer;
begin
     result:='';
     if Copy(FileName, 1, 2)=PathDelim+PathDelim then
     begin
          i:=PosEx(PathDelim, FileName, 3)-3;
          if i<=0 then i:=MAXINT; result:=Copy(FileName, 3, i);
     end;
end;

function ReadTarget(FileName: TFileName): string;
var i: integer;
begin
     result:='';
     if Copy(FileName, 1, 2)=PathDelim+PathDelim then
     begin
          i:=PosEx(PathDelim, FileName, 3);
          if i>0 then i:=PosEx(PathDelim, FileName, i+1);
          if i<=0 then i:=MAXINT; result:=ExcludeTrailingPathDelimiter(Copy(FileName, 1, i));
     end;
end;

procedure MettreAJourService;
function OEM(AsciiString: string): string;
begin
    result:=AsciiString;
    CharToOEM(PChar(AsciiString), PChar(result));
end;
var batchfile: TStringList;
    i: integer;
    batchname: string;
begin
     i:=0;
     repeat
           if i=0 then batchname:=RenvoiDossierTemp+ChangeFileExt(ExtractFileName(ParamStr(0)),'.bat')
           else batchname:=RenvoiDossierTemp+ChangeFileExt(ExtractFileName(ParamStr(0)),' ('+inttostr(i)+').bat');
           Inc(i);
     until not FileExists(batchname);
     FileSetAttr(ParamStr(0), 0);
     batchfile := TStringList.Create;
     with batchfile do
     try
        Add(':Label0');
        Add('del "' + Oem(ParamStr(0)) + '"');
        Add('if exist "' + Oem(ParamStr(0)) + '" goto Label0');
        Add('rename "'+Oem(ChangeFileExt(ParamStr(0), '.tmp')) +'" "'+ Oem(ExtractFileName(ParamStr(0)))+'"');
        Add('net start '+NOMAPPLI);
        Add('del "' + Oem(batchname)+'"');
        SaveToFile(batchname);
     finally
        batchfile.Free;
     end;
     ShellExecute(0, 'open', PChar(batchname), nil, PChar(ExtractFilePath(batchname)), SW_HIDE);
     MiseAJourService:=true;
end;

procedure ServiceController(CtrlCode: DWord); stdcall;
begin UpdateSoft.Controller(CtrlCode); end;

function TUpdateSoft.GetServiceController: TServiceController;
begin Result := ServiceController; end;

function TUpdateSoft.FindCmdLineSwitch(Switch: string; const Chars: TSysCharSet; IgnoreCase: Boolean): integer;
var I: Integer;
    S: string;
begin
     if Switch[1] in Chars then Switch:=Copy(Switch, 2, MAXINT);
     for I := 1 to ParamCount-1 do
     begin
          S := Param[I];
          if Pos(':', S)>0 then S:=Copy(S, 1, Pos(':', S)-1);
       if (Chars = []) or (S[1] in Chars) then
         if IgnoreCase then
         begin
           if (AnsiCompareText(Copy(S, 2, MAXINT), Switch) = 0) then
           begin
             Result := i;
             Exit;
           end;
         end
         else begin
           if (AnsiCompareStr(Copy(S, 2, MAXINT), Switch) = 0) then
           begin
             Result := i;
             Exit;
           end;
         end;
     end;
     Result := 0;
end;

function TUpdateSoft.FindCmdLineSwitchValue(Switch: string; const Chars: TSysCharSet; IgnoreCase: Boolean): string;
var I: Integer;
    S: string;
    SwitchName, SwitchValue: string;
begin
     if Switch[1] in Chars then Switch:=Copy(Switch, 2, MAXINT);
     for I := 1 to ParamCount-1 do
     begin
          S := Param[I];
          if (Chars = []) or (S[1] in Chars) then
          begin
               S:=Copy(S, 2, MAXINT);
               if Pos(':', S)=0 then
               begin
                    SwitchName:=S;
                    SwitchValue:='';
               end
               else
               begin
                    SwitchName:=Copy(S, 1, Pos(':', S)-1);
                    SwitchValue:=Copy(S, Pos(':', S)+1, MAXINT);
               end;
               if IgnoreCase then
               begin
                    if (AnsiCompareText(SwitchName, Switch) = 0) then
                    begin
                         Result := SwitchValue;
                         Exit;
                    end;
               end
               else
               begin
                    if (AnsiCompareStr(SwitchName, Switch) = 0) then
                    begin
                         Result := SwitchValue;
                         Exit;
                    end;
               end;
          end;
     end;
     Result := '';
end;

function TUpdateSoft.FindSwitch(const Switch: string): bool; begin Result := FindCmdLineSwitch(Switch, ['-', '/'], True)>0; end;

function TUpdateSoft.FindSwitchValue(const Switch: string): string; begin Result := FindCmdLineSwitchValue(Switch, ['-', '/'], True); end;

function TUpdateSoft.DisconnectDrive: DWORD;
begin if Host<>'' then result := WNetCancelConnection2(PChar(Host), CONNECT_UPDATE_PROFILE, true) else result:=NO_ERROR; end;

function TUpdateSoft.ConnectDrive: DWORD;
var nRes: TNetResource;
begin
     if Host<>'' then
     begin
          FillChar(NRes, SizeOf(NRes), #0);
          nRes.dwType := RESOURCETYPE_DISK;
          nRes.dwDisplayType:=RESOURCEDISPLAYTYPE_SHARE;
          nRes.lpLocalName := nil;
          nRes.lpProvider:=nil;
          nRes.lpRemoteName := PChar(ReadTarget(Folder));
          result:=WNetAddConnection2(nRes, nil, nil, CONNECT_TEMPORARY);
     end
     else result:=NO_ERROR;
end;

procedure TUpdateSoft.LireConfiguration;
begin
     Folder:=''; Script:=''; User:='';
     with TRegistry.Create do
     try
        Rootkey:=HKEY_LOCAL_MACHINE;
        if OpenKey(SERVICE_CONFIGURATION_KEY, false) then
        begin Folder:=ExtractFilePath(ReadString('Folder')); Script:=ReadString('Script'); User:=ReadString('User'); end;
        Free;
     except
     end;
     Host:=ReadHost(Folder);
end;

procedure TUpdateSoft.EcrireConfiguration(WriteTag: bool=false);
begin
     with TRegistry.Create do
     try
        Rootkey:=HKEY_LOCAL_MACHINE;
        if WriteTag then OpenKey(SERVICE_APPLICATION_KEY, true)
        else
        if OpenKey(SERVICE_CONFIGURATION_KEY, true) then
        begin WriteString('Folder', ExtractFilePath(Folder)); WriteString('Script', Script); WriteString('User', User); end;
        Free;
     except
     end;
     Host:=ReadHost(Folder);
end;

function TUpdateSoft.GetPassword: PChar;
var Chaine: string;
begin
     if Mode in [Mode_Installation, Mode_Test] then
     begin
          Chaine:=FindSwitchValue(PARAM_SERVICE_PASSWORD);
          result:=PChar(Chaine);
     end
     else result:=nil;
end;

procedure TUpdateSoft.ServiceCreate(Sender: TObject);
var ServiceControlManager: SC_Handle;
    Status: _SERVICE_STATUS;
    ServiceHandle: SC_Handle;
    Args: array of PAnsiChar;
    FichierEXE: string;
    procedure WaitForServiceStop(Duration: cardinal=0);
    var TickCount: cardinal;
    begin
         TickCount:=GetTickCount;
         repeat
              ControlService(ServiceHandle, SERVICE_CONTROL_STOP, Status);
         until (Status.dwCurrentState=SERVICE_STOPPED) or ((Duration<>0) and (GetTickCount-TickCount>Duration));
    end;
begin
     if SameText(System.ParamStr(1), PARAM_SERVICE_UNINSTALL) then
     begin
          ServiceControlManager:=OpenSCManager('', nil, STANDARD_RIGHTS_REQUIRED or SC_MANAGER_CREATE_SERVICE);
          ServiceHandle:=OpenService(ServiceControlManager, NOMAPPLI, SERVICE_ALL_ACCESS);
          if ServiceHandle<>0 then
          begin
               Setlength(Args, 1);
               Args[0]:=PChar(PARAM_SERVICE_UNINSTALL);
               StartService(ServiceHandle, length(Args), Args[0]);
               Finalize(Args);
               WaitForServiceStop(30000);
               DeleteService(ServiceHandle);
               CloseServiceHandle(ServiceHandle);
          end;
          CloseServiceHandle(ServiceControlManager);
          try
             with TRegistry.Create(KEY_READ or KEY_WRITE) do
             try
                RootKey := HKEY_LOCAL_MACHINE;
                if KeyExists(SERVICE_UNINSTALL_KEY) then DeleteKey(SERVICE_UNINSTALL_KEY);
             finally
                Free;
             end;
          except
          end;
          EffacerExecutable([ChangeFileExt(ParamStr(0), '.tmp')]);
     end
     else
     begin
          TraceMessagesByRegistry;
          Mode:=Mode_Normal;
          LireConfiguration;
          FichierEXE:=ChangeFileExt(ParamStr(0), '.tmp');
          if FileExists(FichierEXE) and IsCompanySigningCertificate(FichierEXE, APP_PUBLISHER) and (CompareVersion(GetVersion(FichierEXE), GetVersion(ParamStr(0)))>0) then MettreAJourService;
     end;
end;

procedure TUpdateSoft.ServiceStart(Sender: TService; var Started: Boolean);
var FichierEXE: string;
    Max: cardinal;
begin
     if not MiseAJourService then
     begin
          Log(LOG_START);
          if FindSwitch(PARAM_SERVICE_UNINSTALL) then Mode:=Mode_Desinstallation
          else
          if (FindSwitch(PARAM_SERVICE_INSTALL) or FindSwitch(PARAM_SERVICE_TEST)) and FindSwitch(PARAM_SERVICE_FOLDER) and FindSwitch(PARAM_SERVICE_SCRIPT) and FindSwitch(PARAM_SERVICE_USER) and FindSwitch(PARAM_SERVICE_PASSWORD) then
          begin
               // Test ou Installation du service
               Folder:=ExtractFilePath(FindSwitchValue(PARAM_SERVICE_FOLDER));
               Script:=FindSwitchValue(PARAM_SERVICE_SCRIPT);
               User:=FindSwitchValue(PARAM_SERVICE_USER);

               if FindSwitch(PARAM_SERVICE_TEST) then
               begin
                    EcrireDebug('Mode test');
                    EcrireConfiguration(true);
                    Mode:=Mode_Test;
               end
               else
               begin
                    EcrireDebug('Mode installation');
                    try
                       with TRegistry.Create(KEY_READ or KEY_WRITE) do
                       try
                          RootKey := HKEY_LOCAL_MACHINE;
                          if OpenKey(SERVICE_CONFIGURATION_KEY, true) and not ValueExists('Description') then
                          begin
                               WriteString('Description', 'Ce service gre le lancement des mises  jour d''UpdateSoft.');
                               CloseKey;
                          end;
                          if FindSwitch(PARAM_SERVICE_INSTALL) and not KeyExists(SERVICE_UNINSTALL_KEY) and OpenKey(SERVICE_UNINSTALL_KEY,true) then
                          begin
                               DeleteValue('DisplayIcon');
                               WriteString('DisplayIcon', ParamStr(0));
                               DeleteValue('EstimatedSize');
                               WriteInteger('EstimatedSize', TailleFichier(ParamStr(0)) div 1024);
                               DeleteValue('InstallLocation');
                               WriteString('InstallLocation',ExtractFilePath(ParamStr(0)));
                               DeleteValue('DisplayVersion');
                               WriteString('DisplayVersion',GetVersion(ParamStr(0)));
                               DeleteValue('DisplayName');
                               WriteString('DisplayName',NOMAPPLI);
                               DeleteValue('UninstallString');
                               WriteString('UninstallString','"'+ParamStr(0)+'" /U');
                               DeleteValue('Publisher');
                               WriteString('Publisher', APP_PUBLISHER);
                               CloseKey;
                          end;
                       finally
                          Free;
                       end;
                    except
                    end;
                    CredDeleteCredentials(WideString(Host));
                    EcrireConfiguration;
                    CredWriteCredentials(WideString(Host), WideString(FindSwitchValue(PARAM_SERVICE_USER)), WideString(FindSwitchValue(PARAM_SERVICE_PASSWORD)));
                    Mode:=Mode_Installation;
               end;
          end;
          case Mode of
          Mode_Test:
          begin
               CredGetMaxPersistType(CRED_TYPE_DOMAIN_PASSWORD, Max);
               if (Host<>'') and (User<>'') and (FindSwitchValue(PARAM_SERVICE_PASSWORD)<>'') and (Max=0) then Log(LOG_CREDENTIALS, NomUtilisateur, true)
               else
               begin
                    EcrireDebug('Lecture des fichiers...');
                    CredDeleteCredentials(WideString(Host));
                    CredWriteCredentials(WideString(Host), WideString(FindSwitchValue(PARAM_SERVICE_USER)), WideString(FindSwitchValue(PARAM_SERVICE_PASSWORD)));
                    ConnectDriveResult:=ConnectDrive;
                    if (ConnectDriveResult=NO_ERROR) or FileExists(Folder+EXECUTABLE) then if FileExists(Folder+EXECUTABLE) then if FileExists(Script) then Log(LOG_TESTOK, '', true)
                                                                                                                                                       else Log(LOG_FILENOTFOUND, Script, true)
                                                                                                                            else Log(LOG_FILENOTFOUND, Folder+EXECUTABLE, true)
                                                                                      else Log(LOG_NETWORK, ReadTarget(Folder)+' - '+SysErrorMessage(ConnectDriveResult)+' (Code : '+inttostr(ConnectDriveResult)+')', true);
                    if ConnectDriveResult<>0 then DisconnectDrive;
                    CredDeleteCredentials(WideString(Host));
               end;
               ConnectDriveResult:=0;
          end;
          Mode_Normal:
          begin
               EcrireDebug('Mode normal');
               try
                  with TRegistry.Create(KEY_READ or KEY_WRITE) do
                  try
                     RootKey := HKEY_LOCAL_MACHINE;
                     if OpenKey(SERVICE_UNINSTALL_KEY,true) then
                     begin
                          if not (ValueExists('EstimatedSize') and (GetDataType('EstimatedSize')=rdInteger) and (cardinal(ReadInteger('EstimatedSize'))=TailleFichier(ParamStr(0)) div 1024)) then
                          begin
                               DeleteValue('EstimatedSize');
                               WriteInteger('EstimatedSize', TailleFichier(ParamStr(0)) div 1024);
                          end;
                          if not (ValueExists('DisplayVersion') and (GetDataType('DisplayVersion')=rdString) and (ReadString('DisplayVersion')=GetVersion(ParamStr(0)))) then
                          begin
                               DeleteValue('DisplayVersion');
                               WriteString('DisplayVersion',GetVersion(ParamStr(0)));
                          end;
                     end;
                     CloseKey;
                  finally
                     Free;
                  end;
               except
               end;
               ConnectDriveResult:=ConnectDrive;
               if (ConnectDriveResult=NO_ERROR) or FileExists(Folder+EXECUTABLE) then
                   if FileExists(Folder+EXECUTABLE) then
                       if FileExists(Script) then
                       begin
                            FichierEXE:=Folder+EXECUTABLE+'.temp';
                            if FileExists(FichierEXE) then
                            begin
                                 if IsCompanySigningCertificate(FichierEXE, APP_PUBLISHER) and (CompareVersion(GetVersion(FichierEXE), GetVersion(Folder+EXECUTABLE))>0) then
                                 begin
                                      EffacerFichier(Folder+EXECUTABLE);
                                      CopierFichier(FichierEXE, Folder+EXECUTABLE);
                                 end;
                                 EffacerFichier(FichierEXE);
                            end;
                            ProcHandle:=LanceAppli(AnsiQuotedStr(Folder+EXECUTABLE, '"')+' '+AnsiQuotedStr(Script, '"'), Folder)
                       end
                       else Log(LOG_FILENOTFOUND, Script)
                   else Log(LOG_FILENOTFOUND, Folder+EXECUTABLE)
               else Log(LOG_NETWORK, ReadTarget(Folder)+' - '+SysErrorMessage(ConnectDriveResult)+' (Code : '+inttostr(ConnectDriveResult)+')');
               if ProcHandle=0 then
               begin
                    if ConnectDriveResult<>0 then DisconnectDrive;
                    ConnectDriveResult:=0;
               end;
          end;
          Mode_Desinstallation:
          begin
               EcrireDebug('Mode dsinstallation');
               DeleteTask(NOMAPPLI);
               CredDeleteCredentials(WideString(Host));
               // Supprime l'entre du registre permettant de voir les messages dans le journal d'vnements
               try
                  with TRegistry.Create(KEY_READ or KEY_WRITE) do
                  try
                     RootKey := HKEY_LOCAL_MACHINE;
                     if KeyExists(SERVICE_MESSAGE_KEY) then DeleteKey(SERVICE_MESSAGE_KEY);
                  finally
                     Free;
                  end;
               except
               end;
          end;
          end;
     end;
end;

procedure TUpdateSoft.ServiceStop(Sender: TService; var Stopped: Boolean);
begin if not MiseAJourService then Log(LOG_STOP); end;

procedure TUpdateSoft.ServiceExecute(Sender: TService);
begin
     while not Terminated do
     try
        Sleep(20); ServiceThread.ProcessRequests(False);
        if (ProcHandle<>0) and (WaitForSingleObject(ProcHandle, 0)=WAIT_OBJECT_0) then ProcHandle:=0;
        if ProcHandle=0 then DoStop;
     except end;
     if ConnectDriveResult<>0 then DisconnectDrive;
     ConnectDriveResult:=0;
end;

procedure TUpdateSoft.Log(Valeur: TLogMessage ; Complement: string ='' ; LogInRegistryIfTestMode: bool=false);
var Chaine: string;
    Level: cardinal;
begin
     try
        if (Valeur>=Low(LOG_MESSAGE)) and (Valeur<=High(LOG_MESSAGE)) then
        begin
             Chaine:=LOG_MESSAGE[Valeur];
             if Valeur in [LOG_START, LOG_STOP] then Level:=EVENTLOG_INFORMATION_TYPE else Level:=EVENTLOG_ERROR_TYPE;
             if Pos('%s', Chaine)>0 then Chaine:=Format(Chaine, [Complement]);
             if (Mode=Mode_Test) and LogInRegistryIfTestMode then
             with TRegistry.Create(KEY_READ or KEY_WRITE) do
             try
                RootKey := HKEY_LOCAL_MACHINE;
                if OpenKey(SERVICE_APPLICATION_KEY, true) then WriteString('', Chaine);
             finally
                Free;
             end
             else LogMessage(Chaine, Level, 0, integer(Valeur));
        end;
     except end;
end;

end.
